# CGcoefficient.jl

[![License](http://img.shields.io/badge/license-MIT-brightgreen.svg?style=flat)](LICENSE)
[![CI](https://github.com/0382/CGcoefficient.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/0382/CGcoefficient.jl/actions/workflows/CI.yml)
[![codecov.io](https://codecov.io/gh/0382/CGcoefficient.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/0382/CGcoefficient.jl)
[![](https://img.shields.io/badge/docs-dev-blue.svg)](https://0382.github.io/CGcoefficient.jl/dev)

[[English](README.md)]

计算CG系数，Racah系数，Wigner 3j, 6j, 9j系数，Moshinsky系数等。

你可以使用定义的`SqrtRational`类型以保存准确结果，它内部使用`BigInt`计算以避免溢出。同时我们也提供浮点数运算的快速版本，比[GNU Scientific Library](https://www.gnu.org/software/gsl/)快好几倍。

我也用c++重写了浮点数版本，用于数值计算：[WignerSymbol](https://github.com/0382/WignerSymbol).

关于更多更多细节以及计算公式，请看文档[![](https://img.shields.io/badge/docs-dev-blue.svg)](https://0382.github.io/CGcoefficient.jl/dev)。

### 安装

使用julia REPL安装即可
```julia-repl
julia> ]
pkg> add CGcoefficient
```

### 示例

```julia-repl
julia> CG(1,2,3,1,1,2)
√(2//3)

julia> nineJ(1,2,3,4,5,6,3,6,9)
1//1274√(3//5)

julia> f6j(6,6,6,6,6,6)
-0.07142857142857142
```

更多示例请看文档。

### 函数列表

这个包提供两类函数。

1. 精确函数。返回`SqrtRational`；这类函数主要是为了演示，内部使用`BigInt`进行计算，不需要缓存，计算速度相对较慢。
2. 浮点数函数。返回双精度浮点数；这类函数主要是为了数值计算，内部使用`Float64`进行计算。在使用之前，你需要先调用[`wigner_init_float`](https://0382.github.io/CGcoefficient.jl/stable/api/#CGcoefficient.wigner_init_float)来预先计算二项式系数表并缓存这个表，用于后面的计算。当角动量量子数非常大的时候，它们可能会由于浮点数计算产生一些误差。对于误差的分析详见：[wigner-benchmark](https://github.com/0382/wigner-benchmark)。

#### 精确函数

精确函数仅用于演示，其中一些可以是`Real`参数，比如`1, 3//2, 0.5`，但是`4//3, 0.6`会报错。

- `CG(j1, j2, j3, m1, m2, m3)`, CG系数，参数是均为`Real`。
- `CG0(j1, j2, j3)`, CG系数特殊情况`m1 = m2 = m3 = 0`，此时当然角动量是整数才有意义。
- `threeJ(j1, j2, j3, m1, m2, m3)`, Wigner 3j系数，参数均为`Real`。
- `sixJ(j1, j2, j3, j4, j5, j6)`, Wigner 6j系数，参数均为`Real`。
- `Racah(j1, j2, j3, j4, j5, j6)`, Racah系数，参数均为`Real`。
- `nineJ(j1, j2, j3, j4, j5, j6, j7, j8, j9)`, Wigner 9j系数，参数均为`Real`。
- `norm9J(j2, j3, j4, j5, j5, j6, j7, j8, j9)`, normalized 9j系数，参数均为`Real`。
- `lsjj(l1, l2, j1, j2, L, S, J)`, LS耦合到jj耦合的转换系数，它实际上等于一个normalized 9j系数，但更易于使用且更快。`j1, j2`是`Real`，其余必须是整数。
- `Moshinsky(N, L, n, l, n1, l1, n2, l2, Λ, D)`, Moshinsky括号，量子数都是整数，`D`是有理数，默认为`1`。

#### 浮点数函数

对于数值计算而言，为了效率我们避免使用分数类型，如果某个参数可能是半整数，函数的则使用两倍的角动量量子数作为参数，以此避免半整数。在形参命名中，如果某个参数接受两倍的角动量，那么会有一个`d`前缀。

- `fCG(dj1, dj2, dj3, dm1, dm2, dm3)`, CG系数
- `fCG0(j1, j2, j3)`, CG系数特殊情况`m1 = m2 = m3 = 0`。
- `fCGspin(ds1, ds2, S)`, 快速计算两个1/2自旋的CG系数。
- `fCG3spin(ds1, ds2, ds3, S12, dS)`, 快速计算 `<S12,M12|1/2,m1;1/2,m2><S,M|S12,M12;1/2,m3>`.
- `f3j(dj1, dj2, dj3, dm1, dm2, dm3)`, Wigner 3j系数。
- `f6j(dj1, dj2, dj3, dj4, dj5, dj6)`, Wigner 6j系数。
- `fRacah(dj1, dj2, dj3, dj4, dj5, dj6)`, Racah系数。
- `f9j(dj1, dj2, dj3, dj4, dj5, dj6, dj7, dj8, dj9)`, Wigner 9j系数。
- `fnorm9j(dj1, dj2, dj3, dj4, dj5, dj6, dj7, dj8, dj9)`, normalized 9j系数。
- `flsjj(l1, l2, dj1, dj2, L, S, J)`, LS耦合到jj耦合的转换系数。
- `fMoshinsky(N, L, n, l, n1, l1, n2, l2, Λ)`, oshinsky括号。
- `dfunc(dj, dm1, dm2, β)`, Wigner d 函数。


### 参考资料

- [https://github.com/ManyBodyPhysics/CENS](https://github.com/ManyBodyPhysics/CENS)
- D. A. Varshalovich, A. N. Moskalev and V. K. Khersonskii, *Quantum Theory of Angular Momentum*, (World Scientific, 1988).
- Buck et al. Nuc. Phys. A 600 (1996) 387-402.
- H. T. Johansson and C. Forssén, Fast and Accurate Evaluation of Wigner 3$j$, 6$j$, and 9$j$ Symbols Using Prime Factorization and Multiword Integer Arithmetic, SIAM J. Sci. Comput. 38, A376 (2016).

# CGcoefficient.jl

[![License](http://img.shields.io/badge/license-MIT-brightgreen.svg?style=flat)](LICENSE)
[![CI](https://github.com/0382/CGcoefficient.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/0382/CGcoefficient.jl/actions/workflows/CI.yml)
[![codecov.io](https://codecov.io/gh/0382/CGcoefficient.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/0382/CGcoefficient.jl)
[![](https://img.shields.io/badge/docs-dev-blue.svg)](https://0382.github.io/CGcoefficient.jl/dev)

[[中文](README_zh.md)]

A package to calculate CG-coefficient, Racah coefficient, Wigner 3j, 6j, 9j symbols and Moshinsky brakets.

One can get the exact result with `SqrtRational` type, which use `BigInt` to avoid overflow. And we also offer float version for numeric calculation, which is several times faster than [GNU Scientific Library](https://www.gnu.org/software/gsl/).

I also rewrite the float version with c++ for numeric calculation: [WignerSymbol](https://github.com/0382/WignerSymbol).

For more details and the calculation formula, please see the document [![](https://img.shields.io/badge/docs-dev-blue.svg)](https://0382.github.io/CGcoefficient.jl/dev).

### Install

Just start a Julia REPL, and install it
```julia-repl
julia> ]
pkg> add CGcoefficient
```

### Example

```julia-repl
julia> CG(1,2,3,1,1,2)
√(2//3)

julia> nineJ(1,2,3,4,5,6,3,6,9)
1//1274√(3//5)

julia> f6j(6,6,6,6,6,6)
-0.07142857142857142
```

For more examples please see the document.

### API

This package contains two types of functions:

1. The exact functions return `SqrtRational`, which are designed for demonstration. They use `BigInt` in the internal calculation, and do not cache the binomial table, so they are not efficient.
2. The floating-point functions return `Float64`, which are designed for numeric calculation. They use `Int, Float64` in the internal calculation, and you should pre-call [`wigner_init_float`](https://0382.github.io/CGcoefficient.jl/stable/api/#CGcoefficient.wigner_init_float) to calculate and cache the binomial table for later calculation. They may give inaccurate result for vary large angular momentum, due to floating-point arithmetic. You can find the max error at here: [wigner-benchmark](https://github.com/0382/wigner-benchmark).

#### Exact functions

Exact function only for demonstration, some of them can be `Real` arguments, like `1, 3//2, 0.5`, but `4//3, 0.6` will throw error.

- `CG(j1, j2, j3, m1, m2, m3)`, CG-coefficient, `Real` arguments.
- `CG0(j1, j2, j3)`, CG-coefficient for `m1 = m2 = m3 = 0`, only integer angular momentum number is meaningful.
- `threeJ(j1, j2, j3, m1, m2, m3)`, Wigner 3j-symbol, `Real` arguments.
- `sixJ(j1, j2, j3, j4, j5, j6)`, Wigner 6j-symbol, `Real` arguments.
- `Racah(j1, j2, j3, j4, j5, j6)`, Racah coefficient, `Real` arguments.
- `nineJ(j1, j2, j3, j4, j5, j6, j7, j8, j9)`, Wigner 9j-symbol, `Real` arguments.
- `norm9J(j2, j3, j4, j5, j5, j6, j7, j8, j9)`, normalized 9j-symbol, `Real` arguments.
- `lsjj(l1, l2, j1, j2, L, S, J)`, LS-coupling to jj-coupling transform coefficient. It actually equals to a normalized 9j-symbol, but easy to use and faster. `j1, j2` can be `Real`.
- `Moshinsky(N, L, n, l, n1, l1, n2, l2, Λ, D)`, Moshinsky brakets, `Integer` arguments, except `D` is a rational (default is `1`).

#### Float functions

For faster numeric calculation, if the angular momentum number can be half-integer, the argument of the functions is actually double of the number. In this way, all arguments can be integers. In this package, the doubled arguments are named starts with `d`.

- `fCG(dj1, dj2, dj3, dm1, dm2, dm3)`, CG-coefficient.
- `fCG0(j1, j2, j3)`, CG-coefficient for `m1 = m2 = m3 = 0`.
- `fCGspin(ds1, ds2, S)`, quicker CG-coefficient for two spin-1/2 coupling.
- `fCG3spin(ds1, ds2, ds3, S12, dS)`, quickly evaluate `<S12,M12|1/2,m1;1/2,m2><S,M|S12,M12;1/2,m3>`.
- `f3j(dj1, dj2, dj3, dm1, dm2, dm3)`, Wigner 3j-symbol.
- `f6j(dj1, dj2, dj3, dj4, dj5, dj6)`, Wigner 6j-symbol.
- `fRacah(dj1, dj2, dj3, dj4, dj5, dj6)`, Racah coefficient.
- `f9j(dj1, dj2, dj3, dj4, dj5, dj6, dj7, dj8, dj9)`, Wigner 9j-symbol.
- `fnorm9j(dj1, dj2, dj3, dj4, dj5, dj6, dj7, dj8, dj9)`, normalized 9j-symbol.
- `flsjj(l1, l2, dj1, dj2, L, S, J)`, LS-coupling to jj-coupling transform coefficient.
- `fMoshinsky(N, L, n, l, n1, l1, n2, l2, Λ)`, Moshinsky brakets.
- `dfunc(dj, dm1, dm2, β)`, Wigner d-function.

### Reference

- [https://github.com/ManyBodyPhysics/CENS](https://github.com/ManyBodyPhysics/CENS)
- L. Wei, Unified approach for exact calculation of angular momentum coupling and recoupling coefficients, Computer Physics Communications 120, 222 (1999).
- L. Wei, New formula for 9-j symbols and their direct calculation, Computers in Physics 12, 632 (1998).
- D. A. Varshalovich, A. N. Moskalev and V. K. Khersonskii, *Quantum Theory of Angular Momentum*, (World Scientific, 1988).
- Buck et al. Nuc. Phys. A 600 (1996) 387-402.
- H. T. Johansson and C. Forssén, Fast and Accurate Evaluation of Wigner 3$j$, 6$j$, and 9$j$ Symbols Using Prime Factorization and Multiword Integer Arithmetic, SIAM J. Sci. Comput. 38, A376 (2016).

# this file test the validity by comparing with the widely used `libgsl`

function test_f3j_with_gsl(test_range::AbstractArray)
    wigner_init_float(cld(maximum(test_range), 2), "Jmax", 3)
    for dj1 in test_range
    for dj2 in test_range
    for dj3 in test_range
    for dm1 in -dj1:2:dj1
    for dm2 in -dj2:2:dj2
        dm3 = -dm1-dm2
        if check_couple(dj1, dj2, dj3) & check_jm(dj3, dm3)
            gsl = gsl3j(dj1, dj2, dj3, dm1, dm2, dm3)
            my = f3j(dj1, dj2, dj3, dm1, dm2, dm3)
            @test isapprox(my, gsl; atol=1e-10)
        end
    end end end end end
end

function test_f6j_with_gsl(test_range::AbstractArray)
    wigner_init_float(cld(maximum(test_range), 2), "Jmax", 6)
    for j1 in test_range
    for j2 in test_range
    for j3 in test_range
    for j4 in test_range
    for j5 in test_range
    for j6 in test_range
        if check_6j(j1, j2, j3, j4, j5, j6)
            gsl = gsl6j(j1, j2, j3, j4, j5, j6)
            my = f6j(j1,j2,j3,j4,j5,j6)
            @test isapprox(my, gsl; atol=1e-10)
        end
    end end end end end end
end

function test_f9j_with_gsl(test_range::AbstractArray)
    wigner_init_float(cld(maximum(test_range), 2), "Jmax", 9)
    for j1 in test_range
    for j2 in test_range
    for j3 in test_range
    for j4 in test_range
    for j5 in test_range
    for j6 in test_range
    for j7 in test_range
    for j8 in test_range
    for j9 in test_range
        if check_9j(j1,j2,j3,j4,j5,j6,j7,j8,j9)
            gsl = gsl9j(j1,j2,j3,j4,j5,j6,j7,j8,j9)
            my = f9j(j1,j2,j3,j4,j5,j6,j7,j8,j9)
            @test isapprox(my, gsl; atol=1e-10)
        end
    end end end end end end end end end
end

using Test
using CGcoefficient

include("test_sqrtrational.jl")
include("test_zero.jl")
include("test_special.jl")
include("test_Gaunt.jl")
include("test_orthonormality.jl")
include("test_with_gsl.jl")
include("test_float_gsl.jl")
include("test_Moshinsky.jl")
include("test_pf.jl")

@testset "test SqrtRational" begin test_sqrtrational() end
@testset "test SqrtRational show" begin test_show() end
@testset "test simplify" begin test_simplify() end

@testset "test trivial zero" begin test_trival_zero() end
@testset "test zero" begin test_zero() end

@testset "special condition: CG" begin test_special_CG(1//2:1//2:10) end
@testset "special condition: CG0" begin test_CG0(1:10) end
@testset "special condition: CGspin" begin test_CGspin() end
@testset "special condition: CG3spin" begin test_CG3spin() end
@testset "special condition: 3j as CG" begin test_3j_as_CG(1:8) end
@testset "special condition: 6j" begin test_special_6j(1//2:1//2:5) end
@testset "special condition: Racah" begin test_special_Racah(1//2:1//2:5) end
@testset "special condition: 9j" begin test_special_9j(1//2:1//2:3) end
@testset "special condition: lsjj" begin test_lsjj(0:5) end
@testset "special condition: flsjj" begin test_flsjj(0:5) end

@testset "test xGaunt" begin test_xGaunt(0:5) end

@testset "test orthonormality: dCG" begin test_orthonormality_dCG(0:8) end
@testset "test summation: d3j" begin test_summation_d3j(0:40) end
@testset "test orthonormality: d6j" begin test_orthonormality_d6j(0:6) end
@testset "test orthonormality: d9j" begin test_orthonormality_d9j(0:4) end

@testset "test Moshinsky" begin test_Moshinsky() end

@testset "test PFrational" begin test_PFRational() end
@testset "test eCG" begin test_eCG(1:3) end
@testset "test eCG0" begin test_eCG0(1:3) end
@testset "test e3j" begin test_e3j(1:3) end
@testset "test e6j" begin test_e6j(1:3) end
@testset "test pf binomial" begin test_pf_binomial() end

try
    gsl3j(1, 1, 1, 0, 0, 0)
catch err
    if isa(err, ErrorException)
        println(err.msg)
        println("If you want to run test with libgsl, please download gsl library and rerun the test.")
        exit()
    end
    error(err)
end

@testset "test with gsl: 3j" begin test_3j_with_gsl(1:5) end
@testset "test with gsl: 6j" begin test_6j_with_gsl(1:5) end
@testset "test with gsl: 9j" begin test_9j_with_gsl(1:5) end
@testset "float version: f3j" begin test_f3j_with_gsl(50:55) end
@testset "float version: f6j" begin test_f6j_with_gsl(50:55) end
@testset "float version: f9j" begin test_f9j_with_gsl(50:52) end

# this file test the some special case if Wigner symbols
# especially the when one of arguement is equal to zero
# All formulat are refered in
# [1] D. A. Varshalovich, A. N. Moskalev and V. K. Khersonskii, Quantum Theory of Angular Momentum, (World Scientific, 1988).

# test special condition for CG coefficients
# Ref[1], P248, Sec 8.5, Formula(1)
function test_special_CG(test_range::AbstractArray)
    for j = test_range
        for m = -j:1:j
            cg = CG(j, j, 0, m, -m, 0)
            mycg = iphase(Int(j - m)) / exact_sqrt(2j + 1)
            @test cg == mycg
        end
    end
end

function test_CG0(test_range::AbstractArray)
    for j1 = test_range, j2 = test_range, j3 = test_range
        if check_couple(Int(2j1), Int(2j2), Int(2j3))
            cg0 = CG0(j1, j2, j3)
            tj = threeJ(j1, j2, j3, 0, 0, 0) * iphase(2j1 + j3) * exact_sqrt(2j3 + 1)
            @test cg0 == tj
        end
    end
end

function test_CGspin()
    wigner_init_float(2, "Jmax", 3)
    @test fCGspin(1, 1, 1) ≈ fCG(1, 1, 2, 1, 1, 2) ≈ 1.0
    @test fCGspin(1, 1, 0) ≈ fCG(1, 1, 0, 1, 1, 2) ≈ 0.0
    @test fCGspin(1, -1, 1) ≈ fCG(1, 1, 2, 1, -1, 0) ≈ 1/√2
    @test fCGspin(1, -1, 0) ≈ fCG(1, 1, 0, 1, -1, 0) ≈ 1/√2
    @test fCGspin(-1, 1, 1) ≈ fCG(1, 1, 2, -1, 1, 0) ≈ 1/√2
    @test fCGspin(-1, 1, 0) ≈ fCG(1, 1, 0, -1, 1, 0) ≈ -1/√2
    @test fCGspin(-1, -1, 1) ≈ fCG(1, 1, 2, -1, -1, -2) ≈ 1.0
    @test fCGspin(-1, -1, 0) ≈ fCG(1, 1, 0, -1, -1, -2) ≈ 0.0
end

function test_CG3spin()
    wigner_init_float(3, "Jmax", 3)
    for ds1 = (-1, 1) for ds2 = (-1, 1) for ds3 = (-1, 1)
        for S12 = (0,1)
            for dS = (1,3)
                x = fCG3spin(ds1, ds2, ds3, S12, dS)
                y = fCG(1, 1, 2S12, ds1, ds2, ds1+ds2) * fCG(2S12, 1, dS, ds1+ds2, ds3, ds1+ds2+ds3)
                @test x ≈ y
            end
        end
    end end end
end

function test_3j_as_CG(test_range::AbstractArray)
    for dj1 in test_range, dj2 in test_range, dj3 in test_range
        for dm1 in -dj1:2:dj1, dm2 in -dj2:2:dj2
            dm3 = -dm1 - dm2
            if check_couple(dj1, dj2, dj3) & check_jm(dj3, dm3)
                tj = d3j(dj1, dj2, dj3, dm1, dm2, dm3)
                cg = dCG(dj1, dj2, dj3, -dm1, -dm2, dm3)
                @test tj == cg * SqrtRational(iphase(dj1 + div(dj3 + dm3, 2)), 1//(dj3 + 1))
            end
        end
    end
    wigner_init_float(cld(maximum(test_range), 2), "Jmax", 3)
    for dj1 in test_range, dj2 in test_range, dj3 in test_range
        for dm1 in -dj1:2:dj1, dm2 in -dj2:2:dj2
            dm3 = -dm1 - dm2
            if check_couple(dj1, dj2, dj3) & check_jm(dj3, dm3)
                tj = f3j(dj1, dj2, dj3, dm1, dm2, dm3)
                cg = fCG(dj1, dj2, dj3, -dm1, -dm2, dm3)
                @test tj ≈ cg * iphase(dj1 + div(dj3 + dm3, 2)) / sqrt(dj3 + 1)
            end
        end
    end
end

# test special condition for 6j symbols
# Ref[1], P299, Sec 9.5, Formula (1)
function test_special_6j(test_range::AbstractArray)
    for j1 in test_range, j2 in test_range, j3 in test_range
        if check_couple(Int(2j1), Int(2j2), Int(2j3))
            sj = sixJ(j1, j2, j3, j2, j1, 0)
            mysj = iphase(Int(j1 + j2 + j3)) / exact_sqrt((2j1 + 1) * (2j2 + 1))
            @test sj == mysj
        end
    end
end

# test special condition for Racah coefficients
# Ref[1], P300, Sec 9.5, Formula (2)
function test_special_Racah(test_range::AbstractArray)
    for j1 in test_range, j2 in test_range, j3 in test_range
        if check_couple(Int(2j1), Int(2j2), Int(2j3))
            rc = Racah(0, j1, j2, j3, j1, j2)
            myrc = 1 / exact_sqrt((2j1 + 1) * (2j2 + 1))
            @test rc == myrc
        end
    end
end

# test special condition for 9j symbols
# Ref[1], P357, Sec 10.9, Formula (1)
function test_special_9j(test_range::AbstractArray)
    for j1 in test_range, j2 in test_range, j3 in test_range,
        j4 in test_range, j5 in test_range, j7 in test_range

        if check_6j(convert(Int, 2j1), convert(Int, 2j2), convert(Int, 2j3), convert(Int, 2j5), convert(Int, 2j4), convert(Int, 2j7))
            nj = nineJ(j1, j2, j3, j4, j5, j3, j7, j7, 0)
            snj = iphase(Int(j2 + j3 + j4 + j7)) / exact_sqrt((2j3 + 1) * (2j7 + 1))
            snj *= sixJ(j1, j2, j3, j5, j4, j7)
            @test nj == snj
        end
    end
end

function test_lsjj(test_range::AbstractArray)
    for l1 in test_range
        for l2 in test_range
            for L in abs(l1-l2):(l1+l2)
                for (j1, j2) in [(l1+1//2, l2+1//2), (l1+1//2, l2-1//2), (l1-1//2, l2+1//2), (l1-1//2, l2-1//2)]
                    for (S, J) in [(0, L), (1, L-1), (1, L), (1, L+1)]
                        @test lsjj(l1, l2, j1, j2, L, S, J) == norm9J(l1, 1//2, j1, l2, 1//2, j2, L, S, J)
                    end
                end
            end
        end
    end
end

function test_flsjj(test_range::AbstractArray)
    wigner_init_float(maximum(test_range), "Jmax", 9)
    for l1 in test_range
        for l2 in test_range
            for L in abs(l1-l2):(l1+l2)
                for (dj1, dj2) in [(2l1+1, 2l2+1), (2l1+1, 2l2-1), (2l1-1, 2l2+1), (2l1-1, 2l2-1)]
                    for (S, J) in [(0, L), (1, L-1), (1, L), (1, L+1)]
                        @test flsjj(l1, l2, dj1, dj2, L, S, J) ≈ fnorm9j(2l1, 1, dj1, 2l2, 1, dj2, 2L, 2S, 2J)
                    end
                end
            end
        end
    end
end

function test_xGaunt(test_range::AbstractArray)
    for l1 in test_range, l2 in test_range, l3 in test_range
        for m1 in -l1:l1, m2 in -l2:l2, m3 in -l3:l3
            g = xGaunt(l1, l2, l3, m1, m2, m3)
            w = exact_sqrt((2l1 + 1) * (2l2 + 1) * (2l3 + 1)//4) * threeJ(l1, l2, l3, m1, m2, m3) * threeJ(l1, l2, l3, 0, 0, 0)
            @test g == w
        end
    end
end

using Primes
using Base.GMP.MPZ

const c_tdiv_q_ui = MPZ.gmpz(:tdiv_q_ui)
const c_ui_pow_ui = MPZ.gmpz(:ui_pow_ui)
const c_divexact = MPZ.gmpz(:divexact)
const c_bin_uiui = MPZ.gmpz(:bin_uiui)
const c_addmul = MPZ.gmpz(:addmul)
const c_get_d_2exp = MPZ.gmpz(:get_d_2exp)
@inline function __gmpz_tdiv_q_ui!(q::BigInt, n::BigInt, d::Culong)
    ccall(c_tdiv_q_ui, Culong, (Ref{BigInt}, Ref{BigInt}, Culong), q, n, d)
end
@inline function __gmpz_ui_pow_ui!(r::BigInt, b::Culong, e::Culong)
    ccall(c_ui_pow_ui, Cvoid, (Ref{BigInt}, Culong, Culong), r, b, e)
end
@inline function __gmpz_divexact!(q::BigInt, n::BigInt, d::BigInt)
    ccall(c_divexact, Cvoid, (Ref{BigInt}, Ref{BigInt}, Ref{BigInt}), q, n, d)
end
@inline function __gmpz_bin_uiui!(r::BigInt, n::Culong, k::Culong)
    ccall(c_bin_uiui, Cvoid, (Ref{BigInt}, Culong, Culong), r, n, k)
end
@inline function __gmpz_addmul!(r::BigInt, a::BigInt, b::BigInt)
    ccall(c_addmul, Cvoid, (Ref{BigInt}, Ref{BigInt}, Ref{BigInt}), r, a, b)
end
@inline function __gmpz_get_d_2exp!(n::BigInt)
    e = Ref{Clong}(0)
    d = ccall(c_get_d_2exp, Cdouble, (Ref{Clong}, Ref{BigInt}), e, n)
    return d, e[]
end

@inline function _bigbin(r::BigInt, n::Int, k::Int)
    __gmpz_bin_uiui!(r, Culong(n), Culong(k))
    return r
end

@inline _bigbin(n::Int, k::Int) = _bigbin(BigInt(), n, k)

@inline function _divgcd!(g::BigInt, n::BigInt, d::BigInt)
    MPZ.gcd!(g, n, d)
    __gmpz_divexact!(n, n, g)
    __gmpz_divexact!(d, d, g)
    return g
end

# t is buffer, modefiy `na, da` in place
@inline function __gmpq_add!(t::BigInt, na::BigInt, da::BigInt, nb::BigInt, db::BigInt)
    MPZ.mul!(na, db)
    __gmpz_addmul!(na, da, nb)
    MPZ.mul!(da, db)
    _divgcd!(t, na, da)
    return
end

@inline function __gmpq_add!(t::BigInt, a::Rational{BigInt}, nu::BigInt, de::BigInt)
    __gmpq_add!(t, a.num, a.den, nu, de)
end

# simplify `x√t`, move the square factors of `t` to `x`
# assume `t` is positive
function simplify!(x::BigInt, t::BigInt, hint::Int)
    q = zero(BigInt)
    tt = one(BigInt)
    for ip in primes(hint)
        p = convert(Culong, ip)
        p > t && break
        r = __gmpz_tdiv_q_ui!(q, t, p)
        i::Culong = zero(Culong)
        while iszero(r)
            i += 1
            MPZ.set!(t, q)
            r = __gmpz_tdiv_q_ui!(q, t, p)
        end
        iszero(i) && continue
        ti, xi = divrem(i, Culong(2))
        xi == 1 && MPZ.mul_ui!(tt, p)
        if ti != 0
            __gmpz_ui_pow_ui!(q, p, ti)
            MPZ.mul!(x, q)
        end
    end
    MPZ.mul!(t, tt)
    return
end

# simplify sn/√(1/rd) -> sn/sd*√(rn/rd), initial value of `sd, rn` is not important
function simplify2!(sn::BigInt, sd::BigInt, rn::BigInt, rd::BigInt, hint::Int)
    _divgcd!(rn, sn, rd)
    _divgcd!(sd, rn, rd)
    MPZ.set_ui!(sd, 1)
    simplify!(sn, rn, hint)
    simplify!(sd, rd, hint)
    return
end

# simplify s*√(n/d) -> s/g*√(n/d)
function simplify3!(g::BigInt, s::BigInt, n::BigInt, d::BigInt, hint::Int)
    _divgcd!(g, n, d)
    _divgcd!(g, s, d)
    MPZ.mul!(n, g)
    _divgcd!(g, n, d)
    MPZ.set_ui!(g, 1)
    simplify!(s, n, hint)
    simplify!(g, d, hint)
    return
end

# simplify sn/sd*√(rn/rd) -> sn/sd*√(rn/rd), t is buffer
function simplify4!(t::BigInt, sn::BigInt, sd::BigInt, rn::BigInt, rd::BigInt, hint::Int)
    _divgcd!(t, sn, sd)
    _divgcd!(t, rn, rd)
    simplify!(sn, rn, hint)
    simplify!(sd, rd, hint)
    _divgcd!(t, sn, sd)
    _divgcd!(t, sn, rd)
    MPZ.mul!(rn, t)
    _divgcd!(t, sd, rn)
    MPZ.mul!(rd, t)
    _divgcd!(t, rn, rd)
    return
end

using CGcoefficient
using BenchmarkTools

function calculate_lsjj(test_range::AbstractArray)
    sum = 0.0
    for l1 in test_range
        for l2 in test_range
            for (dj1, dj2) in [(2l1-1, 2l2-1), (2l1-1, 2l2+1), (2l1+1, 2l2-1), (2l1+1, 2l2+1)]
                for L in abs(l1-l2):(l1+l2)
                    for (S, J) in [(0, L), (1, L-1), (1, L), (1, L+1)]
                        sum += flsjj(l1, l2, dj1, dj2, L, S, J)
                    end
                end
            end
        end
    end
    return sum
end

function calculate_norm9j(test_range::AbstractArray)
    sum = 0.0
    for l1 in test_range
        for l2 in test_range
            for (dj1, dj2) in [(2l1-1, 2l2-1), (2l1-1, 2l2+1), (2l1+1, 2l2-1), (2l1+1, 2l2+1)]
                for L in abs(l1-l2):(l1+l2)
                    for (S, J) in [(0, L), (1, L-1), (1, L), (1, L+1)]
                        sum += fnorm9j(2l1, 1, dj1, 2l2, 1, dj2, 2L, 2S, 2J)
                    end
                end
            end
        end
    end
    return sum
end

test_range = 0:10

wigner_init_float(maximum(test_range), "Jmax", 9)

t1 = @belapsed calculate_lsjj(test_range)
t2 = @belapsed calculate_norm9j(test_range)

println("diff = ", calculate_lsjj(test_range) - calculate_norm9j(test_range))
println("lsjj time = $(t1*1000)ms")
println("norm9j time = $(t2*1000)ms")

using CGcoefficient
using BenchmarkTools
using Test

# wapper of gsl 3nj functions
function gsl3j(dj1::Int, dj2::Int, dj3::Int, dm1::Int, dm2::Int, dm3::Int)
    ccall(
        (:gsl_sf_coupling_3j, "libgsl"),
        Cdouble,
        (Cint, Cint, Cint, Cint, Cint, Cint),
        dj1, dj2, dj3, dm1, dm2, dm3
    )
end

function gsl6j(dj1::Int, dj2::Int, dj3::Int, dj4::Int, dj5::Int, dj6::Int)
    ccall(
        (:gsl_sf_coupling_6j, "libgsl"),
        Cdouble,
        (Cint, Cint, Cint, Cint, Cint, Cint),
        dj1, dj2, dj3, dj4, dj5, dj6
    )
end

function gsl9j(dj1::Int, dj2::Int, dj3::Int,
                dj4::Int, dj5::Int, dj6::Int,
                dj7::Int, dj8::Int, dj9::Int)
    ccall(
        (:gsl_sf_coupling_9j, "libgsl"),
        Cdouble,
        (Cint, Cint, Cint, Cint, Cint, Cint, Cint, Cint, Cint),
        dj1, dj2, dj3, dj4, dj5, dj6, dj7, dj8, dj9
    )
end

function calculate_3j(func::Function, test_range::AbstractArray)
    if func == f3j
        wigner_init_float(cld(maximum(test_range), 2), "Jmax", 3)
    end
    sum = 0.0
    for dj1 in test_range
    for dj2 in test_range
    for dj3 in test_range
    for dm1 in -dj1:2:dj1
    for dm2 in -dj2:2:dj2
        dm3 = -dm1-dm2
        sum += func(dj1, dj2, dj3, dm1, dm2, dm3)
    end end end end end
    return sum
end

function calculate_6j(func::Function, test_range::AbstractArray)
    if func == f6j
        wigner_init_float(cld(maximum(test_range), 2), "Jmax", 6)
    end
    sum = 0.0
    for j1 in test_range
    for j2 in test_range
    for j3 in test_range
    for j4 in test_range
    for j5 in test_range
    for j6 in test_range
        sum += func(j1, j2, j3, j4, j5, j6)
    end end end end end end
    return sum
end

function calculate_9j(func::Function, test_range::AbstractArray)
    if func == f9j
        wigner_init_float(cld(maximum(test_range), 2), "Jmax", 9)
    end
    sum = 0.0
    for j1 in test_range
    for j2 in test_range
    for j3 in test_range
    for j4 in test_range
    for j5 in test_range
    for j6 in test_range
    for j7 in test_range
    for j8 in test_range
    for j9 in test_range
        sum += func(j1,j2,j3,j4,j5,j6,j7,j8,j9)
    end end end end end end end end end
    return sum
end

test_range = 40:50

t1 = @belapsed calculate_3j(f3j, test_range)
t2 = @belapsed calculate_3j(gsl3j, test_range)

println("diff = ", calculate_3j(f3j, test_range) - calculate_3j(gsl3j, test_range))
println("f3j time = $(t1)s")
println("gsl3j time = $(t2)s")

test_range = 45:60

t1 = @belapsed calculate_6j(f6j, test_range)
t2 = @belapsed calculate_6j(gsl6j, test_range)

println("diff = ", calculate_6j(f6j, test_range) - calculate_6j(gsl6j, test_range))
println("f6j time = $(t1)s")
println("gsl6j time = $(t2)s")

test_range = 30:35

t1 = @belapsed calculate_9j(f9j, test_range)
t2 = @belapsed calculate_9j(gsl9j, test_range)

println("diff = ", calculate_9j(f9j, test_range) - calculate_9j(gsl9j, test_range))
println("f9j time = $(t1)s")
println("gsl9j time = $(t2)s")

using CGcoefficient
using WignerSymbols

function get_max_error_3j(djmax)
    wigner_init_float(div(djmax, 2) + 1, "Jmax", 3)
    max_error = 0.0
    max_rel_error = 0.0
    for dj1 in (djmax & 1):2:djmax
    for dj2 in dj1:2:djmax
    for dj3 in (dj2-dj1):2:djmax
        if dj1 < djmax && dj2 < djmax && dj3 < (djmax-isodd(djmax)) # bacause they are calculated in privious call
            continue
        end
        for dm1 in -dj1:2:dj1
            for dm2 in (dj2 & 1):2:dj2 # minus dm2 has same absolute value of (-dm1, -dm2)
                dm3 = -dm1-dm2
                check_jm(dj3, dm3) || continue
                exact = wigner3j(dj1//2, dj2//2, dj3//2, dm1//2, dm2//2)
                fval = f3j(dj1, dj2, dj3, dm1, dm2, dm3)
                max_error = max(max_error, abs(exact - fval))
                if exact != 0.0
                    max_rel_error = max(max_rel_error, abs((exact - fval)/exact))
                end
            end
        end
    end end end
    return max_error, max_rel_error
end

err = zeros(100)
rel_err = zeros(100)

for dj in 1:100
    err[dj], rel_err[dj] = @time get_max_error_3j(dj)
    println("dj = $dj, err = $(err[dj]), rel_err = $(rel_err[dj])")
end

# benchmark the exact version and the float version

using CGcoefficient

function bench_3j(func::Function, djmax::Int)
    sum = 0.0
    for dj1 in 1:djmax
        print(dj1, '\r')
        for dj2 in 0:dj1
            for dj3 = abs(dj1-dj2):2:dj2
                for dm1 in -dj1:2:0
                    for dm2 in -dj2:2:dj2
                        dm3 = -dm1-dm2
                        ans = func(dj1, dj2, dj3, dm1, dm2, dm3)
                        sum += ans
                    end
                end
            end 
        end
    end
    return sum
end

function bench_6j(func::Function, djmax::Int)
    sum = 0.0
    for dj1 in 0:djmax
        print(dj1, '\r')
        for dj2 in 0:dj1
            for dj3 in abs(dj1-dj2):2:dj2
                for dj4 in 0:dj1
                    for dj5 in abs(dj3-dj4):2:min(dj1, dj3+dj4)
                        dj6min = max(abs(dj1 - dj5), abs(dj2 - dj4))
                        dj6max = min(dj1, dj2 + dj4)
                        for dj6 in dj6min:2:dj6max
                            ans = func(dj1, dj2, dj3, dj4, dj5, dj6)
                            sum += ans
                        end
                    end
                end
            end
        end
    end
    return sum
end

Jmax = 20

wigner_init_pf(Jmax, "Jmax", 6)
wigner_init_float(Jmax, "Jmax", 6)

big3j(dj1,dj2,dj3,dm1,dm2,dm3) = convert(Float64, float(d3j(dj1,dj2,dj3,dm1,dm2,dm3)))
big6j(dj1,dj2,dj3,dj4,dj5,dj6) = convert(Float64, float(d6j(dj1,dj2,dj3,dj4,dj5,dj6)))

bench_3j(f3j, 1)
bench_3j(ef3j, 1)
bench_3j(big3j, 1)
bench_6j(f6j, 1)
bench_6j(ef6j, 1)
bench_6j(big6j, 1)

t_f3j = @elapsed bench_3j(f3j, 2Jmax)
t_ef3j = @elapsed bench_3j(ef3j, 2Jmax)
t_big3j = @elapsed bench_3j(big3j, 2Jmax)

t_f6j = @elapsed bench_6j(f6j, 2Jmax)
t_ef6j = @elapsed bench_6j(ef6j, 2Jmax)
t_big6j = @elapsed bench_6j(big6j, 2Jmax)

println("f3j: ", t_f3j)
println("ef3j: ", t_ef3j)
println("big3j: ", t_big3j)
println("f6j: ", t_f6j)
println("ef6j: ", t_ef6j)
println("big6j: ", t_big6j)

function test_PFRational()
    wigner_init_pf(10, "nmax", 0)
    x = pf_binomial(10, 5) # 252
    @test numerator(x) == 252
    @test denominator(x) == 1
    @test convert(Rational, x) == 252//1
    y = pf_binomial(10, 6) # 210
    @test numerator(gcd(x, y)) == 42
    @test numerator(lcm(x, y)) == 1260
    @test numerator(x * y) == 52920
    @test numerator(x / y) == 6
    @test denominator(x / y) == 5
    @test numerator(inv(x)) == 1
    @test denominator(inv(x)) == 252
    @test numerator(x^2) == 63504
end

function test_eCG(test_range::AbstractArray)
    wigner_init_pf(cld(maximum(test_range), 2), "Jmax", 3)
    for dj1 in test_range
    for dj2 in test_range
    for dj3 in test_range
    for dm1 in -dj1:2:dj1
    for dm2 in -dj2:2:dj2
        dm3 = dm1 + dm2
        d = dCG(dj1, dj2, dj3, dm1, dm2, dm3)
        e = eCG(dj1, dj2, dj3, dm1, dm2, dm3)
        ef = efCG(dj1, dj2, dj3, dm1, dm2, dm3)
        d = simplify(d)
        @test d == e
        @test convert(Float64, float(d)) == ef
    end end end end end
end

function test_eCG0(test_range::AbstractArray)
    wigner_init_pf(maximum(test_range), "Jmax", 3)
    for j1 in test_range
    for j2 in test_range
    for j3 in test_range
        d = CG0(j1, j2, j3)
        e = eCG0(j1, j2, j3)
        ef = efCG0(j1, j2, j3)
        f = fCG0(j1, j2, j3)
        @test d == e
        @test convert(Float64, float(d)) == ef
        @test ef ≈ f
    end end end
end

function test_e3j(test_range::AbstractArray)
    wigner_init_pf(cld(maximum(test_range), 2), "Jmax", 3)
    for dj1 in test_range
    for dj2 in test_range
    for dj3 in test_range
    for dm1 in -dj1:2:dj1
    for dm2 in -dj2:2:dj2
        dm3 = -dm1-dm2
        d = d3j(dj1, dj2, dj3, dm1, dm2, dm3)
        e = e3j(dj1, dj2, dj3, dm1, dm2, dm3)
        ef = ef3j(dj1, dj2, dj3, dm1, dm2, dm3)
        d = simplify(d)
        @test d == e
        @test convert(Float64, float(d)) == ef
    end end end end end
end

function test_e6j(test_range::AbstractArray)
    wigner_init_pf(cld(maximum(test_range), 2), "Jmax", 6)
    for j1 in test_range
    for j2 in test_range
    for j3 in test_range
    for j4 in test_range
    for j5 in test_range
    for j6 in test_range
        d = d6j(j1, j2, j3, j4, j5, j6)
        e = e6j(j1, j2, j3, j4, j5, j6)
        ef = ef6j(j1, j2, j3, j4, j5, j6)
        d = simplify(d)
        if d != e
            println(j1, j2, j3, j4, j5, j6)
            println(d)
            println(e)
            return
        end
        @test d == e
        @test convert(Float64, float(d)) == ef
    end end end end end end
end


function test_pf_binomial()
    wigner_init_pf(100, "nmax", 0)
    wigner_init_float(100, "nmax", 0)
    n = 100
    for k in 0:n
        x = pf_binomial(n, k)
        y = binomial(big(n), big(k))
        @test numerator(x) == y
        f = fbinomial(n, k)
        @test convert(Float64, numerator(x)) ≈ f
    end
end

# this file contains some useful functions

"""
    iphase(n::Integer)
``(-1)^n``
"""
@inline iphase(n::T) where {T <: Integer} = iseven(n) ? one(T) : -one(T)

"""
    is_same_parity(x::T, y::T) where {T <: Integer}
judge if two integers are same odd or same even
"""
@inline is_same_parity(x::T, y::T) where {T <: Integer} = mod(x, 2) == mod(y, 2)

"""
    check_jm(dj::T, dm::T) where {T <: Integer}
check if the m-quantum number if one of the components of the j-quantum number,
in other words, `m` and `j` has the same parity, and `abs(m) < j`
"""
@inline check_jm(dj::T, dm::T) where {T <: Integer} = is_same_parity(dj, dm) & (abs(dm) <= dj)

"""
    check_couple(dj1::T, dj2::T, dj3::T) where {T <: Integer}
check if three angular monentum number `j1, j2, j3` can couple
"""
@inline check_couple(dj1::T, dj2::T, dj3::T) where {T <: Integer} = begin
    iseven(dj1 + dj2 + dj3) && (dj1 <= dj2 + dj3) && (dj2 <= dj1 + dj3) && (dj3 <= dj1 + dj2)
end

@doc raw"""
    binomial_data_size(n::Int)::Int
Store (half) binomial data in the order of
```text
# n - data
  0   1
  1   1
  2   1 2
  3   1 3
  4   1 4 6
  5   1 5 10
  6   1 6 15 20
```
Return the total number of the stored data.
"""
@inline function binomial_data_size(n::Int)::Int
    x = div(n, 2) + 1
    return x * (x + isodd(n))
end

@doc raw"""
    binomial_index(n::Int, k::Int)::Int
Return the index of the binomial coefficient in the table.
"""
@inline function binomial_index(n::Int, k::Int)::Int
    x = div(n, 2) + 1
    return x * (x - iseven(n)) + k + 1
end

"""
    check_CG(dj1::T, dj2::T, dj3::T, dm1::T, dm2::T, dm3::T) where {T <: Integer}
Check if the Clebsch-Gordan coefficient is valid.
"""
@inline function check_CG(dj1::T, dj2::T, dj3::T, dm1::T, dm2::T, dm3::T) where {T <: Integer}
    check_jm(dj1, dm1) && check_jm(dj2, dm2) && check_jm(dj3, dm3) && check_couple(dj1, dj2, dj3) && (dm1 + dm2 == dm3)
end

"""
    check_Gaunt(l1::T, l2::T, l3::T, m1::T, m2::T, m3::T) where {T <: Integer}
Check if the Gaunt coefficient is valid.
"""
@inline function check_Gaunt(l1::T, l2::T, l3::T, m1::T, m2::T, m3::T) where {T <: Integer}
    if !check_couple(l1, l2, l3)
        return false
    end
    if abs(m1) > l1 || abs(m2) > l2 || abs(m3) > l3
        return false
    end
    if m1 + m2 + m3 != 0
        return false
    end
    return true
end

"""
    check_3j(dj1::T, dj2::T, dj3::T, dm1::T, dm2::T, dm3::T) where {T <: Integer}
Check if the Wigner 3-j symbol is valid.
"""
@inline function check_3j(dj1::T, dj2::T, dj3::T, dm1::T, dm2::T, dm3::T) where {T <: Integer}
    check_jm(dj1, dm1) && check_jm(dj2, dm2) && check_jm(dj3, dm3) && check_couple(dj1, dj2, dj3) && (dm1 + dm2 + dm3 == 0)
end

"""
    check_6j(dj1::T, dj2::T, dj3::T, dj4::T, dj5::T, dj6::T) where {T <: Integer}
Check if the Wigner 6-j symbol is valid.
"""
@inline function check_6j(dj1::T, dj2::T, dj3::T, dj4::T, dj5::T, dj6::T) where {T <: Integer}
    check_couple(dj1, dj2, dj3) && check_couple(dj1, dj5, dj6) && check_couple(dj4, dj2, dj6) && check_couple(dj4, dj5, dj3)
end

"""
    check_9j(dj1::T, dj2::T, dj3::T, dj4::T, dj5::T, dj6::T, dj7::T, dj8::T, dj9::T) where {T <: Integer}
Check if the Wigner 9-j symbol is valid.
"""
@inline function check_9j(dj1::T, dj2::T, dj3::T, dj4::T, dj5::T, dj6::T, dj7::T, dj8::T, dj9::T) where {T <: Integer}
    check_couple(dj1, dj2, dj3) && check_couple(dj4, dj5, dj6) && check_couple(dj7, dj8, dj9) &&
    check_couple(dj1, dj4, dj7) && check_couple(dj2, dj5, dj8) && check_couple(dj3, dj6, dj9)
end

"""
    check_Moshinsky(N::T, L::T, n::T, l::T, n1::T, l1::T, n2::T, l2::T, Λ::T) where {T <: Integer}
Check if the Moshinsky coefficient is valid.
"""
@inline function check_Moshinsky(N::T, L::T, n::T, l::T, n1::T, l1::T, n2::T, l2::T, Λ::T) where {T <: Integer}
    if N < 0 || n < 0 || n1 < 0 || n2 < 0
        return false
    end
    if Λ > L + l || L > Λ + l || l > Λ + L
        return false
    end
    if Λ > l1 + l2 || l1 > Λ + l2 || l2 > Λ + l1
        return false
    end
    E = 2N + L
    e = 2n + l
    e1 = 2n1 + l1
    e2 = 2n2 + l2
    if E + e != e1 + e2
        return false
    end
    return true
end

mutable struct PrimePowItem
    size::Int
    offset::Int
    ulongdata::Vector{Culong}
    bigdata::Vector{BigInt}
    function PrimePowItem(size::Int, offset::Int, ulongdata::Vector{Culong}, bigdata::Vector{BigInt})
        new(size, offset, ulongdata, bigdata)
    end
end

function make_pow_item(p::Culong, k::Int)
    offset = floor(Int, log(big(p), big(typemax(Culong))))
    ulongdata = Vector{Culong}(undef, offset)
    for i in 1:offset
        ulongdata[i] = p^i
    end
    if k > offset
        bigdata = [BigInt(p) for i in offset+1:k]
        for i in offset+1:k
            MPZ.pow_ui!(bigdata[i - offset], i)
        end
    else
        bigdata = BigInt[]
    end
    PrimePowItem(max(k, offset), offset, ulongdata, bigdata)
end

# first n primes
_prime_table = Culong[2, 3, 5, 7]
# first n primes and their powers
_prime_pow_table = PrimePowItem[]

@inline nth_stored_prime(n::Integer)::Culong = @inbounds _prime_table[n]::Culong
@inline last_stored_prime()::Culong = _prime_table[end]::Culong
@inline stored_prime_num()::Int = length(_prime_table::Vector{Culong})
@inline prime_pow_table()::Vector{PrimePowItem} = _prime_pow_table::Vector{PrimePowItem}
@inline prime_pow_table_size()::Int = length(prime_pow_table())
@inline max_prime_index(n::Integer)::Int = searchsortedlast(_prime_table::Vector{Culong}, convert(Culong, n))

function _extend_prime_table(size::Integer)
    size <= stored_prime_num() && return
    start = stored_prime_num() + 1
    p = last_stored_prime()
    for i in start:size
        p = nextprime(p + 1)
        push!(_prime_table, p)
    end
end

function _extend_prime_table_to(n::Integer)
    p = last_stored_prime()
    n <= p && return
    while p < n
        p = nextprime(p + 1)
        push!(_prime_table, p)
    end
end

function _extend_item!(item::PrimePowItem, k::Integer)
    k <= item.size && return
    k <= item.offset && return
    resize!(item.bigdata, k - item.offset)
    for i in item.size+1:k
        p = item.ulongdata[1]
        idx = i - item.offset
        item.bigdata[idx] = BigInt(p)
        MPZ.pow_ui!(item.bigdata[idx], i)
    end
    item.size = k
end


function _extend_prime_pow_table(size::Integer, maxnum::Integer, times::Int)
    size <= prime_pow_table_size() && return
    _extend_prime_table(size)
    factor = log2(maxnum) * times
    for i in eachindex(prime_pow_table())
        p = nth_stored_prime(i)
        k = floor(Int, factor / log2(p))
        _extend_item!(prime_pow_table()[i], k)
    end
    sizehint!(prime_pow_table(), size)
    start = prime_pow_table_size() + 1
    for i in start:size
        p = nth_stored_prime(i)
        k = floor(Int, factor / log2(p))
        push!(prime_pow_table(), make_pow_item(p, k))
    end
end

function mul_p_pow_k!(x::BigInt, pidx::Int, k::Int)
    item = prime_pow_table()[pidx]::PrimePowItem
    if k <= item.offset
        return MPZ.mul_ui!(x, @inbounds item.ulongdata[k])
    end
    return MPZ.mul!(x, item.bigdata[k - item.offset])
end

_fbinomial_data = Float64[1.0]
_fbinomial_nmax = Int(0)
@inline get_fbinomial_data()::Vector{Float64} = _fbinomial_data::Vector{Float64}
@inline get_fbinomial_nmax()::Int = _fbinomial_nmax::Int

"""
    fbinomial(n::Integer, k::Integer)
`binomial` with Float64 return value.
"""
@inline function fbinomial(n::Integer, k::Integer)::Float64
    if n < 0 || n > get_fbinomial_nmax() || k < 0 || k > n
        return 0.0
    end
    k = min(k, n - k)
    return @inbounds get_fbinomial_data()[binomial_index(n, k)]
end

"""
    function unsafe_fbinomial(n::Int, k::Int)
Same as fbinomial, but without bounds check. Thus for `n < 0` or `n > _nmax` or `k < 0` or `k > n`, the result is undefined.
In Wigner symbol calculation, the mathematics guarantee that `unsafe_fbinomial(n, k)` is always safe.
"""
@inline function unsafe_fbinomial(n::Int, k::Int)::Float64
    k = min(k, n - k)
    return @inbounds get_fbinomial_data()[binomial_index(n, k)]
end

function _extend_fbinomial_data(n::Int)
    if n > get_fbinomial_nmax()
        old_data = copy(get_fbinomial_data())
        resize!(get_fbinomial_data(), binomial_data_size(n))
        copyto!(get_fbinomial_data(), old_data)
        t = BigInt()
        for m = get_fbinomial_nmax()+1:n
            for k = 0:div(m, 2)
                get_fbinomial_data()[binomial_index(m, k)] = _bigbin(t, m, k)
            end
            global _fbinomial_nmax = get_fbinomial_nmax() + 1
        end
        global _fbinomial_nmax = n
    end
    nothing
end

"""
    wigner_init_float(n::Integer, mode::AbstractString, rank::Integer)
We calculate the Wigner Symbols with binomials. We will store some binomials first, then when we need one binomial, we just load it. In this package, the functions starts with `f` character dependent on the stored binomials. The `wigner_init_float` function is used to extend the range of the stored binomial table.

The parameters means:
- `mode`:
    - `"Jmax"`: set the maximum angular momentum in the system.
    - `"2bjmax"`: set the maximum two-body coupled angular momentum in the system.
    - `"nmax"`: directly set the maximum binomial number.
    - `"Moshinsky"`: set the maximum `N = 2n+l` in the Moshinsky bracket.
- `n`: the maximum angular momentum or the maximum binomial number, dependent on the `mode`.
- `rank`:
    - `3`: calculate only CG coefficients and 3j symbols.
    - `6`: calculate CG coefficients, 3j symbols and 6j symbols.
    - `9`: calculate CG coefficients, 3j symbols, 6j symbols and 9j symbols.

`"Jmax"` means the global maximum angular momentum, for every parameters. It is always safe with out any assumption.

The `"2bjmax"` mode means your calculation only consider two-body coupling, and no three-body coupling. This mode assumes that in all these coefficients, at least one of the angular momentun is just a single particle angular momentum. With this assumption, `"2bjmax"` mode will use less memory than `"Jmax"` mode.

The `"Moshinsky"` mode means you want to calculate the Moshinsky brackets. The `n` parameter is the maximum `N = 2n+l` in the Moshinsky bracket. The `rank` parameter is ignored.

The `"nmax"` mode directly set `nmax`, and the `rank` parameter is ignored. 

For example
```julia
wigner_init_float(21, "Jmax", 6)
```
means you calculate CG and 6j symbols, and donot calculate 9j symbol. The maximum angular momentum in your system is 21.

The exact values of the maximum `nmax` for different `rank` are shown in the table below ([details](https://0382.github.io/CGcoefficient.jl/stable/wigner/#Estimate-the-capacity)).

|                                       |    Calculate range    |   CG & 3j   | 6j & Racah  |     9j      |
| :-----------------------------------: | :-------------------: | :---------: | :---------: | :---------: |
|          meaning of `type`            | `type`\\\\`rank`      |      3      |      6      |      9      |
|        max angular momentum           |    `"Jmax"`           |  `3Jmax+1`  |  `4Jmax+1`  |  `5Jmax+1`  |
| max two-body coupled angular momentum |   `"2bjmax"`          |  `2jmax+1`  |  `3jmax+1`  |  `4jmax+1`  |
| max ``N = 2n+l`` for Moshinsky bracket|    `"Moshinsky"`      |  `6Nmax+1`  |  `6Nmax+1`  |  `6Nmax+1`  |
|            max binomial               |    `"nmax"`           |   `nmax`    |   `namx`    |   `nmax`    |

You do not need to rememmber those values in the table. You just need to find the maximum angular momentum in you canculation, then call the function.

The `wigner_init_float` function is **not** thread safe, so you should call it before you start your calculation.
"""
function wigner_init_float(n::Integer, mode::AbstractString, rank::Integer)
    if mode == "Jmax"
        rank == 3 && _extend_fbinomial_data(3 * n + 1)
        rank == 6 && _extend_fbinomial_data(4 * n + 1)
        rank == 9 && _extend_fbinomial_data(5 * n + 1)
        if rank != 3 && rank != 6 && rank != 9
            throw(ArgumentError("invalid rank $rank"))
        end
    elseif mode == "2bjmax"
        rank == 3 && _extend_fbinomial_data(2 * n + 1)
        rank == 6 && _extend_fbinomial_data(3 * n + 1)
        rank == 9 && _extend_fbinomial_data(4 * n + 1)
        if rank != 3 && rank != 6 && rank != 9
            throw(ArgumentError("invalid rank $rank"))
        end
    elseif mode == "nmax"
        _extend_fbinomial_data(n)
    elseif mode == "Moshinsky"
        _extend_fbinomial_data(6 * n + 1)
    else
        throw(ArgumentError("invalid mode $mode"))
    end
    nothing
end


# basic CG coefficient calculation function with Float64 return value
# unlike the SqrtRational version, this function gives out zero when the parameters are not valid
function _fCG(dj1::Int, dj2::Int, dj3::Int, dm1::Int, dm2::Int, dm3::Int)
    check_CG(dj1, dj2, dj3, dm1, dm2, dm3) || return zero(Float64)
    J::Int = div(dj1 + dj2 + dj3, 2)
    Jm1::Int = J - dj1
    Jm2::Int = J - dj2
    Jm3::Int = J - dj3
    j1mm1::Int = div(dj1 - dm1, 2)
    j2mm2::Int = div(dj2 - dm2, 2)
    j3mm3::Int = div(dj3 - dm3, 2)
    j2pm2::Int = div(dj2 + dm2, 2)
    A = sqrt(unsafe_fbinomial(dj1, Jm2) * unsafe_fbinomial(dj2, Jm3) / (
        unsafe_fbinomial(J + 1, Jm3) * unsafe_fbinomial(dj1, j1mm1) *
        unsafe_fbinomial(dj2, j2mm2) * unsafe_fbinomial(dj3, j3mm3)
    ))
    B = zero(Float64)
    low::Int = max(zero(Int), j1mm1 - Jm2, j2pm2 - Jm1)
    high::Int = min(Jm3, j1mm1, j2pm2)
    for z in low:high
        B = -B + unsafe_fbinomial(Jm3, z) * unsafe_fbinomial(Jm2, j1mm1 - z) * unsafe_fbinomial(Jm1, j2pm2 - z)
    end
    return iphase(high) * A * B
end

function _f3j(dj1::Int, dj2::Int, dj3::Int, dm1::Int, dm2::Int, dm3::Int)
    check_3j(dj1, dj2, dj3, dm1, dm2, dm3) || return zero(Float64)
    J::Int = div(dj1 + dj2 + dj3, 2)
    Jm1::Int = J - dj1
    Jm2::Int = J - dj2
    Jm3::Int = J - dj3
    j1mm1::Int = div(dj1 - dm1, 2)
    j2mm2::Int = div(dj2 - dm2, 2)
    j3mm3::Int = div(dj3 - dm3, 2)
    j1pm1::Int = div(dj1 + dm1, 2)
    A = sqrt(unsafe_fbinomial(dj1, Jm2) * unsafe_fbinomial(dj2, Jm1) / (
        (J+1) * unsafe_fbinomial(J, Jm3) * unsafe_fbinomial(dj1, j1mm1) *
        unsafe_fbinomial(dj2, j2mm2) * unsafe_fbinomial(dj3, j3mm3)
    ))
    B = zero(Float64)
    low::Int = max(zero(Int), j1pm1 - Jm2, j2mm2 - Jm1)
    high::Int = min(Jm3, j1pm1, j2mm2)
    for z in low:high
        B = -B + unsafe_fbinomial(Jm3, z) * unsafe_fbinomial(Jm2, j1pm1 - z) * unsafe_fbinomial(Jm1, j2mm2 - z)
    end
    return iphase(dj1 + div(dj3 + dm3, 2) + high) * A * B
end

function _fCG0(j1::Int, j2::Int, j3::Int)
    check_couple(2j1, 2j2, 2j3) || return zero(Float64)
    J = j1 + j2 + j3
    isodd(J) && return zero(Float64)
    g = div(J, 2)
    return iphase(g - j3) * unsafe_fbinomial(g, j3) * unsafe_fbinomial(j3, g - j1) / sqrt(unsafe_fbinomial(J + 1, 2j3 + 1) * unsafe_fbinomial(2j3, J - 2j1))
end

function _f6j(dj1::Int, dj2::Int, dj3::Int, dj4::Int, dj5::Int, dj6::Int)
    check_6j(dj1, dj2, dj3, dj4, dj5, dj6) || return zero(Float64)
    j123::Int = div(dj1 + dj2 + dj3, 2)
    j156::Int = div(dj1 + dj5 + dj6, 2)
    j426::Int = div(dj4 + dj2 + dj6, 2)
    j453::Int = div(dj4 + dj5 + dj3, 2)
    jpm123::Int = div(dj1 + dj2 - dj3, 2)
    jpm132::Int = div(dj1 + dj3 - dj2, 2)
    jpm231::Int = div(dj2 + dj3 - dj1, 2)
    jpm156::Int = div(dj1 + dj5 - dj6, 2)
    jpm426::Int = div(dj4 + dj2 - dj6, 2)
    jpm453::Int = div(dj4 + dj5 - dj3, 2)
    A = sqrt(unsafe_fbinomial(j123 + 1, dj1 + 1) * unsafe_fbinomial(dj1, jpm123) / (
        unsafe_fbinomial(j156 + 1, dj1 + 1) * unsafe_fbinomial(dj1, jpm156) *
        unsafe_fbinomial(j453 + 1, dj4 + 1) * unsafe_fbinomial(dj4, jpm453) *
        unsafe_fbinomial(j426 + 1, dj4 + 1) * unsafe_fbinomial(dj4, jpm426)
    ))
    B = zero(Float64)
    low::Int = max(j123, j453, j426, j156)
    high::Int = min(jpm123 + j453, jpm132 + j426, jpm231 + j156)
    for x = low:high
        B = -B + unsafe_fbinomial(x + 1, j123 + 1) * unsafe_fbinomial(jpm123, x - j453) *
                 unsafe_fbinomial(jpm132, x - j426) * unsafe_fbinomial(jpm231, x - j156)
    end
    return iphase(high) * A * B / (dj4 + 1)
end

function _f9j(dj1::Int, dj2::Int, dj3::Int,
    dj4::Int, dj5::Int, dj6::Int,
    dj7::Int, dj8::Int, dj9::Int)
    check_9j(dj1, dj2, dj3, dj4, dj5, dj6, dj7, dj8, dj9) || return zero(Float64)
    j123::Int = div(dj1 + dj2 + dj3, 2)
    j456::Int = div(dj4 + dj5 + dj6, 2)
    j789::Int = div(dj7 + dj8 + dj9, 2)
    j147::Int = div(dj1 + dj4 + dj7, 2)
    j258::Int = div(dj2 + dj5 + dj8, 2)
    j369::Int = div(dj3 + dj6 + dj9, 2)
    pm123::Int = div(dj1 + dj2 - dj3, 2)
    pm132::Int = div(dj1 + dj3 - dj2, 2)
    pm231::Int = div(dj2 + dj3 - dj1, 2)
    pm456::Int = div(dj4 + dj5 - dj6, 2)
    pm465::Int = div(dj4 + dj6 - dj5, 2)
    pm564::Int = div(dj5 + dj6 - dj4, 2)
    pm789::Int = div(dj7 + dj8 - dj9, 2)
    pm798::Int = div(dj7 + dj9 - dj8, 2)
    pm897::Int = div(dj8 + dj9 - dj7, 2)
    # value in sqrt
    P0_nu = unsafe_fbinomial(j123 + 1, dj1 + 1) * unsafe_fbinomial(dj1, pm123) *
            unsafe_fbinomial(j456 + 1, dj5 + 1) * unsafe_fbinomial(dj5, pm456) *
            unsafe_fbinomial(j789 + 1, dj9 + 1) * unsafe_fbinomial(dj9, pm798)
    P0_de = unsafe_fbinomial(j147 + 1, dj1 + 1) * unsafe_fbinomial(dj1, div(dj1 + dj4 - dj7, 2)) *
            unsafe_fbinomial(j258 + 1, dj5 + 1) * unsafe_fbinomial(dj5, div(dj2 + dj5 - dj8, 2)) *
            unsafe_fbinomial(j369 + 1, dj9 + 1) * unsafe_fbinomial(dj9, div(dj3 + dj9 - dj6, 2))
    P0 = P0_nu / P0_de
    dtl::Int = max(abs(dj2 - dj6), abs(dj4 - dj8), abs(dj1 - dj9))
    dth::Int = min(dj2 + dj6, dj4 + dj8, dj1 + dj9)
    PABC = zero(Float64)
    for dt::Int = dtl:2:dth
        j19t::Int = div(dj1 + dj9 + dt, 2)
        j26t::Int = div(dj2 + dj6 + dt, 2)
        j48t::Int = div(dj4 + dj8 + dt, 2)
        Pt_de = unsafe_fbinomial(j19t + 1, dt + 1) * unsafe_fbinomial(dt, div(dj1 + dt - dj9, 2)) *
                unsafe_fbinomial(j26t + 1, dt + 1) * unsafe_fbinomial(dt, div(dj2 + dt - dj6, 2)) *
                unsafe_fbinomial(j48t + 1, dt + 1) * unsafe_fbinomial(dt, div(dj4 + dt - dj8, 2))
        Pt_de *= (dt + 1)^2
        xl::Int = max(j123, j369, j26t, j19t)
        xh::Int = min(pm123 + j369, pm132 + j26t, pm231 + j19t)
        At = zero(Float64)
        for x = xl:xh
            At = -At + unsafe_fbinomial(x + 1, j123 + 1) * unsafe_fbinomial(pm123, x - j369) *
                       unsafe_fbinomial(pm132, x - j26t) * unsafe_fbinomial(pm231, x - j19t)
        end
        yl::Int = max(j456, j26t, j258, j48t)
        yh::Int = min(pm456 + j26t, pm465 + j258, pm564 + j48t)
        Bt = zero(Float64)
        for y = yl:yh
            Bt = -Bt + unsafe_fbinomial(y + 1, j456 + 1) * unsafe_fbinomial(pm456, y - j26t) *
                       unsafe_fbinomial(pm465, y - j258) * unsafe_fbinomial(pm564, y - j48t)
        end
        zl::Int = max(j789, j19t, j48t, j147)
        zh::Int = min(pm789 + j19t, pm798 + j48t, pm897 + j147)
        Ct = zero(Float64)
        for z = zl:zh
            Ct = -Ct + unsafe_fbinomial(z + 1, j789 + 1) * unsafe_fbinomial(pm789, z - j19t) *
                       unsafe_fbinomial(pm798, z - j48t) * unsafe_fbinomial(pm897, z - j147)
        end
        PABC += (iphase(xh + yh + zh) * At * Bt * Ct) / Pt_de
    end
    return iphase(dth) * sqrt(P0) * PABC
end

function _fm9j(j1::Int, j2::Int, j3::Int, j4::Int, j5::Int, j6::Int, j7::Int, j8::Int, j9::Int)::Float64
    j123::Int = j1 + j2 + j3
    j456::Int = j4 + j5 + j6
    j789::Int = j7 + j8 + j9
    j147::Int = j1 + j4 + j7
    j258::Int = j2 + j5 + j8
    j369::Int = j3 + j6 + j9
    pm123::Int = j1 + j2 - j3
    pm132::Int = j1 + j3 - j2
    pm231::Int = j2 + j3 - j1
    pm456::Int = j4 + j5 - j6
    pm465::Int = j4 + j6 - j5
    pm564::Int = j5 + j6 - j4
    pm789::Int = j7 + j8 - j9
    pm798::Int = j7 + j9 - j8
    pm897::Int = j8 + j9 - j7
    sum = zero(Float64)
    tl::Int = max(abs(j2 - j6), abs(j4 - j8), abs(j1 - j9))
    th::Int = min(j2 + j6, j4 + j8, j1 + j9)
    for t::Int = tl:th
        j19t::Int = j1 + j9 + t
        j26t::Int = j2 + j6 + t
        j48t::Int = j4 + j8 + t
        dt::Int = 2t
        Pt_de = unsafe_fbinomial(j19t + 1, dt + 1) * unsafe_fbinomial(dt, j1 + t - j9) *
                unsafe_fbinomial(j26t + 1, dt + 1) * unsafe_fbinomial(dt, j2 + t - j6) *
                unsafe_fbinomial(j48t + 1, dt + 1) * unsafe_fbinomial(dt, j4 + t - j8)
        Pt_de *= (dt + 1)^2
        xl::Int = max(j123, j369, j26t, j19t)
        xh::Int = min(pm123 + j369, pm132 + j26t, pm231 + j19t)
        At = zero(Float64)
        for x::Int = xl:xh
            At = -At + unsafe_fbinomial(x + 1, j123 + 1) * unsafe_fbinomial(pm123, x - j369) *
                       unsafe_fbinomial(pm132, x - j26t) * unsafe_fbinomial(pm231, x - j19t)
        end
        yl::Int = max(j456, j26t, j258, j48t)
        yh::Int = min(pm456 + j26t, pm465 + j258, pm564 + j48t)
        Bt = zero(Float64)
        for y::Int = yl:yh
            Bt = -Bt + unsafe_fbinomial(y + 1, j456 + 1) * unsafe_fbinomial(pm456, y - j26t) *
                       unsafe_fbinomial(pm465, y - j258) * unsafe_fbinomial(pm564, y - j48t)
        end
        zl::Int = max(j789, j19t, j48t, j147)
        zh::Int = min(pm789 + j19t, pm798 + j48t, pm897 + j147)
        Ct = zero(Float64)
        for z::Int = zl:zh
            Ct = -Ct + unsafe_fbinomial(z + 1, j789 + 1) * unsafe_fbinomial(pm789, z - j19t) *
                       unsafe_fbinomial(pm798, z - j48t) * unsafe_fbinomial(pm897, z - j147)
        end
        sum += iphase(xh + yh + zh) * At * Bt * Ct / Pt_de
    end
    return sum
end

function _fMoshinsky(N::Int, L::Int, n::Int, l::Int, n1::Int, l1::Int, n2::Int, l2::Int, Λ::Int, tanβ::Float64)
    check_Moshinsky(N, L, n, l, n1, l1, n2, l2, Λ) || return zero(Float64)
    e1 = 2 * n1 + l1
    e2 = 2 * n2 + l2
    E = 2 * N + L
    e = 2 * n + l
    χ = e1 + e2
    nl1 = n1 + l1
    nl2 = n2 + l2
    NL = N + L
    nl = n + l

    cosβ = 1 / sqrt(1 + tanβ^2)
    sinβ = tanβ * cosβ
    pre = unsafe_fbinomial(χ + 2, e1 + 1) / unsafe_fbinomial(χ + 2, E + 1)
    pre *= unsafe_fbinomial(L + l + Λ + 1, 2Λ + 1) * unsafe_fbinomial(2Λ, Λ + L - l)
    pre /= unsafe_fbinomial(l1 + l2 + Λ + 1, 2Λ + 1) * unsafe_fbinomial(2Λ, Λ + l1 - l2)

    pre *= (2l1 + 1) * unsafe_fbinomial(2nl1 + 1, nl1) / (unsafe_fbinomial(e1 + 1, n1) * 2^l1)
    pre *= (2l2 + 1) * unsafe_fbinomial(2nl2 + 1, nl2) / (unsafe_fbinomial(e2 + 1, n2) * 2^l2)
    pre *= (2L + 1) * unsafe_fbinomial(2NL + 1, NL) / (unsafe_fbinomial(E + 1, N) * 2^L)
    pre *= (2l + 1) * unsafe_fbinomial(2nl + 1, nl) / (unsafe_fbinomial(e + 1, n) * 2^l)
    pre = sqrt(pre) / ((e1 + 2) * (e2 + 2))

    sum = zero(Float64)
    for ea = 0:min(e1, E)
        eb = e1 - ea
        ec = E - ea
        ed = e2 - ec
        ed < 0 && continue
        tfa = sinβ^(ea + ed) * cosβ^(eb + ec) * unsafe_fbinomial(e1 + 2, ea + 1) * unsafe_fbinomial(e2 + 2, ec + 1)
        for la = rem(ea, 2):2:ea
            na = div(ea - la, 2)
            nla = na + la
            ta = 2^la * (2la + 1) * unsafe_fbinomial(ea + 1, na) / unsafe_fbinomial(2nla + 1, nla)
            ta = tfa * ta
            for lb = abs(l1 - la):2:min(l1 + la, eb)
                nb = div(eb - lb, 2)
                nlb = nb + lb
                tb = 2^lb * (2lb + 1) * unsafe_fbinomial(eb + 1, nb) / unsafe_fbinomial(2nlb + 1, nlb)
                g1 = div(la + lb + l1, 2)
                t1 = unsafe_fbinomial(g1, l1) * unsafe_fbinomial(l1, g1 - la)
                tb = ta * tb * t1
                for lc = abs(L - la):2:min(L + la, ec)
                    nc = div(ec - lc, 2)
                    nlc = nc + lc
                    tc = 2^lc * (2lc + 1) * unsafe_fbinomial(ec + 1, nc) / unsafe_fbinomial(2nlc + 1, nlc)
                    g3 = div(la + lc + L, 2)
                    t3 = unsafe_fbinomial(g3, L) * unsafe_fbinomial(L, g3 - la)
                    Δ3 = (2L + 1) * unsafe_fbinomial(la + lc + L + 1, 2L + 1) * unsafe_fbinomial(2L, L + la - lc)
                    tc = tb * tc * t3 / Δ3
                    ldmin = max(abs(l2 - lc), abs(l - lb))
                    ldmax = min(ed, l2 + lc, l + lb)
                    for ld = ldmin:2:ldmax
                        nd = div(ed - ld, 2)
                        nld = nd + ld
                        td = 2^ld * (2ld + 1) * unsafe_fbinomial(ed + 1, nd) / unsafe_fbinomial(2nld + 1, nld)
                        g2 = div(lc + ld + l2, 2)
                        t2 = unsafe_fbinomial(g2, l2) * unsafe_fbinomial(l2, g2 - lc)
                        g4 = div(lb + ld + l, 2)
                        t4 = unsafe_fbinomial(g4, l) * unsafe_fbinomial(l, g4 - lb)
                        Δ4 = (2l + 1) * unsafe_fbinomial(lb + ld + l + 1, 2l + 1) * unsafe_fbinomial(2l, l + lb - ld)
                        td = tc * td * t2 * t4 / Δ4
                        m9j = _fm9j(la, lb, l1, lc, ld, l2, L, l, Λ)
                        sum += iphase(ld) * td * m9j
                    end
                end
            end
        end
    end
    return pre * sum
end

function _dfunc(dj::Int, dm1::Int, dm2::Int, β::Float64)
    check_jm(dj, dm1) && check_jm(dj, dm2) || return zero(Float64)
    jm1 = div(dj - dm1, 2)
    jp1 = div(dj + dm1, 2)
    jm2 = div(dj - dm2, 2)
    mm = div(dm1 + dm2, 2)
    s, c = sincos(β)
    kmin = max(0, -mm)
    kmax = min(jm1, jm2)
    sum = 0.0
    for k = kmin:kmax
        sum = -sum + unsafe_fbinomial(jm1, k) * unsafe_fbinomial(jp1, mm + k) * c^(mm + 2k) * s^(jm1 + jm2 - 2k)
    end
    sum = iphase(jm2 + kmax) * sum
    sum = sum * √(unsafe_fbinomial(dj, jm1) / unsafe_fbinomial(dj, jm2))
    return sum
end

function _flsjj(l1::Int, l2::Int, dj1::Int, dj2::Int, L::Int, S::Int, J::Int)::Float64
    check_couple(2l1, 2l2, 2L) || return zero(Float64)
    check_couple(dj1, dj2, 2J) || return zero(Float64)
    LSJcase = 0
    if S == 0
        LSJcase = 1
    elseif S == 1
        (L == J - 1) && (LSJcase = 2)
        (J == L) && (LSJcase = 3)
        (L == J + 1) && (LSJcase = 4)
    end
    iszero(LSJcase) && return zero(Float64)
    m = l1 - l2
    p = l1 + l2
    δ1 = dj1 - 2l1
    δ2 = dj2 - 2l2
    d = 2*(2l1+1)*(2l2+1)
    r = zero(Float64)
    if δ1 == 1 && δ2 == 1
        if LSJcase == 1
            r = (J + p + 2) * (p + 1 - J) / d
        elseif LSJcase == 2
            r = (J + m) * (J - m) / (J * (2J + 1))
            r *= (J + p + 1) * (J + p + 2) / d
        elseif LSJcase == 3
            m == 0 && return zero(Float64)
            r = m * abs(m) / (J * (J + 1))
            r *= (J + p + 2) * (p + 1 - J) / d
        elseif LSJcase == 4
            r = -(L + m) * (L - m) / (L * (2J + 1))
            r *= (p - J) * (p + 1 - J) / d
        end
    elseif δ1 == 1 && δ2 == -1
        if LSJcase == 1
            r = (J + m + 1) * (J - m) / d
        elseif LSJcase == 2
            r = -(p + 1 + J) * (p + 1 - J) / (J * (2J + 1))
            r *= (J + m + 1) * (J + m) / d
        elseif LSJcase == 3
            r = (p + 1) * (p + 1) / (J * (J + 1))
            r *= (J + m + 1) * (J - m) / d
        elseif LSJcase == 4
            r = -(p + 1 + L) * (p + 1 - L) / (L * (2J + 1))
            r *= (J - m + 1) * (J - m) / d
        end
    elseif δ1 == -1 && δ2 == 1
        if LSJcase == 1
            r = -(J + m) * (J - m + 1) / d
        elseif LSJcase == 2
            r = (p + 1 + J) * (p + 1 - J) / (J * (2J + 1))
            r *= (J - m) * (J - m + 1) / d
        elseif LSJcase == 3
            r = (p + 1) * (p + 1) / (J * (J + 1))
            r *= (J + m) * (J - m + 1) / d
        elseif LSJcase == 4
            r = (p + 1 + L) * (p + 1 - L) / (L * (2J + 1))
            r *= (J + m + 1) * (J + m) / d
        end
    elseif δ1 == -1 && δ2 == -1
        if LSJcase == 1
            r = (J + p + 1) * (p - J) / d
        elseif LSJcase == 2
            r = -(J + m) * (J - m) / (J * (2J + 1))
            r *= (p - J) * (p + 1 - J) / d
        elseif LSJcase == 3
            m == 0 && return zero(Float64)
            r = -m * abs(m) / (J * (J + 1))
            r *= (J + p + 1) * (p - J) / d
        elseif LSJcase == 4
            r = (L + m) * (L - m) / (L * (2J + 1))
            r *= (J + p + 1) * (J + p + 2) / d
        end
    end
    return copysign(sqrt(abs(r)), r)
end

"""
    fCG(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer)
float64 and fast CG coefficient.
"""
@inline function fCG(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer)
    return _fCG(Int.((dj1, dj2, dj3, dm1, dm2, dm3))...)
end

"""
    fCG0(dj1::Integer, dj2::Integer, dj3::Integer)
float64 and fast CG coefficient for `m1 == m2 == m3 == 0`.
"""
@inline function fCG0(dj1::Integer, dj2::Integer, dj3::Integer)
    return _fCG0(Int.((dj1, dj2, dj3))...)
end

"""
    fCGspin(ds1::Integer, ds2::Integer, S::Integer)
float64 and fast CG coefficient for two spin-1/2 coupling.
"""
@inline function fCGspin(ds1::Integer, ds2::Integer, S::Integer)
    unsigned(S) > 1 && return zero(Float64)
    (abs(ds1) != 1 || abs(ds2) != 1) && return zero(Float64)
    if iszero(S)
        return ds1 == ds2 ? 0.0 : copysign(1 / √2, ds1)
    else # S = 1
        return ds1 == ds2 ? 1.0 : 1 / √2
    end
end

# i1 = ds1 > 0, i2 = ds2 > 0, i3 = S > 0, is = (S12 + dS) / 2
# (i1, i2, i3, is) -> 3 * (4 * i1 + 2 * i2 + i3) + is
const CG3spin_data = [
    0.0,                 # (-1/2, -1/2, -1/2,   0,  1/2) -> 0
    0.0,                 # (-1/2, -1/2, -1/2,   1,  1/2) -> 0
    1.0,                 # (-1/2, -1/2, -1/2,   1,  3/2) -> 1
    0.0,                 # (-1/2, -1/2,  1/2,   0,  1/2) -> 0
    -0.816496580927726,  # (-1/2, -1/2,  1/2,   1,  1/2) -> -sqrt(2/3)
    0.5773502691896257,  # (-1/2, -1/2,  1/2,   1,  3/2) -> sqrt(1/3)
    -0.7071067811865476, # (-1/2,  1/2, -1/2,   0,  1/2) -> -sqrt(1/2)
    0.408248290463863,   # (-1/2,  1/2, -1/2,   1,  1/2) -> sqrt(1/6)
    0.5773502691896257,  # (-1/2,  1/2, -1/2,   1,  3/2) -> sqrt(1/3)
    -0.7071067811865476, # (-1/2,  1/2,  1/2,   0,  1/2) -> -sqrt(1/2)
    -0.408248290463863,  # (-1/2,  1/2,  1/2,   1,  1/2) -> -sqrt(1/6)
    0.5773502691896257,  # (-1/2,  1/2,  1/2,   1,  3/2) -> sqrt(1/3)
    0.7071067811865476,  # ( 1/2, -1/2, -1/2,   0,  1/2) -> sqrt(1/2)
    0.408248290463863,   # ( 1/2, -1/2, -1/2,   1,  1/2) -> sqrt(1/6)
    0.5773502691896257,  # ( 1/2, -1/2, -1/2,   1,  3/2) -> sqrt(1/3)
    0.7071067811865476,  # ( 1/2, -1/2,  1/2,   0,  1/2) -> sqrt(1/2)
    -0.408248290463863,  # ( 1/2, -1/2,  1/2,   1,  1/2) -> -sqrt(1/6)
    0.5773502691896257,  # ( 1/2, -1/2,  1/2,   1,  3/2) -> sqrt(1/3)
    0.0,                 # ( 1/2,  1/2, -1/2,   0,  1/2) -> 0
    0.816496580927726,   # ( 1/2,  1/2, -1/2,   1,  1/2) -> sqrt(2/3)
    0.5773502691896257,  # ( 1/2,  1/2, -1/2,   1,  3/2) -> sqrt(1/3)
    0.0,                 # ( 1/2,  1/2,  1/2,   0,  1/2) -> 0
    0.0,                 # ( 1/2,  1/2,  1/2,   1,  1/2) -> 0
    1.0                  # ( 1/2,  1/2,  1/2,   1,  3/2) -> 1
]

"""
    fCG3spin(ds1::Integer, ds2::Integer, ds3::Integer, S12::Integer, dS::Integer)
float64 and fast CG coefficient for three spin-1/2 coupling: <S12,M12|1/2,m1;1/2,m2><S,M|S12,M12;1/2,m3>
"""
function fCG3spin(ds1::Integer, ds2::Integer, ds3::Integer, S12::Integer, dS::Integer)::Float64
    unsigned(S12) > 1 && return zero(Float64)
    (S12 == 0 && dS != 1) && return zero(Float64)
    (S12 == 1 && (dS != 1 && dS != 3)) && return zero(Float64)
    (abs(ds1) != 1 || abs(ds2) != 1 || abs(ds3) != 1) && return zero(Float64)
    return CG3spin_data[3 * (2ds1 + ds2 + div(ds3 + 1, 2)) + div(S12 + dS, 2) + 10]
end


"""
    f3j(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer)
float64 and fast Wigner 3j symbol.
"""
@inline function f3j(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer)
    return _f3j(Int.((dj1, dj2, dj3, dm1, dm2, dm3))...)
end

"""
    f6j(dj1::Integer, dj2::Integer, dj3::Integer, dj4::Integer, dj5::Integer, dj6::Integer)
float64 and fast Wigner 6j symbol.
"""
@inline function f6j(dj1::Integer, dj2::Integer, dj3::Integer, dj4::Integer, dj5::Integer, dj6::Integer)
    return _f6j(Int.((dj1, dj2, dj3, dj4, dj5, dj6))...)
end

"""
    Racah(dj1::Integer, dj2::Integer, dj3::Integer, dj4::Integer, dj5::Integer, dj6::Integer)
float64 and fast Racah coefficient.
"""
@inline function fRacah(dj1::Integer, dj2::Integer, dj3::Integer, dj4::Integer, dj5::Integer, dj6::Integer)
    return iphase(div(dj1 + dj2 + dj3 + dj4, 2)) * f6j(dj1, dj2, dj5, dj4, dj3, dj6)
end

"""
    f9j(dj1::Integer, dj2::Integer, dj3::Integer,
        dj4::Integer, dj5::Integer, dj6::Integer,
        dj7::Integer, dj8::Integer, dj9::Integer)
float64 and fast Wigner 9j symbol.
"""
@inline function f9j(dj1::Integer, dj2::Integer, dj3::Integer,
    dj4::Integer, dj5::Integer, dj6::Integer,
    dj7::Integer, dj8::Integer, dj9::Integer)
    return _f9j(Int.((dj1, dj2, dj3, dj4, dj5, dj6, dj7, dj8, dj9))...)
end

"""
    fnorm9j(dj1::Integer, dj2::Integer, dj3::Integer,
            dj4::Integer, dj5::Integer, dj6::Integer,
            dj7::Integer, dj8::Integer, dj9::Integer)
float64 and fast normalized Wigner 9j symbol.
"""
@inline function fnorm9j(dj1::Integer, dj2::Integer, dj3::Integer,
    dj4::Integer, dj5::Integer, dj6::Integer,
    dj7::Integer, dj8::Integer, dj9::Integer)
    return sqrt((dj3 + 1.0) * (dj6 + 1.0) * (dj7 + 1.0) * (dj8 + 1.0)) * f9j(dj1, dj2, dj3, dj4, dj5, dj6, dj7, dj8, dj9)
end

"""
    lsjj(l1::Integer, l2::Integer, dj1::Integer, dj2::Integer, L::Integer, S::Integer, J::Integer)
float64 and fast lsjj coefficient.
"""
@inline function flsjj(l1::Integer, l2::Integer, dj1::Integer, dj2::Integer, L::Integer, S::Integer, J::Integer)
    return _flsjj(Int.((l1, l2, dj1, dj2, L, S, J))...)
end


"""
    fMoshinsky(N::Integer, L::Integer, n::Integer, l::Integer, n1::Integer, l1::Integer, n2::Integer, l2::Integer, tanβ::Float64 = 1.0)
float64 and fast Moshinsky bracket.
"""
@inline function fMoshinsky(N::Integer, L::Integer, n::Integer, l::Integer, n1::Integer, l1::Integer, n2::Integer, l2::Integer, Λ::Integer, tanβ::Float64=1.0)
    return _fMoshinsky(Int.((N, L, n, l, n1, l1, n2, l2, Λ))..., tanβ)
end

"""
    dfunc(dj::Integer, dm1::Integer, dm2::Integer, β::Float64)
Wigner d-function.
"""
@inline function dfunc(dj::Integer, dm1::Integer, dm2::Integer, β::Float64)
    return _dfunc(Int.((dj, dm1, dm2))..., β)
end

# this file test the orthonormality of Wigner symbols
# All formulat are refered in
# [1] D. A. Varshalovich, A. N. Moskalev and V. K. Khersonskii, Quantum Theory of Angular Momentum, (World Scientific, 1988).

# Ref[1], P236, Sec 8.1, Formula (8)
function test_orthonormality_dCG(test_range::AbstractArray)
    # Formula (8) first part
    for dj1 in test_range
    for dj2 in test_range
    for dj3 in test_range
    for dj4 in test_range
        if check_couple(dj1, dj2, dj3) && check_couple(dj1, dj2, dj4)
            for dm3 = -min(dj3,dj4):2:min(dj3,dj4)
                sum = zero(SqrtRational)
                for dm1 = -dj1:2:dj1
                    dm2 = dm3 - dm1
                    if check_jm(dj2, dm2)
                        sum += dCG(dj1,dj2,dj3,dm1,dm2,dm3) * dCG(dj1,dj2,dj4,dm1,dm2,dm3)
                    end
                end
                @test sum == Int(dj3==dj4)
            end
        end
    end end end end
    # Formula (8) second part
    for dj1 in test_range
    for dj2 in test_range
        for dm1 = -dj1:2:dj1
        for dm2 = -dj2:2:dj2
        for dm3 = -dj1:2:dj1
            dm = dm1 + dm2
            dm4 = dm - dm3
            sum = zero(SqrtRational)
            for dj3 = abs(dj1-dj2):2:(dj1+dj2)
                if check_jm(dj2, dm4) && check_jm(dj3, dm)
                    sum += dCG(dj1,dj2,dj3,dm1,dm2,dm) * dCG(dj1,dj2,dj3,dm3,dm4,dm)
                end
            end
            @test sum == Int(dm1 == dm3)
        end end end
    end end
end

# Ref[1], P453, Sec 12.1, Formula (2)
function test_summation_d3j(test_range::AbstractArray)
    for dj1 = test_range
    for dj3 = 0:maximum(test_range)
        check_couple(dj1, dj1, dj3) || continue
        sum = zero(SqrtRational)
        for dm1 = -dj1:2:dj1
            sum += iphase(div(dj1-dm1, 2)) * d3j(dj1,dj1,dj3,dm1,-dm1,0)
        end
        @test sum == exact_sqrt(dj1+1) * Int(dj3==0)
    end end
end

# Ref[1], P291, Sec 9.1, Formula(9)
function test_orthonormality_d6j(test_range::AbstractArray)
    for dj1 in test_range
    for dj2 in test_range
    for dj4 in test_range
    for dj5 in test_range
    for dj6 in test_range
    for dj7 in test_range
        is_same_parity(dj6, dj7) || continue
        check_couple(dj1, dj5, dj6) || continue
        check_couple(dj1, dj5, dj7) || continue
        check_couple(dj4, dj2, dj6) || continue
        check_couple(dj4, dj2, dj7) || continue
        is_same_parity(dj1 + dj2, dj4 + dj5) || continue
        sum = zero(SqrtRational)
        djmin = max(abs(dj1-dj2), abs(dj4-dj5))
        djmax = min(dj1+dj2, dj4+dj5)
        for dj3 = djmin:2:djmax
            sum += (dj3+1) * (dj6+1) * (
                d6j(dj1,dj2,dj3,dj4,dj5,dj6) * d6j(dj1,dj2,dj3,dj4,dj5,dj7)
            )
        end
        @test sum == Int(dj6==dj7)
    end end end end end end
end

# Ref[1], P335, Sec 10.1, Formula (9)
function test_orthonormality_d9j(test_range::AbstractArray)
    for a in test_range
    for b in test_range
    for c in test_range
    for d in test_range
    for e in test_range
    for f in test_range
    for cx in test_range
    for fx in test_range
    for j in test_range
        is_same_parity(c, cx) || continue
        is_same_parity(f, fx) || continue
        check_couple(a, b, c) || continue
        check_couple(a, b, cx) || continue
        check_couple(d, e, f) || continue
        check_couple(d, e, fx) || continue
        check_couple(c, f, j) || continue
        check_couple(cx, fx, j) || continue
        sum = zero(SqrtRational)
        for g in abs(a-d):2:(a+d)
        for h in abs(b-e):2:(b+e)
            if check_couple(g, h, j)
                sum += (g+1)*(h+1)*(
                    d9j(a,b,c,d,e,f,g,h,j) * d9j(a,b,cx,d,e,fx,g,h,j)
                )
            end
        end end
        if (c==cx) && (f==fx)
            @test sum == 1//((c+1)*(f+1))
        else
            @test sum == 0
        end
    end end end end end end end end end
end

using Documenter
push!(LOAD_PATH, "..")
using CGcoefficient

makedocs(
    modules = [CGcoefficient],
    sitename = "CGcoefficient.jl",
    clean = false,
    pages = [
        "Home" => "index.md",
        "API" => "api.md",
        "Formula" => [
            "Wigner Symbols" => "wigner.md",
            "LS-jj recoupling" => "lsjj.md",
            "Moshinsky" => "moshinsky.md",
            "Prime Factorization" => "pfrational.md",
        ],
    ]
)

deploydocs(
    repo = "github.com/0382/CGcoefficient.jl.git",
    target = "build/"
)

# this file test the validity by comparing with the widely used `libgsl`

# wapper of gsl 3nj functions
function gsl3j(dj1::Int, dj2::Int, dj3::Int, dm1::Int, dm2::Int, dm3::Int)
    ccall(
        (:gsl_sf_coupling_3j, "libgsl"),
        Cdouble,
        (Cint, Cint, Cint, Cint, Cint, Cint),
        dj1, dj2, dj3, dm1, dm2, dm3
    )
end

function gsl6j(dj1::Int, dj2::Int, dj3::Int, dj4::Int, dj5::Int, dj6::Int)
    ccall(
        (:gsl_sf_coupling_6j, "libgsl"),
        Cdouble,
        (Cint, Cint, Cint, Cint, Cint, Cint),
        dj1, dj2, dj3, dj4, dj5, dj6
    )
end

function gsl9j(dj1::Int, dj2::Int, dj3::Int,
                dj4::Int, dj5::Int, dj6::Int,
                dj7::Int, dj8::Int, dj9::Int)
    ccall(
        (:gsl_sf_coupling_9j, "libgsl"),
        Cdouble,
        (Cint, Cint, Cint, Cint, Cint, Cint, Cint, Cint, Cint),
        dj1, dj2, dj3, dj4, dj5, dj6, dj7, dj8, dj9
    )
end

# Because the gsl compute wigner 3nj symbols using float point number,
# sometimes my code give out zero, but gsl give out a very small number.
# In this condition, `≈` operator will give false result.
function test_3j_with_gsl(test_range::AbstractArray)
    for dj1 in test_range
    for dj2 in test_range
    for dj3 in test_range
    for dm1 in -dj1:2:dj1
    for dm2 in -dj2:2:dj2
        dm3 = -dm1-dm2
        if check_couple(dj1, dj2, dj3) & check_jm(dj3, dm3)
            gsl = gsl3j(dj1, dj2, dj3, dm1, dm2, dm3)
            my = float(d3j(dj1, dj2, dj3, dm1, dm2, dm3))
            @test (my == 0 && gsl < 1e-10) || (gsl ≈ my)
        end
    end end end end end
end

function test_6j_with_gsl(test_range::AbstractArray)
    for j1 in test_range
    for j2 in test_range
    for j3 in test_range
    for j4 in test_range
    for j5 in test_range
    for j6 in test_range
        if check_6j(j1, j2, j3, j4, j5, j6)
            gsl = gsl6j(j1, j2, j3, j4, j5, j6)
            my = float(d6j(j1,j2,j3,j4,j5,j6))
            @test (my == 0 && gsl < 1e-10) || (gsl ≈ my)
        end
    end end end end end end
end

function test_9j_with_gsl(test_range::AbstractArray)
    for j1 in test_range
    for j2 in test_range
    for j3 in test_range
    for j4 in test_range
    for j5 in test_range
    for j6 in test_range
    for j7 in test_range
    for j8 in test_range
    for j9 in test_range
        if check_9j(j1,j2,j3,j4,j5,j6,j7,j8,j9)
            gsl = gsl9j(j1,j2,j3,j4,j5,j6,j7,j8,j9)
            my = float(d9j(j1,j2,j3,j4,j5,j6,j7,j8,j9))
            @test (my == 0 && gsl < 1e-10) | (gsl ≈ my)
        end
    end end end end end end end end end
end

import Base:*,/,^

@doc raw"""
    PFRational{T<:Integer} <: Real
A positive rational number in prime factorization form.
```math
q = \prod_{i=1}^{n} p_i^{e_i}
```
where ``p_i`` is the ``i``-th prime number and ``e_i`` can be negative.
"""
struct PFRational{T<:Integer} <: Real
    e::Vector{T}
    PFRational{T}(e::Vector{T}) where {T} = new{T}(e)
end

PFRational(e::Vector{T}) where {T<:Integer} = PFRational{T}(e)

Base.one(::Type{PFRational{T}}) where {T<:Integer} = PFRational{T}(zeros(T, 0))
Base.copy(x::PFRational) = PFRational(copy(x.e))
Base.eltype(::Type{PFRational{T}}) where {T<:Integer} = T

pf_alloc(T::Type{<:Integer}, n::Integer) = PFRational{T}(zeros(T, n))
pf_alloc!(x::PFRational{T}, n::Integer) where {T<:Integer} = begin
    resize!(x.e, n)
    fill!(x.e, T(0))
end

Base.inv(x::PFRational) = PFRational(-x.e)

*(x::PFRational, y::PFRational) = begin
    T = promote_type(eltype(x.e), eltype(y.e))
    e = zeros(T, max(length(x.e), length(y.e)))
    copyto!(e, x.e)
    for i in eachindex(y.e)
        e[i] += y.e[i]
    end
    return PFRational{T}(e)
end

/(x::PFRational, y::PFRational) = begin
    T = promote_type(eltype(x.e), eltype(y.e))
    e = zeros(T, max(length(x.e), length(y.e)))
    copyto!(e, x.e)
    for i in eachindex(y.e)
        e[i] -= y.e[i]
    end
    return PFRational{T}(e)
end

^(x::PFRational, n::Integer) = PFRational(x.e .* n)
square!(x::PFRational) = begin
    for i in eachindex(x.e)
        x.e[i] *= 2
    end
end

"""
    gcd(x::PFRational, y::PFRational)
gcd of rational means gcd of numerator and lcm of denominator
"""
Base.gcd(x::PFRational, y::PFRational) = begin
    T = promote_type(eltype(x.e), eltype(y.e))
    e = zeros(T, max(length(x.e), length(y.e)))
    copyto!(e, x.e)
    for i in eachindex(y.e)
        e[i] = min(e[i], y.e[i])
    end
    return PFRational{T}(e)
end

"""
    lcm(x::PFRational, y::PFRational)
lcm of rational means lcm of numerator and gcd of denominator
"""
Base.lcm(x::PFRational, y::PFRational) = begin
    T = promote_type(eltype(x.e), eltype(y.e))
    e = zeros(T, max(length(x.e), length(y.e)))
    copyto!(e, x.e)
    for i in eachindex(y.e)
        e[i] = max(e[i], y.e[i])
    end
    return PFRational{T}(e)
end

# assume length(y) <= length(x)
_copy!(x::PFRational{T}, y::PFRational{T}) where {T<:Integer} = begin
    for i in eachindex(y.e)
        x.e[i] = y.e[i]
    end
    for i in length(y.e)+1:length(x.e)
        x.e[i] = 0
    end
end

# assume length(y) <= length(x)
_mul!(x::PFRational{T}, y::PFRational{T}) where {T<:Integer} = begin
    for i in eachindex(y.e)
        x.e[i] += y.e[i]
    end
end

# assume length(y) <= length(x)
_div!(x::PFRational{T}, y::PFRational{T}) where {T<:Integer} = begin
    for i in eachindex(y.e)
        x.e[i] -= y.e[i]
    end
end

# assume length(y) <= length(x)
_gcd!(x::PFRational{T}, y::PFRational{T}) where {T<:Integer} = begin
    for i in eachindex(y.e)
        x.e[i] = min(x.e[i], y.e[i])
    end
    for i in length(y.e)+1:length(x.e)
        x.e[i] = min(x.e[i], 0)
    end
end

# positive integers in prime factorization form
_pf_integers = PFRational{Int16}[one(PFRational{Int16})]
# binomial coefficients in prime factorization form
_pf_bin_data = PFRational{Int16}[one(PFRational{Int16})]
# maximum `n` for binomial coefficients
_pf_bin_nmax = Int(0)

function _extend_pf_integers(n::Integer)
    n <= length(_pf_integers) && return
    _extend_prime_table_to(n)
    sizehint!(_pf_integers, n)
    maxsize = length(_prime_table)
    e = zeros(Int16, maxsize)
    for i in length(_pf_integers)+1:n
        fill!(e, Int16(0))
        idx = 0
        t = i
        while t > 1
            idx += 1
            p = nth_stored_prime(idx)
            while t % p == 0
                e[idx] += 1
                t = div(t, p)
            end
        end
        push!(_pf_integers, PFRational{Int16}(deepcopy(e[1:idx])))
    end
end

@inline pf_int(n::Integer)::PFRational{Int16} = _pf_integers[n]::PFRational{Int16}
@inline pf_bin_nmax()::Int = _pf_bin_nmax::Int
@inline pf_bin_data()::Vector{PFRational{Int16}} = _pf_bin_data::Vector{PFRational{Int16}}
@inline function _pf_bin(n::Integer, k::Integer)::PFRational{Int16}
    k = min(k, n - k)
    return @inbounds pf_bin_data()[binomial_index(n, k)]
end

"""
    pf_binomial(n::Integer, k::Integer)::PFRational{Int16}
Return the stored binomial coefficient `C(n, k)` in prime factorization form.
"""
function pf_binomial(n::Integer, k::Integer)::PFRational{Int16}
    0 <= k <= n <= pf_bin_nmax() || throw(ArgumentError("invalid binomial arguments"))
    k = min(k, n - k)
    return pf_bin_data()[binomial_index(n, k)]
end


function _extend_pf_binomial(n::Integer)
    n <= pf_bin_nmax() && return
    _extend_prime_table_to(n)
    _extend_pf_integers(n)
    sizehint!(_pf_bin_data, binomial_data_size(n))
    pf = pf_alloc(Int16, length(_prime_table))
    for i in pf_bin_nmax()+1:n
        fill!(pf.e, Int16(0))
        push!(_pf_bin_data, one(PFRational{Int16}))
        for j in 1:div(i, 2)
            _mul!(pf, pf_int(i - j + 1))
            _div!(pf, pf_int(j))
            size = length(pf.e)
            while size > 0 && pf.e[size] == 0
                size -= 1
            end
            push!(_pf_bin_data, PFRational{Int16}(deepcopy(pf.e[1:size])))
        end
    end
    global _pf_bin_nmax = n
end

_numerator!(num::BigInt, x::PFRational) = begin
    MPZ.set_ui!(num, 1)
    for i in eachindex(x.e)
        if x.e[i] > 0
            mul_p_pow_k!(num, i, convert(Int, x.e[i]))
        end
    end
    return num
end

_denominator!(den::BigInt, x::PFRational) = begin
    MPZ.set_ui!(den, 1)
    for i in eachindex(x.e)
        if x.e[i] < 0
            mul_p_pow_k!(den, i, -convert(Int, x.e[i]))
        end
    end
    return den
end

_rational!(num::BigInt, den::BigInt, x::PFRational) = begin
    MPZ.set_ui!(num, 1)
    MPZ.set_ui!(den, 1)
    for i in eachindex(x.e)
        if x.e[i] > 0
            mul_p_pow_k!(num, i, convert(Int, x.e[i]))
        elseif x.e[i] < 0
            mul_p_pow_k!(den, i, -convert(Int, x.e[i]))
        end
    end
end

Base.numerator(x::PFRational) = _numerator!(BigInt(0), x)
Base.denominator(x::PFRational) = _denominator!(BigInt(0), x)

Base.convert(::Type{Rational}, x::PFRational) = begin
    num = BigInt(0)
    den = BigInt(0)
    _rational!(num, den, x)
    return Base.unsafe_rational(num, den)
end

"""
    wigner_init_pf(n::Integer, mode::AbstractString, rank::Integer)
Initialize the prime factorization tables for Wigner symbols.
The parameters are similar to `wigner_inif_float`.
You must call this function before using the `e` and `ef` versions of Wigner symbols.
"""
function wigner_init_pf(n::Integer, mode::AbstractString, rank::Integer)
    nmax = 0
    if mode == "Jmax"
        rank == 3 && (nmax = 3n + 1)
        rank == 6 && (nmax = 4n + 1)
        rank == 9 && (nmax = 5n + 1)
        (rank != 3 && rank != 6 && rank != 9) && throw(ArgumentError("invalid rank: $rank"))
    elseif mode == "2bjmax"
        rank == 3 && (nmax = 2n + 1)
        rank == 6 && (nmax = 3n + 1)
        rank == 9 && (nmax = 4n + 1)
        (rank != 3 && rank != 6 && rank != 9) && throw(ArgumentError("invalid rank: $rank"))
    elseif mode == "nmax"
        nmax = n
        rank = 3
    else
        throw(ArgumentError("invalid mode: $mode"))
    end
    # this is just a rough guess, if it throws an error, we can increase it
    approx_times = Dict(3=>8, 6=>10, 9=>12)
    _extend_prime_table_to(nmax)
    size = length(_prime_table)
    _extend_prime_pow_table(size, nmax, get(approx_times, rank, 8))
    _extend_pf_integers(nmax)
    _extend_pf_binomial(nmax)
    nothing
end

import Base: +, -, *, /, ==
using Markdown

"""
    SqrtRational <: Real
Store exact value of a `Rational`'s square root.
It is stored in `s√r` format, and we do not simplify it during arithmetics.
You can use the `simplify` function to simplify it.
"""
struct SqrtRational{T} <: Real
    s::Rational{T}
    r::Rational{T}
    SqrtRational{T}(s::Rational{T}, r::Rational{T}) where {T} = begin
        r < 0 && throw(ArgumentError("invalid SqrtRational $s√$r"))
        (iszero(s) || iszero(r)) && return new(zero(s), one(r))
        new(s, r)
    end
end

SqrtRational(s::Rational{T1}, r::Rational{T2}) where {T1,T2} = SqrtRational{promote_type(T1, T2)}(promote(s, r)...)
SqrtRational(s::Integer, r::Rational{T}) where {T} = SqrtRational(promote(s, r)...)
SqrtRational(s::Rational{T}, r::Integer) where {T} = SqrtRational(promote(s, r)...)
SqrtRational(s::Integer, r::Integer) = SqrtRational(promote(Rational(s), r)...)
SqrtRational(s::Union{Integer,Rational}) = SqrtRational(s, one(s))

"""
    exact_sqrt(r::Union{Integer, Rational})
Get exact `√r` using `SqrtRational` type.
"""
exact_sqrt(r::Union{Integer,Rational}) = SqrtRational(one(r), r)

# some basic functions
Base.zero(::Type{SqrtRational{T}}) where {T} = SqrtRational(zero(T), one(T))
Base.one(::Type{SqrtRational{T}}) where {T} = SqrtRational(one(T), one(T))
Base.zero(x::SqrtRational) = zero(typeof(x))
Base.one(x::SqrtRational) = one(typeof(x))
Base.sign(x::SqrtRational) = sign(x.s)
Base.signbit(x::SqrtRational) = signbit(x.s)
Base.inv(x::SqrtRational) = SqrtRational(inv(x.s), inv(x.r))
Base.copy(x::SqrtRational) = SqrtRational(deepcopy(x.s), deepcopy(x.r))

# override some operators
+(x::SqrtRational) = x
-(x::SqrtRational) = SqrtRational(-x.s, x.r)
*(x::SqrtRational, y::SqrtRational) = SqrtRational(x.s * y.s, x.r * y.r)
*(x::SqrtRational, y::Union{Integer,Rational}) = SqrtRational(x.s * y, x.r)
*(x::Union{Integer,Rational}, y::SqrtRational) = y * x
/(x::SqrtRational, y::SqrtRational) = SqrtRational(x.s / y.s, x.r / y.r)
/(x::SqrtRational, y::Union{Integer,Rational}) = SqrtRational(x.s / y, x.r)
/(x::Union{Integer,Rational}, y::SqrtRational) = SqrtRational(x / y.s, inv(y.r))
==(x::SqrtRational, y::SqrtRational) = begin
    if y.s == 0
        return x.s == 0
    elseif signbit(y.s) != signbit(x.s)
        return false
    else
        isone((x.s / y.s)^2 * (x.r / y.r))
    end
end
==(x::SqrtRational, y::Union{Integer,Rational}) = (x == SqrtRational(y))
==(x::Union{Integer,Rational}, y::SqrtRational) = (SqrtRational(x) == y)

# Only if `r == 1` in `s√r`, the add operator can work.
# We do not simplify `s√r` every time, but in this function,
# we need to simplify it first, and then do the `+` operator.
+(x::SqrtRational, y::Union{Integer,Rational}) = begin
    r = x.r
    t1 = isqrt(numerator(r))
    t1 * t1 != numerator(r) && throw(ArgumentError("cannot simplify $(x)"))
    t2 = isqrt(denominator(r))
    t2 * t2 != denominator(r) && throw(ArgumentError("cannot simplify $(x)"))
    return x.s * (t1 // t2) + y
end
+(x::Union{Integer,Rational}, y::SqrtRational) = y + x
+(x::SqrtRational{T1}, y::SqrtRational{T2}) where {T1,T2} = begin
    if x == 0
        return y
    else
        return x * (one(promote_type(T1, T2)) + y / x)
    end
end
-(x::SqrtRational, y::Union{Integer,Rational}) = (x + (-y))
-(x::Union{Integer,Rational}, y::SqrtRational) = (x + (-y))
-(x::SqrtRational, y::SqrtRational) = (x + (-y))

# widen
Base.widen(x::SqrtRational) = SqrtRational(widen(x.s), widen(x.r))

# convert
"""
    float(x::SqrtRational)::BigFloat
Convert a `SqrtRational` to `BigFloat`.
"""
Base.float(x::SqrtRational) = convert(BigFloat, x.s) * sqrt(convert(BigFloat, x.r))

# show
Base.show(io::IO, ::MIME"text/plain", x::SqrtRational) = begin
    if isone(x.r)
        if denominator(x.s) == 1
            print(io, numerator(x.s))
        else
            print(io, x.s)
        end
        return
    elseif isone(x.s)
        if denominator(x.r) == 1
            print(io, "√$(numerator(x.r))")
        else
            print(io, "√($(x.r))")
        end
        return
    elseif isone(-x.s)
        if denominator(x.r) == 1
            print(io, "-√$(numerator(x.r))")
        else
            print(io, "-√($(x.r))")
        end
        return
    end
    to_show::String = ""
    if denominator(x.s) == 1
        to_show = string(numerator(x.s))
    else
        to_show = "$(x.s)"
    end
    if denominator(x.r) == 1
        to_show *= "√$(numerator(x.r))"
    else
        to_show *= "√($(x.r))"
    end
    print(io, to_show)
end

Base.show(io::IO, x::SqrtRational) = show(io::IO, "text/plain", x)

Base.show(io::IO, ::MIME"text/markdown", x::SqrtRational) = begin
    if isone(x.r)
        if denominator(x.s) == 1
            show(io, "text/markdown", Markdown.parse("``$(numerator(x.s))``"))
        else
            show(io, "text/markdown", Markdown.parse("``\\frac{$(numerator(x.s))}{$(denominator(x.s))}``"))
        end
        return
    elseif isone(x.s)
        if denominator(x.r) == 1
            show(io, "text/markdown", Markdown.parse("``\\sqrt{$(numerator(x.r))}``"))
        else
            show(io, "text/markdown", Markdown.parse("``\\sqrt{\\frac{$(numerator(x.r))}{$(denominator(x.r))}}``"))
        end
        return
    elseif isone(-x.s)
        if denominator(x.r) == 1
            show(io, "text/markdown", Markdown.parse("``-\\sqrt{$(numerator(x.r))}``"))
        else
            show(io, "text/markdown", Markdown.parse("``-\\sqrt{\\frac{$(numerator(x.r))}{$(denominator(x.r))}}``"))
        end
        return
    end
    to_show::String = ""
    if denominator(x.s) == 1
        to_show = string(numerator(x.s))
    else
        to_show = "\\frac{$(numerator(x.s))}{$(denominator(x.s))}"
    end
    if denominator(x.r) == 1
        to_show *= "\\sqrt{$(numerator(x.r))}"
    else
        to_show *= "\\sqrt{\\frac{$(numerator(x.r))}{$(denominator(x.r))}}"
    end
    show(io, "text/markdown", Markdown.parse("``$to_show``"))
end

"""
    simplify(n::Integer)
Simplify a integer `n = x * t^2` to `(x, t)`
"""
function simplify(n::Integer)
    s = sign(n)
    n = s * n
    x = one(n)
    t = one(n)
    for (f, i) in factor(n)
        ti, xi = divrem(i, 2)
        xi == 1 && (x = x * f)
        ti != 0 && (t = t * f^ti)
    end
    return s * x, t
end

function simplify(n::BigInt)
    sb = signbit(n)
    x = one(BigInt)
    t = one(BigInt)
    for (f, i) in factor(abs(n))
        ti, xi = divrem(i, 2)
        xi == 1 && MPZ.mul!(x, f)
        ti != 0 && MPZ.mul_ui!(t, MPZ.pow_ui!(f, ti))
    end
    sb && MPZ.neg!(x)
    return x, t
end

"""
    simplify(x::SqrtRational)
Simplify a SqrtRational.
"""
function simplify(x::SqrtRational)
    nx, nt = simplify(numerator(x.r))
    dx, dt = simplify(denominator(x.r))
    nt *= numerator(x.s)
    dt *= denominator(x.s)
    a0 = gcd(nt, dt)
    nt = div(nt, a0)
    dt = div(dt, a0)
    a1 = gcd(nx, dt)
    a2 = gcd(dx, nt)
    dt = div(dt, a1)
    nt = div(nt, a2)
    dx = div(dx, a2) * a1
    nx = div(nx, a1) * a2
    return SqrtRational(nt // dt, nx // dx)
end

# This file contains the core functions of WignerSymbols and CG-coefficient.

# basic CG coefficient calculation function
function _dCG(dj1::Int, dj2::Int, dj3::Int, dm1::Int, dm2::Int, dm3::Int)
    check_CG(dj1, dj2, dj3, dm1, dm2, dm3) || return zero(SqrtRational{BigInt})
    J::Int = div(dj1 + dj2 + dj3, 2)
    Jm1::Int = J - dj1
    Jm2::Int = J - dj2
    Jm3::Int = J - dj3
    j1mm1::Int = div(dj1 - dm1, 2)
    j2mm2::Int = div(dj2 - dm2, 2)
    j3mm3::Int = div(dj3 - dm3, 2)
    j2pm2::Int = div(dj2 + dm2, 2)
    t = BigInt()
    nA = _bigbin(dj1, Jm2)
    MPZ.mul!(nA, _bigbin(t, dj2, Jm3))
    dA = _bigbin(J + 1, Jm3)
    MPZ.mul!(dA, _bigbin(t, dj1, j1mm1))
    MPZ.mul!(dA, _bigbin(t, dj2, j2mm2))
    MPZ.mul!(dA, _bigbin(t, dj3, j3mm3))

    B::BigInt = zero(BigInt)
    low::Int = max(zero(Int), j1mm1 - Jm2, j2pm2 - Jm1)
    high::Int = min(Jm3, j1mm1, j2pm2)
    tz = BigInt()
    for z in low:high
        _bigbin(tz, Jm3, z)
        MPZ.mul!(tz, _bigbin(t, Jm2, j1mm1 - z))
        MPZ.mul!(tz, _bigbin(t, Jm1, j2pm2 - z))
        MPZ.sub!(B, tz, B)
    end
    if isodd(high)
        MPZ.neg!(B)
    end
    simplify3!(t, B, nA, dA, J + 1)
    return SqrtRational(Base.unsafe_rational(B, t), Base.unsafe_rational(nA, dA))
end

# spaecial case: m1 == m2 == m3 == 0
function _CG0(j1::Int, j2::Int, j3::Int)
    check_couple(j1, j2, j3) || return zero(SqrtRational{BigInt})
    J = j1 + j2 + j3
    g = div(J, 2)
    sn = _bigbin(g, j3)
    sd = _bigbin(j3, g - j1)
    MPZ.mul!(sn, sd)
    if isodd(g - j3)
        MPZ.neg!(sn)
    end
    rd = _bigbin(J + 1, 2j3 + 1)
    rn = _bigbin(2j3, J - 2j1)
    MPZ.mul!(rd, rn)
    simplify2!(sn, sd, rn, rd, J + 1)
    return SqrtRational(Base.unsafe_rational(sn, sd), Base.unsafe_rational(rn, rd))
end

function _3j0(j1::Int, j2::Int, j3::Int)
    check_couple_(j1, j2, j3) || return zero(SqrtRational{BigInt})
    J = j1 + j2 + j3
    g = div(J, 2)
    sn = _bigbin(g, j3)
    sd = _bigbin(j3, g - j1)
    MPZ.mul!(sn, sd)
    if isodd(g)
        MPZ.neg!(sn)
    end
    rd = _bigbin(J + 1, 2j3 + 1)
    rn = _bigbin(2j3, J - 2j1)
    MPZ.mul!(rd, rn)
    MPZ.mul_ui!(rd, convert(Culong, 2j3 + 1))
    simplify2!(sn, sd, rn, rd, J + 1)
    return SqrtRational(Base.unsafe_rational(sn, sd), Base.unsafe_rational(rn, rd))
end

function _xGaunt(l1::Int, l2::Int, l3::Int, m1::Int, m2::Int, m3::Int)
    check_Gaunt(l1, l2, l3, m1, m2, m3) || return zero(SqrtRational{BigInt})
    J::Int = l1 + l2 + l3
    g::Int = div(J, 2)
    Jm1::Int = l2 + l3 - l1
    Jm2::Int = l1 + l3 - l2
    Jm3::Int = l1 + l2 - l3
    j1mm1::Int = l1 - m1
    j2mm2::Int = l2 - m2
    j3mm3::Int = l3 - m3
    j1pm1::Int = l1 + m1

    sn = zero(BigInt)
    sd = zero(BigInt)
    temp = zero(BigInt)
    low = max(zero(Int), j1pm1 - Jm2, j2mm2 - Jm1)
    high = min(Jm3, j1pm1, j2mm2)
    for z in low:high
        _bigbin(sd, Jm3, z)
        MPZ.mul!(sd, _bigbin(temp, Jm2, j1pm1 - z))
        MPZ.mul!(sd, _bigbin(temp, Jm1, j2mm2 - z))
        MPZ.sub!(sn, sd, sn)
    end
    if iszero(sn)
        return zero(SqrtRational{BigInt})
    end
    if isodd(g + j3mm3 + high)
        MPZ.neg!(sn)
    end
    MPZ.mul!(sn, _bigbin(temp, g, g - l3))
    MPZ.mul!(sn, _bigbin(temp, l3, g - l1))
    rn = zero(BigInt)
    rd = zero(BigInt)
    MPZ.set_ui!(rd, 4)
    MPZ.mul!(rd, _bigbin(temp, 2l1, j1mm1))
    MPZ.mul!(rd, _bigbin(temp, 2l2, j2mm2))
    MPZ.mul!(rd, _bigbin(temp, 2l3, j3mm3))
    MPZ.set_ui!(rn, convert(Culong, 2l3 + 1))
    MPZ.mul!(rn, _bigbin(temp, 2l3, Jm1))
    MPZ.mul!(rd, _bigbin(temp, J + 1, 2l1 + 1))
    MPZ.mul!(rd, _bigbin(temp, J + 1, 2l2 + 1))
    simplify3!(sd, sn, rn, rd, J + 1)
    return SqrtRational(Base.unsafe_rational(sn, sd), Base.unsafe_rational(rn, rd))
end

# basic 3j-symbol calculation funciton
function _d3j(dj1::Int, dj2::Int, dj3::Int, dm1::Int, dm2::Int, dm3::Int)
    check_3j(dj1, dj2, dj3, dm1, dm2, dm3) || return zero(SqrtRational{BigInt})
    J::Int = div(dj1 + dj2 + dj3, 2)
    Jm1::Int = J - dj1
    Jm2::Int = J - dj2
    Jm3::Int = J - dj3
    j1mm1::Int = div(dj1 - dm1, 2)
    j2mm2::Int = div(dj2 - dm2, 2)
    j3mm3::Int = div(dj3 - dm3, 2)
    j1pm1::Int = div(dj1 + dm1, 2)
    t = BigInt()
    nA = _bigbin(dj1, Jm2)
    MPZ.mul!(nA, _bigbin(t, dj2, Jm1))
    dA = _bigbin(J, Jm3)
    MPZ.mul!(dA, _bigbin(t, dj1, j1mm1))
    MPZ.mul!(dA, _bigbin(t, dj2, j2mm2))
    MPZ.mul!(dA, _bigbin(t, dj3, j3mm3))
    MPZ.mul_ui!(dA, convert(Culong, J + 1))

    B::BigInt = zero(BigInt)
    low::Int = max(zero(Int), j1pm1 - Jm2, j2mm2 - Jm1)
    high::Int = min(Jm3, j1pm1, j2mm2)
    tz = BigInt()
    for z in low:high
        _bigbin(tz, Jm3, z)
        MPZ.mul!(tz, _bigbin(t, Jm2, j1pm1 - z))
        MPZ.mul!(tz, _bigbin(t, Jm1, j2mm2 - z))
        MPZ.sub!(B, tz, B)
    end
    if isodd(dj1 + div(dj3 + dm3, 2) + high)
        MPZ.neg!(B)
    end
    simplify3!(t, B, nA, dA, J + 1)
    return SqrtRational(Base.unsafe_rational(B, t), Base.unsafe_rational(nA, dA))
end

# basic 6j-symbol calculation funciton
function _d6j(dj1::Int, dj2::Int, dj3::Int, dj4::Int, dj5::Int, dj6::Int)
    check_6j(dj1, dj2, dj3, dj4, dj5, dj6) || return zero(SqrtRational{BigInt})
    j123::Int = div(dj1 + dj2 + dj3, 2)
    j156::Int = div(dj1 + dj5 + dj6, 2)
    j426::Int = div(dj4 + dj2 + dj6, 2)
    j453::Int = div(dj4 + dj5 + dj3, 2)
    jpm123::Int = div(dj1 + dj2 - dj3, 2)
    jpm132::Int = div(dj1 + dj3 - dj2, 2)
    jpm231::Int = div(dj2 + dj3 - dj1, 2)
    jpm156::Int = div(dj1 + dj5 - dj6, 2)
    jpm426::Int = div(dj4 + dj2 - dj6, 2)
    jpm453::Int = div(dj4 + dj5 - dj3, 2)
    # value in sqrt
    t = BigInt()
    nA = _bigbin(j123 + 1, dj1 + 1)
    MPZ.mul!(nA, _bigbin(t, dj1, jpm123))
    dA = _bigbin(j156 + 1, dj1 + 1)
    MPZ.mul!(dA, _bigbin(t, dj1, jpm156))
    MPZ.mul!(dA, _bigbin(t, j453 + 1, dj4 + 1))
    MPZ.mul!(dA, _bigbin(t, dj4, jpm453))
    MPZ.mul!(dA, _bigbin(t, j426 + 1, dj4 + 1))
    MPZ.mul!(dA, _bigbin(t, dj4, jpm426))
    MPZ.mul_ui!(dA, convert(Culong, dj4 + 1))
    MPZ.mul_ui!(dA, convert(Culong, dj4 + 1))
    B::BigInt = zero(BigInt)
    low::Int = max(j123, j453, j426, j156)
    high::Int = min(jpm123 + j453, jpm132 + j426, jpm231 + j156)
    tx = BigInt()
    for x = low:high
        _bigbin(t, x + 1, j123 + 1)
        MPZ.mul!(t, _bigbin(tx, jpm123, x - j453))
        MPZ.mul!(t, _bigbin(tx, jpm132, x - j426))
        MPZ.mul!(t, _bigbin(tx, jpm231, x - j156))
        MPZ.sub!(B, t, B)
    end
    if isodd(high)
        MPZ.neg!(B)
    end
    simplify3!(t, B, nA, dA, high + 1)
    return SqrtRational(Base.unsafe_rational(B, t), Base.unsafe_rational(nA, dA))
end

# use 6j-symbol to calculate Racah coefficient
function _dRacah(dj1::Int, dj2::Int, dj3::Int, dj4::Int, dj5::Int, dj6::Int)
    ans = _d6j(dj1, dj2, dj5, dj4, dj3, dj6)
    if isodd(div(dj1 + dj2 + dj3 + dj4, 2))
        MPZ.neg!(ans.s.num)
    end
    return ans
end

# basic 9j-symbol calculation funciton
function _d9j(dj1::Int, dj2::Int, dj3::Int, dj4::Int, dj5::Int, dj6::Int, dj7::Int, dj8::Int, dj9::Int)
    check_9j(dj1, dj2, dj3, dj4, dj5, dj6, dj7, dj8, dj9) || return zero(SqrtRational{BigInt})
    j123::Int = div(dj1 + dj2 + dj3, 2)
    j456::Int = div(dj4 + dj5 + dj6, 2)
    j789::Int = div(dj7 + dj8 + dj9, 2)
    j147::Int = div(dj1 + dj4 + dj7, 2)
    j258::Int = div(dj2 + dj5 + dj8, 2)
    j369::Int = div(dj3 + dj6 + dj9, 2)
    pm123::Int = div(dj1 + dj2 - dj3, 2)
    pm132::Int = div(dj1 + dj3 - dj2, 2)
    pm231::Int = div(dj2 + dj3 - dj1, 2)
    pm456::Int = div(dj4 + dj5 - dj6, 2)
    pm465::Int = div(dj4 + dj6 - dj5, 2)
    pm564::Int = div(dj5 + dj6 - dj4, 2)
    pm789::Int = div(dj7 + dj8 - dj9, 2)
    pm798::Int = div(dj7 + dj9 - dj8, 2)
    pm897::Int = div(dj8 + dj9 - dj7, 2)
    dtl = max(abs(dj2 - dj6), abs(dj4 - dj8), abs(dj1 - dj9))
    dth = min(dj2 + dj6, dj4 + dj8, dj1 + dj9)
    sum = zero(BigInt)
    ABC = zero(BigInt)
    Pt = zero(BigInt)
    tx = zero(BigInt)
    temp = zero(BigInt)
    for dt = dtl:2:dth
        j19t = div(dj1 + dj9 + dt, 2)
        j26t = div(dj2 + dj6 + dt, 2)
        j48t = div(dj4 + dj8 + dt, 2)
        MPZ.set_ui!(ABC, convert(Culong, dt + 1))
        xl = max(j123, j369, j26t, j19t)
        xh = min(pm123 + j369, pm132 + j26t, pm231 + j19t)
        MPZ.set_ui!(Pt, 0)
        for x = xl:xh
            _bigbin(tx, x + 1, j19t + 1)
            MPZ.mul!(tx, _bigbin(temp, div(dj1 + dj9 - dt, 2), x - j26t))
            MPZ.mul!(tx, _bigbin(temp, div(dj1 + dt - dj9, 2), x - j369))
            MPZ.mul!(tx, _bigbin(temp, div(dt + dj9 - dj1, 2), x - j123))
            MPZ.sub!(Pt, tx, Pt)
        end
        MPZ.mul!(ABC, Pt)
        yl = max(j456, j26t, j258, j48t)
        yh = min(pm456 + j26t, pm465 + j258, pm564 + j48t)
        MPZ.set_ui!(Pt, 0)
        for y = yl:yh
            _bigbin(tx, y + 1, j26t + 1)
            MPZ.mul!(tx, _bigbin(temp, div(dj2 + dj6 - dt, 2), y - j48t))
            MPZ.mul!(tx, _bigbin(temp, div(dj6 + dt - dj2, 2), y - j258))
            MPZ.mul!(tx, _bigbin(temp, div(dt + dj2 - dj6, 2), y - j456))
            MPZ.sub!(Pt, tx, Pt)
        end
        MPZ.mul!(ABC, Pt)
        zl = max(j789, j19t, j48t, j147)
        zh = min(pm789 + j19t, pm798 + j48t, pm897 + j147)
        MPZ.set_ui!(Pt, 0)
        for z = zl:zh
            _bigbin(tx, z + 1, j48t + 1)
            MPZ.mul!(tx, _bigbin(temp, div(dj4 + dj8 - dt, 2), z - j19t))
            MPZ.mul!(tx, _bigbin(temp, div(dj8 + dt - dj4, 2), z - j147))
            MPZ.mul!(tx, _bigbin(temp, div(dt + dj4 - dj8, 2), z - j789))
            MPZ.sub!(Pt, tx, Pt)
        end
        MPZ.mul!(ABC, Pt)
        if isodd(xh + yh + zh)
            MPZ.neg!(ABC)
        end
        MPZ.add!(sum, ABC)
    end
    if iszero(sum)
        return zero(SqrtRational{BigInt})
    end
    if isodd(dth)
        MPZ.neg!(sum)
    end
    MPZ.set_ui!(Pt, convert(Culong, dj3 + 1))
    MPZ.mul_ui!(Pt, convert(Culong, dj6 + 1))
    MPZ.mul_ui!(Pt, convert(Culong, dj9 + 1))
    MPZ.mul_ui!(Pt, convert(Culong, dj7 + 1))
    MPZ.mul_ui!(Pt, convert(Culong, dj8 + 1))
    MPZ.mul_ui!(Pt, convert(Culong, dj9 + 1))
    MPZ.mul!(Pt, _bigbin(temp, j123 + 1, dj3 + 1))
    MPZ.mul!(Pt, _bigbin(temp, j456 + 1, dj6 + 1))
    MPZ.mul!(Pt, _bigbin(temp, j789 + 1, dj9 + 1))
    MPZ.mul!(Pt, _bigbin(temp, dj3, pm231))
    MPZ.mul!(Pt, _bigbin(temp, dj6, pm564))
    MPZ.mul!(Pt, _bigbin(temp, dj9, pm897))
    MPZ.mul!(Pt, _bigbin(temp, j147 + 1, dj7 + 1))
    MPZ.mul!(Pt, _bigbin(temp, j258 + 1, dj8 + 1))
    MPZ.mul!(Pt, _bigbin(temp, j369 + 1, dj9 + 1))
    MPZ.mul!(Pt, _bigbin(temp, dj7, div(dj7 - dj1 + dj4, 2)))
    MPZ.mul!(Pt, _bigbin(temp, dj8, div(dj8 - dj2 + dj5, 2)))
    MPZ.mul!(Pt, _bigbin(temp, dj9, div(dj9 - dj3 + dj6, 2)))
    Jmax = max(j123, j456, j789, j147, j258, j369)
    simplify2!(sum, tx, ABC, Pt, Jmax + 1)
    return SqrtRational(Base.unsafe_rational(sum, tx), Base.unsafe_rational(ABC, Pt))
end

function _lsjj(l1::Int, l2::Int, dj1::Int, dj2::Int, L::Int, S::Int, J::Int)::Rational{Int}
    check_couple(2l1, 2l2, 2L) || return zero(Rational{Int})
    check_couple(dj1, dj2, 2J) || return zero(Rational{Int})
    LSJcase = 0
    if S == 0
        LSJcase = 1
    elseif S == 1
        (L == J - 1) && (LSJcase = 2)
        (J == L) && (LSJcase = 3)
        (L == J + 1) && (LSJcase = 4)
    end
    iszero(LSJcase) && return zero(Rational{Int})
    m = l1 - l2
    p = l1 + l2
    δ1 = dj1 - 2l1
    δ2 = dj2 - 2l2
    d = 2 * (2l1 + 1) * (2l2 + 1)
    r = zero(Rational{Int})
    if δ1 == 1 && δ2 == 1
        if LSJcase == 1
            r = (J + p + 2) * (p + 1 - J) // d
        elseif LSJcase == 2
            r = (J + m) * (J - m) // (J * (2J + 1))
            r *= (J + p + 1) * (J + p + 2) // d
        elseif LSJcase == 3
            m == 0 && return zero(Rational{Int})
            r = m * abs(m) // (J * (J + 1))
            r *= (J + p + 2) * (p + 1 - J) // d
        elseif LSJcase == 4
            r = -(L + m) * (L - m) // (L * (2J + 1))
            r *= (p - J) * (p + 1 - J) // d
        end
    elseif δ1 == 1 && δ2 == -1
        if LSJcase == 1
            r = (J + m + 1) * (J - m) // d
        elseif LSJcase == 2
            r = -(p + 1 + J) * (p + 1 - J) // (J * (2J + 1))
            r *= (J + m + 1) * (J + m) // d
        elseif LSJcase == 3
            r = (p + 1) * (p + 1) // (J * (J + 1))
            r *= (J + m + 1) * (J - m) // d
        elseif LSJcase == 4
            r = -(p + 1 + L) * (p + 1 - L) // (L * (2J + 1))
            r *= (J - m + 1) * (J - m) // d
        end
    elseif δ1 == -1 && δ2 == 1
        if LSJcase == 1
            r = -(J + m) * (J - m + 1) // d
        elseif LSJcase == 2
            r = (p + 1 + J) * (p + 1 - J) // (J * (2J + 1))
            r *= (J - m) * (J - m + 1) // d
        elseif LSJcase == 3
            r = (p + 1) * (p + 1) // (J * (J + 1))
            r *= (J + m) * (J - m + 1) // d
        elseif LSJcase == 4
            r = (p + 1 + L) * (p + 1 - L) // (L * (2J + 1))
            r *= (J + m + 1) * (J + m) // d
        end
    elseif δ1 == -1 && δ2 == -1
        if LSJcase == 1
            r = (J + p + 1) * (p - J) // d
        elseif LSJcase == 2
            r = -(J + m) * (J - m) // (J * (2J + 1))
            r *= (p - J) * (p + 1 - J) // d
        elseif LSJcase == 3
            m == 0 && return zero(Rational{Int})
            r = -m * abs(m) // (J * (J + 1))
            r *= (J + p + 1) * (p - J) // d
        elseif LSJcase == 4
            r = (L + m) * (L - m) // (L * (2J + 1))
            r *= (J + p + 1) * (J + p + 2) // d
        end
    end
    return r
end


function _omega(ans::BigInt, temp::BigInt, j1::Int, j3::Int, g::Int)
    _bigbin(ans, g, j3)
    return MPZ.mul!(ans, _bigbin(temp, j3, g - j1))
end

function _m9j!(
    sum::BigInt, temp::BigInt, tx::BigInt, Pt::BigInt, ABC::BigInt,
    j1::Int, j2::Int, j3::Int, j4::Int, j5::Int, j6::Int, j7::Int, j8::Int, j9::Int)
    j123::Int = j1 + j2 + j3
    j456::Int = j4 + j5 + j6
    j789::Int = j7 + j8 + j9
    j147::Int = j1 + j4 + j7
    j258::Int = j2 + j5 + j8
    j369::Int = j3 + j6 + j9
    pm123::Int = j1 + j2 - j3
    pm132::Int = j1 + j3 - j2
    pm231::Int = j2 + j3 - j1
    pm456::Int = j4 + j5 - j6
    pm465::Int = j4 + j6 - j5
    pm564::Int = j5 + j6 - j4
    pm789::Int = j7 + j8 - j9
    pm798::Int = j7 + j9 - j8
    pm897::Int = j8 + j9 - j7
    MPZ.set_ui!(sum, 0)
    tl::Int = max(abs(j2 - j6), abs(j4 - j8), abs(j1 - j9))
    th::Int = min(j2 + j6, j4 + j8, j1 + j9)
    for t::Int = tl:th
        j19t::Int = j1 + j9 + t
        j26t::Int = j2 + j6 + t
        j48t::Int = j4 + j8 + t
        MPZ.set_ui!(ABC, convert(Culong, 2t + 1))
        xl::Int = max(j123, j369, j26t, j19t)
        xh::Int = min(pm123 + j369, pm132 + j26t, pm231 + j19t)
        MPZ.set_ui!(Pt, 0)
        for x = xl:xh
            _bigbin(tx, x + 1, j19t + 1)
            MPZ.mul!(tx, _bigbin(temp, j1 + j9 - t, x - j26t))
            MPZ.mul!(tx, _bigbin(temp, j1 + t - j9, x - j369))
            MPZ.mul!(tx, _bigbin(temp, t + j9 - j1, x - j123))
            MPZ.sub!(Pt, tx, Pt)
        end
        MPZ.mul!(ABC, Pt)
        yl::Int = max(j456, j26t, j258, j48t)
        yh::Int = min(pm456 + j26t, pm465 + j258, pm564 + j48t)
        MPZ.set_ui!(Pt, 0)
        for y = yl:yh
            _bigbin(tx, y + 1, j26t + 1)
            MPZ.mul!(tx, _bigbin(temp, j2 + j6 - t, y - j48t))
            MPZ.mul!(tx, _bigbin(temp, j6 + t - j2, y - j258))
            MPZ.mul!(tx, _bigbin(temp, t + j2 - j6, y - j456))
            MPZ.sub!(Pt, tx, Pt)
        end
        MPZ.mul!(ABC, Pt)
        zl::Int = max(j789, j19t, j48t, j147)
        zh::Int = min(pm789 + j19t, pm798 + j48t, pm897 + j147)
        MPZ.set_ui!(Pt, 0)
        for z = zl:zh
            _bigbin(tx, z + 1, j48t + 1)
            MPZ.mul!(tx, _bigbin(temp, j4 + j8 - t, z - j19t))
            MPZ.mul!(tx, _bigbin(temp, j8 + t - j4, z - j147))
            MPZ.mul!(tx, _bigbin(temp, t + j4 - j8, z - j789))
            MPZ.sub!(Pt, tx, Pt)
        end
        MPZ.mul!(ABC, Pt)
        if isodd(xh + yh + zh)
            MPZ.neg!(ABC)
        end
        MPZ.add!(sum, ABC)
    end
    return
end

# D = \tan^2\beta = (m_1\omega_1)/(m_2\omega_2)
function _Moshinsky(N::Int, L::Int, n::Int, l::Int, n1::Int, l1::Int, n2::Int, l2::Int, Λ::Int, numD::Int, denD::Int)
    check_Moshinsky(N, L, n, l, n1, l1, n2, l2, Λ) || return zero(SqrtRational{BigInt})
    e1 = 2 * n1 + l1
    e2 = 2 * n2 + l2
    E = 2 * N + L
    e = 2 * n + l
    χ = e1 + e2
    nl1 = n1 + l1
    nl2 = n2 + l2
    NL = N + L
    nl = n + l

    temp = BigInt()
    tx = BigInt()
    Pt = BigInt()
    ABC = BigInt()
    nu_a = BigInt()
    de_a = BigInt()
    nu_b = BigInt()
    de_b = BigInt()
    nu_c = BigInt()
    de_c = BigInt()
    nu_d = BigInt()
    de_d = BigInt()
    nu_fa = BigInt()
    de_fa = BigInt()
    M9j = BigInt()

    Snu = BigInt()
    Sde = BigInt()

    _bigbin(Snu, χ + 2, e1 + 1)
    _bigbin(Sde, χ + 2, E + 1)
    MPZ.mul!(Sde, _bigbin(temp, L + l + Λ + 1, 2Λ + 1))
    MPZ.mul!(Sde, _bigbin(temp, 2Λ, Λ + L - l))
    MPZ.mul!(Sde, _bigbin(temp, l1 + l2 + Λ + 1, 2Λ + 1))
    MPZ.mul!(Sde, _bigbin(temp, 2Λ, Λ + l1 - l2))
    _divgcd!(temp, Snu, Sde)

    MPZ.mul!(Snu, _bigbin(temp, 2nl1 + 1, nl1))
    MPZ.mul_ui!(Sde, convert(Culong, 2l1 + 1))
    MPZ.mul!(Sde, _bigbin(temp, e1 + 1, n1))

    MPZ.mul!(Snu, _bigbin(temp, 2nl2 + 1, nl2))
    MPZ.mul_ui!(Sde, convert(Culong, 2l2 + 1))
    MPZ.mul!(Sde, _bigbin(temp, e2 + 1, n2))

    MPZ.mul!(Snu, _bigbin(temp, 2NL + 1, NL))
    MPZ.mul_ui!(Sde, convert(Culong, 2L + 1))
    MPZ.mul!(Sde, _bigbin(temp, E + 1, N))

    MPZ.mul!(Snu, _bigbin(temp, 2nl + 1, nl))
    MPZ.mul_ui!(Sde, convert(Culong, 2l + 1))
    MPZ.mul!(Sde, _bigbin(temp, e + 1, n))

    _divgcd!(temp, Snu, Sde)

    MPZ.set_ui!(tx, convert(Culong, e1 + 2))
    MPZ.mul_ui!(tx, convert(Culong, e2 + 2))
    MPZ.mul_ui!(tx, convert(Culong, 2Λ + 1))
    MPZ.pow_ui!(tx, 2)
    MPZ.mul_2exp!(tx, l1 + l2 + L + l)
    MPZ.mul!(Sde, tx)
    _divgcd!(temp, Snu, Sde)

    if e - e1 > 0
        __gmpz_ui_pow_ui!(temp, convert(Culong, numD), convert(Culong, e - e1))
        MPZ.mul!(Snu, temp)
    elseif e - e1 < 0
        __gmpz_ui_pow_ui!(temp, convert(Culong, numD), convert(Culong, e1 - e))
        MPZ.mul!(Sde, temp)
    end
    __gmpz_ui_pow_ui!(temp, convert(Culong, denD), convert(Culong, e1 + E))
    MPZ.mul!(Snu, temp)
    __gmpz_ui_pow_ui!(temp, convert(Culong, numD + denD), convert(Culong, e + E))
    MPZ.mul!(Sde, temp)
    _divgcd!(temp, Snu, Sde)

    sum = zero(Rational{BigInt})
    for ea = 0:min(e1, E)
        eb = e1 - ea
        ec = E - ea
        ed = e2 - ec
        ed < 0 && continue
        _bigbin(nu_fa, e1 + 2, ea + 1)
        MPZ.mul!(nu_fa, _bigbin(temp, e2 + 2, ec + 1))
        __gmpz_ui_pow_ui!(temp, convert(Culong, numD), convert(Culong, ea))
        MPZ.mul!(nu_fa, temp)
        __gmpz_ui_pow_ui!(de_fa, convert(Culong, denD), convert(Culong, ea))
        _divgcd!(temp, nu_fa, de_fa)
        for la = rem(ea, 2):2:ea
            na = div(ea - la, 2)
            nla = na + la
            MPZ.mul_ui!(nu_a, nu_fa, convert(Culong, 2la + 1))
            MPZ.mul!(nu_a, _bigbin(temp, ea + 1, na))
            MPZ.mul_2exp!(nu_a, la)
            MPZ.mul!(de_a, de_fa, _bigbin(temp, 2nla + 1, nla))
            _divgcd!(temp, nu_a, de_a)
            for lb = abs(l1 - la):2:min(l1 + la, eb)
                nb = div(eb - lb, 2)
                nlb = nb + lb
                MPZ.mul_ui!(nu_b, nu_a, convert(Culong, 2lb + 1))
                MPZ.mul!(nu_b, _bigbin(temp, eb + 1, nb))
                MPZ.mul_2exp!(nu_b, lb)
                MPZ.mul!(de_b, de_a, _bigbin(temp, 2nlb + 1, nlb))
                MPZ.mul!(nu_b, _omega(tx, temp, la, l1, div(la + lb + l1, 2)))
                # Δ(lalbl1)
                MPZ.mul!(de_b, _bigbin(temp, la + lb + l1 + 1, 2l1 + 1))
                MPZ.mul!(de_b, _bigbin(temp, 2l1, l1 + la - lb))
                _divgcd!(temp, nu_b, de_b)
                for lc = abs(L - la):2:min(L + la, ec)
                    nc = div(ec - lc, 2)
                    nlc = nc + lc
                    MPZ.mul_ui!(nu_c, nu_b, convert(Culong, 2lc + 1))
                    MPZ.mul!(nu_c, _bigbin(temp, ec + 1, nc))
                    MPZ.mul_2exp!(nu_c, lc)
                    MPZ.mul!(de_c, de_b, _bigbin(temp, 2nlc + 1, nlc))
                    MPZ.mul!(nu_c, _omega(tx, temp, la, L, div(la + lc + L, 2)))
                    # Δ(lalcl3)
                    MPZ.mul!(de_c, _bigbin(temp, la + lc + L + 1, 2L + 1))
                    MPZ.mul!(de_c, _bigbin(temp, 2L, L + la - lc))
                    _divgcd!(temp, nu_c, de_c)
                    ldmin = max(abs(l2 - lc), abs(l - lb))
                    ldmax = min(ed, l2 + lc, l + lb)
                    for ld = ldmin:2:ldmax
                        nd = div(ed - ld, 2)
                        nld = nd + ld
                        MPZ.mul_ui!(nu_d, nu_c, convert(Culong, 2ld + 1))
                        MPZ.mul!(nu_d, _bigbin(temp, ed + 1, nd))
                        MPZ.mul_2exp!(nu_d, ld)
                        MPZ.mul!(de_d, de_c, _bigbin(temp, 2nld + 1, nld))
                        MPZ.mul!(nu_d, _omega(tx, temp, lc, l2, div(lc + ld + l2, 2)))
                        MPZ.mul!(nu_d, _omega(tx, temp, lb, l, div(lb + ld + l, 2)))
                        # Δ(lbldl4)
                        MPZ.mul!(de_d, _bigbin(temp, lb + ld + l + 1, 2l + 1))
                        MPZ.mul!(de_d, _bigbin(temp, 2l, l + lb - ld))
                        # Δ(lcldl2)
                        MPZ.mul!(de_d, _bigbin(temp, lc + ld + l2 + 1, 2l2 + 1))
                        MPZ.mul!(de_d, _bigbin(temp, 2l2, l2 + lc - ld))
                        _divgcd!(temp, nu_d, de_d)
                        if isodd(ld)
                            MPZ.neg!(nu_d)
                        end
                        _m9j!(M9j, temp, tx, Pt, ABC, la, lb, l1, lc, ld, l2, L, l, Λ)
                        # don't use MPQ.add! to avoid memory allocation
                        MPZ.mul!(nu_d, M9j)
                        _divgcd!(temp, nu_d, de_d)
                        __gmpq_add!(tx, sum, nu_d, de_d)
                    end
                end
            end
        end
    end
    simplify4!(tx, sum.num, sum.den, Snu, Sde, max(χ + 2, max(l1 + l2, L + l) + Λ + 1, numD + denD))
    return SqrtRational(sum, Base.unsafe_rational(Snu, Sde))
end


"""
    dCG(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer)
CG coefficient function with double angular monentum number parameters, so that the parameters can be integer.
You can calculate `dCG(1, 1, 2, 1, 1, 2)` to calculate the real `CG(1//2, 1//2, 1, 1/2, 1//2, 1)`
"""
@inline dCG(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer) = _dCG(Int.((dj1, dj2, dj3, dm1, dm2, dm3))...)

"""
    d3j(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer)
3j-symbol function with double angular monentum number parameters, so that the parameters can be integer.
"""
@inline d3j(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer) = _d3j(Int.((dj1, dj2, dj3, dm1, dm2, dm3))...)

"""
    d6j(dj1::Integer, dj2::Integer, dj3::Integer, dj4::Integer, dj5::Integer, dj6::Integer)
6j-symbol function with double angular monentum number parameters, so that the parameters can be integer.
"""
@inline d6j(dj1::Integer, dj2::Integer, dj3::Integer, dj4::Integer, dj5::Integer, dj6::Integer) = _d6j(Int.((dj1, dj2, dj3, dj4, dj5, dj6))...)

"""
    dRacah(dj1::Integer, dj2::Integer, dj3::Integer, dj4::Integer, dj5::Integer, dj6::Integer)
Racah coefficient function with double angular momentum parameters, so that the parameters can be integer.
"""
@inline dRacah(dj1::Integer, dj2::Integer, dj3::Integer, dj4::Integer, dj5::Integer, dj6::Integer) = _dRacah(Int.((dj1, dj2, dj3, dj4, dj5, dj6))...)

"""
    d9j(dj1::Integer, dj2::Integer, dj3::Integer,
        dj4::Integer, dj5::Integer, dj6::Integer,
        dj7::Integer, dj8::Integer, dj9::Integer)
9j-symbol function with double angular monentum number parameters, so that the parameters can be integer.
"""
@inline d9j(dj1::Integer, dj2::Integer, dj3::Integer,
    dj4::Integer, dj5::Integer, dj6::Integer,
    dj7::Integer, dj8::Integer, dj9::Integer) = _d9j(Int.((dj1, dj2, dj3, dj4, dj5, dj6, dj7, dj8, dj9))...)

@doc raw"""
    CG(j1::Real, j2::Real, j3::Real, m1::Real, m2::Real, m3::Real)
CG coefficient ``\langle j_1m_1 j_2m_2 | j_3m_3 \rangle``
"""
@inline CG(j1::Real, j2::Real, j3::Real, m1::Real, m2::Real, m3::Real) = _dCG(Int.((2j1, 2j2, 2j3, 2m1, 2m2, 2m3))...)

@doc raw"""
    CG0(j1::Integer, j2::Integer, j3::Integer)
CG coefficient special case: ``\langle j_1 0 j_2 0 | j_3 0 \rangle``.
"""
@inline CG0(j1::Integer, j2::Integer, j3::Integer) = _CG0(Int.((j1, j2, j3))...)

@doc raw"""
    threeJ(j1::Real, j2::Real, j3::Real, m1::Real, m2::Real, m3::Real)
Wigner 3j-symbol
```math
\begin{pmatrix}
j_1 & j_2 & j_3 \\
m_1 & m_2 & m_3
\end{pmatrix}
```
"""
@inline threeJ(j1::Real, j2::Real, j3::Real, m1::Real, m2::Real, m3::Real) = _d3j(Int.((2j1, 2j2, 2j3, 2m1, 2m2, 2m3))...)

@doc raw"""
    xGaunt(l1::Integer, l2::Integer, l3::Integer, m1::Integer, m2::Integer, m3::Integer)
Gaunt coefficient with out ``1/\sqrt{\pi}`` factor.
(This package can only handle integer arithmetic, it is easy to add the factor mannually.)
```math
\begin{aligned}
\mathrm{Gaunt}(l_1 l_2 l_3 m_1 m_2 m_3) &= \int Y_{l_1 m_1}(\theta, \phi) Y_{l_2 m_2}(\theta, \phi) Y_{l_3 m_3}(\theta, \phi) d\Omega \\
&= \sqrt{\frac{(2l_1 + 1)(2l_2 + 1)(2l_3 + 1)}{4\pi}} \begin{pmatrix} l_1 & l_2 & l_3 \\ m_1 & m_2 & m_3 \end{pmatrix} \begin{pmatrix} l_1 & l_2 & l_3 \\ 0 & 0 & 0 \end{pmatrix}. \\
\end{aligned}
```
"""
@inline xGaunt(l1::Integer, l2::Integer, l3::Integer, m1::Integer, m2::Integer, m3::Integer) = _xGaunt(Int.((l1, l2, l3, m1, m2, m3))...)

@doc raw"""
    sixJ(j1::Real, j2::Real, j3::Real, j4::Real, j5::Real, j6::Real)
Wigner 6j-symbol
```math
\begin{Bmatrix}
j_1 & j_2 & j_3 \\
j_4 & j_5 & j_6
\end{Bmatrix}
```
"""
@inline sixJ(j1::Real, j2::Real, j3::Real, j4::Real, j5::Real, j6::Real) = _d6j(Int.((2j1, 2j2, 2j3, 2j4, 2j5, 2j6))...)

@doc raw"""
    Racah(j1::Real, j2::Real, j3::Real, j4::Real, j5::Real, j6::Real)
Racah coefficient
```math
W(j_1j_2j_3j_4, j_5j_6) = (-1)^{j_1+j_2+j_3+j_4} \begin{Bmatrix}
j_1 & j_2 & j_5 \\
j_4 & j_3 & j_6
\end{Bmatrix}
```
"""
@inline Racah(j1::Real, j2::Real, j3::Real, j4::Real, j5::Real, j6::Real) = _dRacah(Int.((2j1, 2j2, 2j3, 2j4, 2j5, 2j6))...)

@doc raw"""
    nineJ(j1::Real, j2::Real, j3::Real,
          j4::Real, j5::Real, j6::Real,
          j7::Real, j8::Real, j9::Real)
Wigner 9j-symbol
```math
\begin{Bmatrix}
j_1 & j_2 & j_3 \\
j_4 & j_5 & j_6 \\
j_7 & j_8 & j_9
\end{Bmatrix}
```
"""
@inline nineJ(j1::Real, j2::Real, j3::Real, j4::Real, j5::Real, j6::Real, j7::Real, j8::Real, j9::Real) = _d9j(Int.((2j1, 2j2, 2j3, 2j4, 2j5, 2j6, 2j7, 2j8, 2j9))...)

@doc raw"""
    norm9J(j1::Real, j2::Real, j3::Real,
           j4::Real, j5::Real, j6::Real,
           j7::Real, j8::Real, j9::Real)
normalized Wigner 9j-symbol
```math
\begin{bmatrix}
j_1 & j_2 & j_3 \\
j_4 & j_5 & j_6 \\
j_7 & j_8 & j_9
\end{bmatrix} = \sqrt{(2j_3+1)(2j_6+1)(2j_7+1)(2j_8+1)} \begin{Bmatrix}
j_1 & j_2 & j_3 \\
j_4 & j_5 & j_6 \\
j_7 & j_8 & j_9
\end{Bmatrix}
```
"""
@inline norm9J(j1::Real, j2::Real, j3::Real, j4::Real, j5::Real, j6::Real, j7::Real, j8::Real, j9::Real) = begin
    dj1, dj2, dj3, dj4, dj5, dj6, dj7, dj8, dj9 = Int.((2j1, 2j2, 2j3, 2j4, 2j5, 2j6, 2j7, 2j8, 2j9))
    Jmax = max(dj1, dj2, dj3, dj4, dj5, dj6, dj7, dj8, dj9)
    ans = _d9j(dj1, dj2, dj3, dj4, dj5, dj6, dj7, dj8, dj9)
    MPZ.mul_ui!(ans.r.num, convert(Culong, dj3 + 1))
    MPZ.mul_ui!(ans.r.num, convert(Culong, dj6 + 1))
    MPZ.mul_ui!(ans.r.num, convert(Culong, dj7 + 1))
    MPZ.mul_ui!(ans.r.num, convert(Culong, dj8 + 1))
    simplify4!(BigInt(), ans.s.num, ans.s.den, ans.r.num, ans.r.den, cld(5Jmax, 2) + 1)
    return ans
end

@doc raw"""
    lsjj(l1::Integer, l2::Integer, j1::Real, j2::Real, L::Integer, S::Integer, J::Integer)
LS-coupling to jj-coupling transformation coefficient
```math
\langle l_1l_2L,s_1s_2S;J|l_1s_1j_1,l_2s_2j_2;J\rangle = \begin{bmatrix}l_1 & s_1 & j_1 \\ l_2 & s_2 & j_2 \\ L & S & J\end{bmatrix}
```
"""
@inline lsjj(l1::Integer, l2::Integer, j1::Real, j2::Real, L::Integer, S::Integer, J::Integer) = begin
    r = _lsjj(Int.((l1, l2, 2j1, 2j2, L, S, J))...)
    return simplify(SqrtRational(sign(r), abs(r)))
end


@doc raw"""
    Moshinsky(N::Integer, L::Integer, n::Integer, l::Integer, n1::Integer, l1::Integer, n2::Integer, l2::Integer, Λ::Integer, D::Union{Rational,Integer}=1)
Moshinsky bracket，Ref: Buck et al. Nuc. Phys. A 600 (1996) 387-402.
This function is designed for demonstration the exact result,
It only calculate the case of ``\tan(\beta) = \sqrt{m_1\omega_1/m_2\omega_2} = 1``.
"""
@inline Moshinsky(N::Integer, L::Integer, n::Integer, l::Integer, n1::Integer, l1::Integer, n2::Integer, l2::Integer, Λ::Integer, D::Union{Rational,Integer}=1) = begin
    iN, iL, in, il, in1, il1, in2, il2, iΛ = Int.((N, L, n, l, n1, l1, n2, l2, Λ))
    numD = Int(numerator(D))
    denD = Int(denominator(D))
    return _Moshinsky(iN, iL, in, il, in1, il1, in2, il2, iΛ, numD, denD)
end

# this file test the Moshinsky coefficients
# the data comes from: Buck et al. Nuc. Phys. A 600 (1996) 387-402

const Moshinsky_test_set = [
    0 0 0 0 0 0 0 0 0
    0 1 0 0 0 0 0 1 1
    0 0 0 1 0 0 0 1 1
    0 2 0 0 0 0 0 2 2
    0 1 0 1 0 0 0 2 2
    0 0 0 2 0 0 0 2 2
    1 0 0 0 0 1 0 1 0
    0 1 0 1 0 1 0 1 0
    0 0 1 0 0 1 0 1 0
    0 1 0 1 0 1 0 1 1
    0 2 0 0 0 1 0 1 2
    0 1 0 1 0 1 0 1 2
    0 0 0 2 0 1 0 1 2]

const Moshinsky_test_set2 = [
    0 2 1 0 0 1 0 3 2
    0 1 0 5 0 1 0 5 6
    0 1 0 3 0 2 0 2 4
    1 3 0 1 0 2 0 4 3
    0 5 0 2 0 2 0 5 4
    0 3 1 6 2 2 1 3 4
    1 0 2 5 2 2 1 3 5
    0 2 4 2 2 2 1 4 2
    3 2 0 4 2 2 1 4 4
]

const Moshinsky_test_set_result2 = [
    SqrtRational(-1//2, 7//10),
    SqrtRational(1//2, 1),
    SqrtRational(0, 1),
    SqrtRational(-1//2, 5//14),
    SqrtRational(-1//6, 1//2),
    SqrtRational(1//24, 65//3),
    SqrtRational(-5//96, 13//7),
    SqrtRational(-1//28, 195//14),
    SqrtRational(4463//25872, 1//3)
]

const inv_sqrt2 = exact_sqrt(1//2)
const Moshinsky_test_set_result = [
    1, inv_sqrt2, -inv_sqrt2, 1//2, -inv_sqrt2, 1//2, inv_sqrt2, 0, -inv_sqrt2, -1, inv_sqrt2, 0, -inv_sqrt2 
]

function test_Moshinsky()
    wigner_init_float(7, "Moshinsky", 0)
    for i = eachindex(Moshinsky_test_set_result)
        N, L, n, l, n1, l1, n2, l2, Λ = Moshinsky_test_set[i, :]
        @test Moshinsky(N, L, n, l, n1, l1, n2, l2, Λ) == Moshinsky_test_set_result[i]
        @test fMoshinsky(N, L, n, l, n1, l1, n2, l2, Λ) ≈ float(Moshinsky_test_set_result[i])
    end
    for i = eachindex(Moshinsky_test_set_result2)
        N, L, n, l, n1, l1, n2, l2, Λ = Moshinsky_test_set2[i, :]
        @test Moshinsky(N, L, n, l, n1, l1, n2, l2, Λ) == Moshinsky_test_set_result2[i]
        @test fMoshinsky(N, L, n, l, n1, l1, n2, l2, Λ) ≈ float(Moshinsky_test_set_result2[i])
    end
end

module CGcoefficient

export CG, CG0, threeJ, sixJ, nineJ, Racah,
       dCG, d3j, d6j, d9j, dRacah, xGaunt,
       lsjj, norm9J,
       Moshinsky,
       SqrtRational,
       exact_sqrt,
       simplify,
       iphase,
       is_same_parity,
       check_jm,
       check_couple,
       binomial_data_size, binomial_index,
       check_CG, check_3j, check_6j, check_9j,
       check_Gaunt, check_Moshinsky,
       fCG, fCG0, f3j, f6j, f9j, fRacah,
       fbinomial, unsafe_fbinomial,
       fMoshinsky, dfunc,
       flsjj, fCGspin, fCG3spin, fnorm9j,
       wigner_init_float


include("mpz.jl")
include("SqrtRational.jl")
include("util.jl")
include("WignerSymbols.jl")
include("floatWignerSymbols.jl")
include("PFRational/primetable.jl")
include("PFRational/PFRational.jl")
include("PFRational/pf_wigner.jl")
export PFRational, wigner_init_pf, pf_binomial, eCG, efCG, eCG0, efCG0, e3j, ef3j, e6j, ef6j

end # module CGcoefficient

# this file test the behavior of `SqrtRational`

function test_sqrtrational()
    x = 3//5 * exact_sqrt(2//3)
    @test zero(x) == 0
    @test 0*x == 0
    @test (0*x).r == 1
    @test (0*x) == zero(x)
    @test 1 == one(x)
    @test x*inv(x) == one(x)
    @test inv(x) == one(x)/x
    @test sign(+x) == 1
    @test sign(-x) == -1
    @test sign(0*x) == 0
    @test signbit(+x) == false
    @test signbit(-x) == true
    @test signbit(0*x) == false
    @test x == x
    @test x != -x
    @test x == copy(x)
    @test x - exact_sqrt(2//3) == SqrtRational(3//5 - 1, 2//3)
    @test 0 - zero(x) == zero(x)
    @test x - x == 0
end

function test_show()
    x = exact_sqrt(3)
    y = exact_sqrt(3//5)
    @test string(zero(x)) == "0"
    @test string(one(x)) == "1"
    @test string(2//3*one(x)) == "2//3"
    @test string(x) == "√3"
    @test string(-x) == "-√3"
    @test string(-y) == "-√(3//5)"
    @test string(y) == "√(3//5)"
    @test string(3*x) == "3√3"
    @test string(2//3*y) == "2//3√(3//5)"
    
    io = IOBuffer()
    show(io, "text/markdown", zero(x))
    @test String(take!(io)) == raw"$0$" * "\n"
    show(io, "text/markdown", one(x))
    @test String(take!(io)) == raw"$1$" * "\n"
    show(io, "text/markdown", 2//3*one(x))
    @test String(take!(io)) == raw"$\frac{2}{3}$" * "\n"
    show(io, "text/markdown", x)
    @test String(take!(io)) == raw"$\sqrt{3}$" * "\n"
    show(io, "text/markdown", y)
    @test String(take!(io)) == raw"$\sqrt{\frac{3}{5}}$" * "\n"
    show(io, "text/markdown", -x)
    @test String(take!(io)) == raw"$-\sqrt{3}$" * "\n"
    show(io, "text/markdown", -y)
    @test String(take!(io)) == raw"$-\sqrt{\frac{3}{5}}$" * "\n"
    show(io, "text/markdown", 3*x)
    @test String(take!(io)) == raw"$3\sqrt{3}$" * "\n"
    show(io, "text/markdown", 2//3*y)
    @test String(take!(io)) == raw"$\frac{2}{3}\sqrt{\frac{3}{5}}$" * "\n"
end

function test_simplify()
    @test simplify(2^7 * 3^3) == (2 * 3, 2^3 * 3)
    @test simplify(exact_sqrt(3//4)) == exact_sqrt(3) / 2
    test_simplify_with_6j()
end

function test_simplify_with_6j()
    test_range = 2:1//2:4
    for j1 in test_range
    for j2 in test_range
    for j3 in test_range
    for j4 in test_range
    for j5 in test_range
    for j6 in test_range
        dj1, dj2, dj3, dj4, dj5, dj6 = Int.((2j1, 2j2, 2j3, 2j4, 2j5, 2j6))
        if check_6j(dj1, dj2, dj3, dj4, dj5, dj6)
            x = d6j(dj1,dj2,dj3,dj4,dj5,dj6)
            @test x == simplify(x)
        end
    end end end end end end
end

function stagger_sum!(sum::BigInt, cf::PFRational{T}, xs::Vector{PFRational{T}}) where T<:Integer
    MPZ.set_ui!(sum, 0)
    _copy!(cf, xs[1])
    for i in 2:length(xs)
        _gcd!(cf, xs[i])
    end
    t = zero(BigInt)
    for i in 1:length(xs)
        _div!(xs[i], cf)
        _numerator!(t, xs[i])
        if isodd(i)
            MPZ.add!(sum, t)
        else
            MPZ.sub!(sum, t)
        end
    end
end

function extract_to!(pf::PFRational{T}, num::BigInt) where T<:Integer
    (iszero(num) || isone(abs(num))) && return
    t = zero(BigInt)
    for i in eachindex(pf.e)
        r = __gmpz_tdiv_q_ui!(t, num, nth_stored_prime(i))
        while iszero(r)
            pf.e[i] += 1
            MPZ.set!(num, t)
            r = __gmpz_tdiv_q_ui!(t, num, nth_stored_prime(i))
        end
    end
    return
end

# assume `sd == rn == rd == 1`
# s * √r
function extract_sr!(sn::BigInt, sd::BigInt, rn::BigInt, rd::BigInt, pf::PFRational{T}) where T<:Integer
    for i in eachindex(pf.e)
        si, ri = divrem(pf.e[i], 2)
        if si > 0
            mul_p_pow_k!(sn, i, si)
        elseif si < 0
            mul_p_pow_k!(sd, i, -si)
        end
        if ri > 0
            MPZ.mul_ui!(rn, nth_stored_prime(i))
        elseif ri < 0
            MPZ.mul_ui!(rd, nth_stored_prime(i))
        end
    end
    return
end

# B * √A
function _pf_CG_impl!(A::PFRational{Int16}, B::BigInt, dj1::Int, dj2::Int, dj3::Int, dm1::Int, dm2::Int, dm3::Int)
    J::Int = div(dj1 + dj2 + dj3, 2)
    Jm1::Int = J - dj1
    Jm2::Int = J - dj2
    Jm3::Int = J - dj3
    j1mm1::Int = div(dj1 - dm1, 2)
    j2mm2::Int = div(dj2 - dm2, 2)
    j3mm3::Int = div(dj3 - dm3, 2)
    j2pm2::Int = div(dj2 + dm2, 2)

    Jsize::Int = max_prime_index(J + 1)
    low::Int = max(zero(Int), j1mm1 - Jm2, j2pm2 - Jm1)
    high::Int = min(Jm3, j1mm1, j2pm2)

    pf_alloc!(A, Jsize)
    if low == high
        z = low
        _copy!(A, _pf_bin(Jm3, z))
        _mul!(A, _pf_bin(Jm2, j1mm1 - z))
        _mul!(A, _pf_bin(Jm1, j2pm2 - z))
        MPZ.set_ui!(B, 1)
    else
        Bs = Vector{PFRational{Int16}}(undef, high - low + 1)
        for z in low:high
            Bs[z - low + 1] = pf_alloc(Int16, Jsize)
            _copy!(Bs[z - low + 1], _pf_bin(Jm3, z))
            _mul!(Bs[z - low + 1], _pf_bin(Jm2, j1mm1 - z))
            _mul!(Bs[z - low + 1], _pf_bin(Jm1, j2pm2 - z))
        end
        stagger_sum!(B, A, Bs)
        iszero(B) && return
        extract_to!(A, B)
    end
    square!(A)
    _mul!(A, _pf_bin(dj1, Jm2))
    _mul!(A, _pf_bin(dj2, Jm3))
    _div!(A, _pf_bin(J + 1, Jm3))
    _div!(A, _pf_bin(dj1, j1mm1))
    _div!(A, _pf_bin(dj2, j2mm2))
    _div!(A, _pf_bin(dj3, j3mm3))
    if isodd(low)
        MPZ.neg!(B)
    end
    return
end

function _pf_3j_impl!(A::PFRational{Int16}, B::BigInt, dj1::Int, dj2::Int, dj3::Int, dm1::Int, dm2::Int, dm3::Int)
    J::Int = div(dj1 + dj2 + dj3, 2)
    Jm1::Int = J - dj1
    Jm2::Int = J - dj2
    Jm3::Int = J - dj3
    j1mm1::Int = div(dj1 - dm1, 2)
    j2mm2::Int = div(dj2 - dm2, 2)
    j3mm3::Int = div(dj3 - dm3, 2)
    j1pm1::Int = div(dj1 + dm1, 2)

    Jsize::Int = max_prime_index(J + 1)
    low::Int = max(zero(Int), j1pm1 - Jm2, j2mm2 - Jm1)
    high::Int = min(Jm3, j1pm1, j2mm2)
    
    pf_alloc!(A, Jsize)
    if low == high
        z = low
        _copy!(A, _pf_bin(Jm3, z))
        _mul!(A, _pf_bin(Jm2, j1pm1 - z))
        _mul!(A, _pf_bin(Jm1, j2mm2 - z))
        MPZ.set_ui!(B, 1)
    else
        Bs = Vector{PFRational{Int16}}(undef, high - low + 1)
        for z in low:high
            Bs[z - low + 1] = pf_alloc(Int16, Jsize)
            _copy!(Bs[z - low + 1], _pf_bin(Jm3, z))
            _mul!(Bs[z - low + 1], _pf_bin(Jm2, j1pm1 - z))
            _mul!(Bs[z - low + 1], _pf_bin(Jm1, j2mm2 - z))
        end
        stagger_sum!(B, A, Bs)
        iszero(B) && return
        extract_to!(A, B)
    end
    square!(A)
    _mul!(A, _pf_bin(dj1, Jm2))
    _mul!(A, _pf_bin(dj2, Jm1))
    _div!(A, pf_int(J + 1))
    _div!(A, _pf_bin(J, Jm3))
    _div!(A, _pf_bin(dj1, j1mm1))
    _div!(A, _pf_bin(dj2, j2mm2))
    _div!(A, _pf_bin(dj3, j3mm3))
    if isodd(low + dj1 + div(dj3 + dm3, 2))
        MPZ.neg!(B)
    end
    return
end

function _pf_6j_impl!(A::PFRational{Int16}, B::BigInt, dj1::Int, dj2::Int, dj3::Int, dj4::Int, dj5::Int, dj6::Int)
    j123::Int = div(dj1 + dj2 + dj3, 2)
    j156::Int = div(dj1 + dj5 + dj6, 2)
    j426::Int = div(dj4 + dj2 + dj6, 2)
    j453::Int = div(dj4 + dj5 + dj3, 2)
    jpm123::Int = div(dj1 + dj2 - dj3, 2)
    jpm132::Int = div(dj1 + dj3 - dj2, 2)
    jpm231::Int = div(dj2 + dj3 - dj1, 2)
    jpm156::Int = div(dj1 + dj5 - dj6, 2)
    jpm426::Int = div(dj4 + dj2 - dj6, 2)
    jpm453::Int = div(dj4 + dj5 - dj3, 2)
    low::Int = max(j123, j453, j426, j156)
    high::Int = min(jpm123 + j453, jpm132 + j426, jpm231 + j156)
    Jsize::Int = max_prime_index(high + 1)
    pf_alloc!(A, Jsize)
    if low == high
        x = low
        _copy!(A, _pf_bin(x + 1, j123 + 1))
        _mul!(A, _pf_bin(jpm123, x - j453))
        _mul!(A, _pf_bin(jpm132, x - j426))
        _mul!(A, _pf_bin(jpm231, x - j156))
        MPZ.set_ui!(B, 1)
    else
        Bs = Vector{PFRational{Int16}}(undef, high - low + 1)
        for x in low:high
            Bs[x - low + 1] = pf_alloc(Int16, Jsize)
            _copy!(Bs[x - low + 1], _pf_bin(x + 1, j123 + 1))
            _mul!(Bs[x - low + 1], _pf_bin(jpm123, x - j453))
            _mul!(Bs[x - low + 1], _pf_bin(jpm132, x - j426))
            _mul!(Bs[x - low + 1], _pf_bin(jpm231, x - j156))
        end
        stagger_sum!(B, A, Bs)
        iszero(B) && return
        extract_to!(A, B)
    end
    _div!(A, pf_int(dj4 + 1))
    square!(A)
    _mul!(A, _pf_bin(j123 + 1, dj1 + 1))
    _mul!(A, _pf_bin(dj1, jpm123))
    _div!(A, _pf_bin(j156 + 1, dj1 + 1))
    _div!(A, _pf_bin(dj1, jpm156))
    _div!(A, _pf_bin(j453 + 1, dj4 + 1))
    _div!(A, _pf_bin(dj4, jpm453))
    _div!(A, _pf_bin(j426 + 1, dj4 + 1))
    _div!(A, _pf_bin(dj4, jpm426))
    if isodd(low)
        MPZ.neg!(B)
    end
    return
end

function _pf_CG(dj1::Int, dj2::Int, dj3::Int, dm1::Int, dm2::Int, dm3::Int)
    check_CG(dj1, dj2, dj3, dm1, dm2, dm3) || return zero(SqrtRational{BigInt})
    A = one(PFRational{Int16})
    sn = one(BigInt)
    _pf_CG_impl!(A, sn, dj1, dj2, dj3, dm1, dm2, dm3)
    iszero(sn) && return zero(SqrtRational{BigInt})
    sd = one(BigInt)
    rn = one(BigInt)
    rd = one(BigInt)
    extract_sr!(sn, sd, rn, rd, A)
    return SqrtRational(Base.unsafe_rational(sn, sd), Base.unsafe_rational(rn, rd))
end

function _pf_fCG(dj1::Int, dj2::Int, dj3::Int, dm1::Int, dm2::Int, dm3::Int)::Float64
    check_CG(dj1, dj2, dj3, dm1, dm2, dm3) || return zero(Float64)
    A = one(PFRational{Int16})
    sn = one(BigInt)
    _pf_CG_impl!(A, sn, dj1, dj2, dj3, dm1, dm2, dm3)
    iszero(sn) && return zero(Float64)
    sd = one(BigInt)
    rn = one(BigInt)
    rd = one(BigInt)
    extract_sr!(sn, sd, rn, rd, A)
    ans = BigFloat(sn) / BigFloat(sd) * sqrt(BigFloat(rn) / BigFloat(rd))
    return convert(Float64, ans)
end

function _pf_3j(dj1::Int, dj2::Int, dj3::Int, dm1::Int, dm2::Int, dm3::Int)
    check_3j(dj1, dj2, dj3, dm1, dm2, dm3) || return zero(SqrtRational{BigInt})
    A = one(PFRational{Int16})
    sn = one(BigInt)
    _pf_3j_impl!(A, sn, dj1, dj2, dj3, dm1, dm2, dm3)
    iszero(sn) && return zero(SqrtRational{BigInt})
    sd = one(BigInt)
    rn = one(BigInt)
    rd = one(BigInt)
    extract_sr!(sn, sd, rn, rd, A)
    return SqrtRational(Base.unsafe_rational(sn, sd), Base.unsafe_rational(rn, rd))
end

function _pf_f3j(dj1::Int, dj2::Int, dj3::Int, dm1::Int, dm2::Int, dm3::Int)::Float64
    check_3j(dj1, dj2, dj3, dm1, dm2, dm3) || return zero(Float64)
    A = one(PFRational{Int16})
    sn = one(BigInt)
    _pf_3j_impl!(A, sn, dj1, dj2, dj3, dm1, dm2, dm3)
    iszero(sn) && return zero(Float64)
    sd = one(BigInt)
    rn = one(BigInt)
    rd = one(BigInt)
    extract_sr!(sn, sd, rn, rd, A)
    ans = BigFloat(sn) / BigFloat(sd) * sqrt(BigFloat(rn) / BigFloat(rd))
    return convert(Float64, ans)
end

function _pf_CG0(j1::Int, j2::Int, j3::Int)
    check_couple(2j1, 2j2, 2j3) || return zero(SqrtRational{BigInt})
    J::Int = j1 + j2 + j3
    isodd(J) && return zero(SqrtRational{BigInt})
    g = div(J, 2)
    Jsize::Int = max_prime_index(J + 1)
    A = pf_alloc(Int16, Jsize)
    _copy!(A, _pf_bin(g, j3))
    _mul!(A, _pf_bin(j3, g - j1))
    square!(A)
    _div!(A, _pf_bin(J + 1, 2j3 + 1))
    _div!(A, _pf_bin(2j3, J - 2j1))
    sn = one(BigInt)
    if isodd(g - j3)
        MPZ.neg!(sn)
    end
    sd = one(BigInt)
    rn = one(BigInt)
    rd = one(BigInt)
    extract_sr!(sn, sd, rn, rd, A)
    return SqrtRational(Base.unsafe_rational(sn, sd), Base.unsafe_rational(rn, rd))
end

function _pf_fCG0(j1::Int, j2::Int, j3::Int)::Float64
    check_couple(2j1, 2j2, 2j3) || return zero(Float64)
    J::Int = j1 + j2 + j3
    isodd(J) && return zero(Float64)
    g = div(J, 2)
    Jsize::Int = max_prime_index(J + 1)
    A = pf_alloc(Int16, Jsize)
    _copy!(A, _pf_bin(g, j3))
    _mul!(A, _pf_bin(j3, g - j1))
    square!(A)
    _div!(A, _pf_bin(J + 1, 2j3 + 1))
    _div!(A, _pf_bin(2j3, J - 2j1))
    sn = one(BigInt)
    if isodd(g - j3)
        MPZ.neg!(sn)
    end
    sd = one(BigInt)
    rn = one(BigInt)
    rd = one(BigInt)
    extract_sr!(sn, sd, rn, rd, A)
    ans = BigFloat(sn) / BigFloat(sd) * sqrt(BigFloat(rn) / BigFloat(rd))
    return convert(Float64, ans)
end

function _pf_6j(dj1::Int, dj2::Int, dj3::Int, dj4::Int, dj5::Int, dj6::Int)
    check_6j(dj1, dj2, dj3, dj4, dj5, dj6) || return zero(SqrtRational{BigInt})
    A = one(PFRational{Int16})
    sn = one(BigInt)
    _pf_6j_impl!(A, sn, dj1, dj2, dj3, dj4, dj5, dj6)
    iszero(sn) && return zero(SqrtRational{BigInt})
    sd = one(BigInt)
    rn = one(BigInt)
    rd = one(BigInt)
    extract_sr!(sn, sd, rn, rd, A)
    return SqrtRational(Base.unsafe_rational(sn, sd), Base.unsafe_rational(rn, rd))
end

function _pf_f6j(dj1::Int, dj2::Int, dj3::Int, dj4::Int, dj5::Int, dj6::Int)::Float64
    check_6j(dj1, dj2, dj3, dj4, dj5, dj6) || return zero(Float64)
    A = one(PFRational{Int16})
    sn = one(BigInt)
    _pf_6j_impl!(A, sn, dj1, dj2, dj3, dj4, dj5, dj6)
    iszero(sn) && return zero(Float64)
    sd = one(BigInt)
    rn = one(BigInt)
    rd = one(BigInt)
    extract_sr!(sn, sd, rn, rd, A)
    ans = BigFloat(sn) / BigFloat(sd) * sqrt(BigFloat(rn) / BigFloat(rd))
    return convert(Float64, ans)
end

"""
    eCG(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer)::SqrtRational{BigInt}
Exact CG coefficient using prime factorization algorithm.
"""
@inline function eCG(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer)::SqrtRational{BigInt}
    _pf_CG(convert(Int, dj1), convert(Int, dj2), convert(Int, dj3), convert(Int, dm1), convert(Int, dm2), convert(Int, dm3))
end

"""
    efCG(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer)::Float64
Exact CG coefficient (Float64) using prime factorization algorithm.
"""
@inline function efCG(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer)::Float64
    _pf_fCG(convert(Int, dj1), convert(Int, dj2), convert(Int, dj3), convert(Int, dm1), convert(Int, dm2), convert(Int, dm3))
end

"""
    e3j(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer)::SqrtRational{BigInt}
Exact 3j symbol using prime factorization algorithm.
"""
@inline function e3j(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer)::SqrtRational{BigInt}
    _pf_3j(convert(Int, dj1), convert(Int, dj2), convert(Int, dj3), convert(Int, dm1), convert(Int, dm2), convert(Int, dm3))
end

"""
    ef3j(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer)::Float64
Exact 3j symbol (Float64) using prime factorization algorithm.
"""
@inline function ef3j(dj1::Integer, dj2::Integer, dj3::Integer, dm1::Integer, dm2::Integer, dm3::Integer)::Float64
    _pf_f3j(convert(Int, dj1), convert(Int, dj2), convert(Int, dj3), convert(Int, dm1), convert(Int, dm2), convert(Int, dm3))
end

"""
    eCG0(j1::Integer, j2::Integer, j3::Integer)::SqrtRational{BigInt}
Exact CG coefficient (`m1 = m2 = m3 = 0`) using prime factorization algorithm.
"""
@inline function eCG0(j1::Integer, j2::Integer, j3::Integer)::SqrtRational{BigInt}
    _pf_CG0(convert(Int, j1), convert(Int, j2), convert(Int, j3))
end

"""
    efCG0(j1::Integer, j2::Integer, j3::Integer)::Float64
Exact CG coefficient (`m1 = m2 = m3 = 0`) (Float64) using prime factorization algorithm.
"""
@inline function efCG0(j1::Integer, j2::Integer, j3::Integer)::Float64
    _pf_fCG0(convert(Int, j1), convert(Int, j2), convert(Int, j3))
end

"""
    e6j(j1::Integer, j2::Integer, j3::Integer, j4::Integer, j5::Integer, j6::Integer)::SqrtRational{BigInt}
Exact 6j symbol using prime factorization algorithm.
"""
@inline function e6j(j1::Integer, j2::Integer, j3::Integer, j4::Integer, j5::Integer, j6::Integer)::SqrtRational{BigInt}
    _pf_6j(convert(Int, j1), convert(Int, j2), convert(Int, j3), convert(Int, j4), convert(Int, j5), convert(Int, j6))
end

"""
    ef6j(j1::Integer, j2::Integer, j3::Integer, j4::Integer, j5::Integer, j6::Integer)::Float64
Exact 6j symbol (Float64) using prime factorization algorithm.
"""
@inline function ef6j(j1::Integer, j2::Integer, j3::Integer, j4::Integer, j5::Integer, j6::Integer)::Float64
    _pf_f6j(convert(Int, j1), convert(Int, j2), convert(Int, j3), convert(Int, j4), convert(Int, j5), convert(Int, j6))
end

# API

## Types
```@docs
SqrtRational
```

## Some useful function
```@docs
iphase
is_same_parity
check_jm
check_couple
binomial_data_size
binomial_index
check_CG
check_3j
check_6j
check_9j
check_Gaunt
check_Moshinsky
exact_sqrt
float(::SqrtRational)
simplify(::Integer)
simplify(::SqrtRational)
```

## Exact functions

The default functions give out exact result in the format of `SqrtRational`.
The results are simplified to give out shotest possible result.
Their arguments are `Real` (but only allow twice of which can be convert into integer).
```@docs
CG
CG0
threeJ
xGaunt
sixJ
nineJ
norm9J
lsjj
Racah
Moshinsky
```

People often use double of angular momentum quantum number as parameters, so we can use integer as parameters. This package also offers such functions, where the `d` letter means *double*.
These functions also give out exact `SqrtRational` results.
```@docs
dCG
d3j
d6j
d9j
dRacah
```

## float version functions

Float version functions is always used for numeric calculation. They are designed for fast calculation.
You should call `wigner_init_float` to reserve the inner **binomial table**.
They only resive `Integer` arguments, thus `fCG, f3j, f6j, fRacha, f9j` only resive arguements which are
double of the exact quantum number. In some functions, e.g. `flsjj`, some quantum number can be half-integer,
the corresponding arguments start with `d` (which mean double of the quantum number);
while some other quantum number must be integer, the corresponding arguments does not starts with `d`.
```@docs
wigner_init_float
fbinomial
unsafe_fbinomial
fCG
fCG0
fCGspin
fCG3spin
f3j
f6j
fRacah
f9j
fnorm9j
flsjj
fMoshinsky
dfunc
```

## prime factorization version

I implement a primary version of the prime factorization algorithm, based on the [wigxjpf](https://fy.chalmers.se/subatom/wigxjpf/) library.

```@docs
PFRational
gcd(::PFRational, ::PFRational)
lcm(::PFRational, ::PFRational)
wigner_init_pf
pf_binomial
eCG
eCG0
e3j
e6j
efCG
efCG0
ef3j
ef6j
```

# CG coefficient and Wigner symbols

## CG coefficient

Ref [^1], P240, Section 8.2.4, Formula (20).

```math
C_{j_1m_1j_2m_2}^{j_3m_3} = \delta_{m_3, m_1+m_2}
\left[
    \dfrac{\begin{pmatrix}2j_1 \\ J-2j_2\end{pmatrix}\begin{pmatrix}2j_2\\J-2j_3\end{pmatrix}}{\begin{pmatrix}J+1\\J-2j_3\end{pmatrix}\begin{pmatrix}2j_1\\j_1-m_1\end{pmatrix}\begin{pmatrix}2j_2 \\ j_2 - m_2\end{pmatrix}\begin{pmatrix}2j_3 \\ j_3-m_3\end{pmatrix}}
\right]^{1/2} \\
\times \sum_{z} (-1)^{z}\begin{pmatrix}J-2j_3 \\ z\end{pmatrix}\begin{pmatrix}J-2j_2 \\ j_1-m_1-z\end{pmatrix}\begin{pmatrix}J-2j_1 \\ j_2 + m_2 - z\end{pmatrix}
```

where, $J = j_1+j_2+j_3$. It is already combination of binomials.

## 3j symbol

Ref [^1], P236, Section 8.1.2, Formula (11).

```math
\begin{aligned}
\begin{pmatrix}j_1 & j_2 & j_3 \\ m_1 & m_2 & m_3\end{pmatrix} &= (-1)^{j_3+m_3+2j_1}\dfrac{1}{\sqrt{2j_3+1}}C_{j_1-m_1j_2-m_2}^{j_3m_3} \\
&= (-1)^{j_3+m_3+2j_1} \dfrac{\delta_{-m_3, m_1+m_2}}{\sqrt{J+1}} \sum_{z} (-1)^{z}\begin{pmatrix}J-2j_3 \\ z\end{pmatrix}\begin{pmatrix}J-2j_2 \\ j_1 + m_1-z\end{pmatrix}\begin{pmatrix}J-2j_1 \\ j_2 - m_2 - z\end{pmatrix} \\
&\times \left[
    \dfrac{\begin{pmatrix}2j_1 \\ J-2j_2\end{pmatrix}\begin{pmatrix}2j_2\\J-2j_3\end{pmatrix}}{\begin{pmatrix}J\\J-2j_3\end{pmatrix}\begin{pmatrix}2j_1\\j_1 - m_1\end{pmatrix}\begin{pmatrix}2j_2 \\ j_2 - m_2\end{pmatrix}\begin{pmatrix}2j_3 \\ j_3-m_3\end{pmatrix}}\right]^{1/2}.
\end{aligned}
```

## 6j symbol

Ref [^1], P293, Section 9.2.1, Formula (1).

```math
\begin{Bmatrix}j_1 & j_2 & j_3 \\ j_4 & j_5 & j_6\end{Bmatrix} = \Delta(j_1j_2j_3)\Delta(j_4j_5j_3)\Delta(j_1j_5j_6)\Delta(j_4j_2j_6) \\
\times \sum\limits_x\dfrac{(-1)^x(x+1)!}{(x-j_{123})!(x-j_{453})!(x-j_{156})!(x-j_{426})!(j_{1245}-x)!(j_{1346}-x)!(j_{2356}-x)!}
```

Here, I use $j_{123} \equiv j_1+j_2+j_3$ for simplicity. The symbol $\Delta(abc)$ is defined as

```math
\Delta(abc) = \left[\dfrac{(a+b-c)!(a-b+c)!(-a+b+c)!}{(a+b+c+1)!}\right]^{\frac{1}{2}}.
```

Move $\Delta^2(j_1j_2j_3)$ into the summation, we can find that
```math
\begin{pmatrix}j_1+j_2-j_3 \\ x - j_{453}\end{pmatrix} = \dfrac{(j_1+j_2-j_3)!}{(x-j_{453})!(j_{1245}-x)!} \\
\begin{pmatrix}j_1-j_2+j_3 \\ x - j_{426}\end{pmatrix} = \dfrac{(j_1-j_2+j_3)!}{(x-j_{426})!(j_{1346}-x)!} \\
\begin{pmatrix}j_2+j_3-j_1 \\ x - j_{156}\end{pmatrix} = \dfrac{(j_2+j_3-j_1)!}{(x-j_{156})!(j_{2356}-x)!} \\
\begin{pmatrix}x+1 \\ j_{123}+1\end{pmatrix} = \dfrac{(x+1)!}{(x-j_{123})(j_{123}+1)!}.
```

So, we have

```math
\begin{Bmatrix}j_1 & j_2 & j_3 \\ j_4 & j_5 & j_6\end{Bmatrix} = \dfrac{\Delta(j_4j_5j_3)\Delta(j_1j_5j_6)\Delta(j_4j_2j_6)}{\Delta(j_1j_2j_3)} \\
\times \sum\limits_x (-1)^x \binom{x+1}{j_{123}+1} \binom{j_1+j_2-j_3}{x - j_{453}}
\binom{j_1-j_2+j_3}{x - j_{426}}\binom{j_2+j_3-j_1}{x - j_{156}}.
```

The $\Delta(abc)$ can also be rewrite with binomials,

```math
\Delta(abc) = \left[\dfrac{1}{\begin{pmatrix}a+b+c+1 \\ 2a + 1\end{pmatrix} \begin{pmatrix}2a \\ a + b - c\end{pmatrix}(2a+1)}\right]^{\frac{1}{2}}.
```

So

```math
\dfrac{\Delta(j_4j_5j_3)\Delta(j_1j_5j_6)\Delta(j_4j_2j_6)}{\Delta(j_1j_2j_3)} \\
= \dfrac{1}{2j_4+1} \left[\dfrac{\begin{pmatrix}j_{123}+1 \\ 2j_1+1\end{pmatrix}\begin{pmatrix}2j_1 \\ j_1 + j_2 - j_3\end{pmatrix}}{\begin{pmatrix}j_{156}+1 \\ 2j_1+1\end{pmatrix}\begin{pmatrix}2j_1 \\ j_1+j_5-j_6\end{pmatrix}\begin{pmatrix}j_{453}+1\\2j_4+1\end{pmatrix}\begin{pmatrix}2j_4\\j_4+j_5-j_3\end{pmatrix}\begin{pmatrix}j_{426}+1 \\ 2j_4+1\end{pmatrix}\begin{pmatrix}2j_4 \\ j_4+j_2-j_6\end{pmatrix}}\right]^{\frac{1}{2}}
```

## Racha coefficient

Ref [^1], P291, Section 9.1.2, Formula (11)

```math
W(j_1j_2j_3j_4, j_5j_6) = (-1)^{j_1+j_2+j_3+j_4} \begin{Bmatrix}
j_1 & j_2 & j_5 \\
j_4 & j_3 & j_6
\end{Bmatrix}
```

This package uses the 6j symbol above to calculate Racha coefficient. 

## 9j symbol

Ref [^1], P340, Section 10.2.4, Formula (20)

```math
\begin{aligned}
\begin{Bmatrix}j_1 & j_2 & j_3 \\ j_4 & j_5 & j_6 \\ j_7 & j_8 & j_9\end{Bmatrix} &= \sum\limits_{t}(-1)^{2t}(2t+1)\begin{Bmatrix}j_1 & j_2 & j_3 \\ j_6 & j_9 & t\end{Bmatrix} \begin{Bmatrix}j_4 & j_5 & j_6 \\ j_2 & t & j_8\end{Bmatrix} \begin{Bmatrix}j_7 & j_8 & j_9 \\ t & j_1 & j_4\end{Bmatrix} \\
&= \sum\limits_{t}(-1)^{2t}(2t+1)\begin{Bmatrix}j_1 & j_2 & j_3 \\ j_6 & j_9 & t\end{Bmatrix} \begin{Bmatrix}j_6 & j_4 & j_5 \\ j_8 & j_2 & t\end{Bmatrix} \begin{Bmatrix}j_8 & j_9 & j_7 \\ j_1 & j_4 & t\end{Bmatrix}.
\end{aligned}
```

To obtain a better formula for calculation, we take an alternative factorization of 6j symbol
```math
\begin{Bmatrix}j_1 & j_2 & j_3 \\ j_4 & j_5 & j_6\end{Bmatrix} = \frac{\Delta(j_1j_2j_3)\Delta(j_4j_2j_6)\Delta(j_4j_5j_3)}{\Delta(j_1j_5j_6)}\sum_{x}\binom{x+1}{j_{156}+1}\binom{j_1+j_5-j_6}{x - j_{426}}\binom{j_1+j_6-j_5}{x - j_{453}}\binom{j_5+j_6-j_1}{x - j_{123}}.
```

So, we can obtain
```math
\begin{aligned}
\begin{Bmatrix}j_1 & j_2 & j_3 \\ j_4 & j_5 & j_6 \\ j_7 & j_8 & j_9\end{Bmatrix}
&= P_0  \sum_{t}(-1)^{2t}(2t+1)\left(\sum_{x}A(t,x)\right)\left(\sum_{x}B(t,y)\right)\left(\sum_{x}C(t,z)\right)
\end{aligned}
```
where
```math
\begin{aligned}
P_0 &= \Delta(j_1j_2j_3)\Delta(j_4j_5j_6)\Delta(j_7j_8j_9)\Delta(j_1j_4j_7)\Delta(j_2j_5j_8)\Delta(j_3j_6j_9), \\
A(t, x) &= (-1)^x\binom{x+1}{j_{19t}+1}\binom{j_1+j_9-t}{x - j_{26t}}\binom{j_1+t-j_9}{x - j_{369}}\binom{t+j_9-j_1}{x - j_{123}}, \\
B(t, y) &= (-1)^y\binom{y+1}{j_{26t}+1}\binom{j_6+j_2-t}{y - j_{48t}}\binom{j_6+t-j_2}{y - j_{258}}\binom{t+j_2-j_6}{y - j_{456}}, \\
C(t, z) &= (-1)^z\binom{z+1}{j_{48t}+1}\binom{j_8+j_4-t}{z - j_{19t}}\binom{j_8+t-j_4}{z - j_{147}}\binom{t+j_4-j_8}{z - j_{789}}.
\end{aligned}
```

## Estimate the capacity

Assume we are doing a calculation for a system, we will not calculate the Winger Symbols with very large angular momentum, because usually we will take some trunction. If in such truncated system, the max angular momentum is $J_{max}$, now we can estimate how many binomial coefficients we need to store to compute those Wigner Symbols.

### With maximum $J_{max}$
####  CG & 3j
According to the formula, the max possible binomial is $\begin{pmatrix} J+1 \\ J-2j_3\end{pmatrix}$, where $J = j_1+j_2+j_3$. So we need at least store binomials to $\begin{pmatrix} n_{min} \\ k\end{pmatrix}$ where
```math
n_{min} \geq 3J_{max}+1
```

#### 6j & Racha
For binomials in `sqrt`，the maximum possible $n = 3J_{max}+1$, and for those in the summation, we have to calculate the boundary of $x + 1$. According to the formula
```math
x \leq \min\{j_1+j_2+j_4+j_5, j_1+j_3+j_4+j_6, j_2+j_3+j_5+j_6\} \leq 4J_{max}
```
So we have to at least store to
```math
n_{min} \geq 4J_{max} + 1
```

#### 9j

Similarly, according to $P_0$, we need $3J_{max}+1$. According to $P(t)$,
```math
t \leq \min\{j_2 + j_6, j_4 + j_8, j_1 + j_9\} \leq 2J_{max}
```
so we need $j_1 + j_9 + t + 1 \leq 4J_{max} + 1$. According to $A(t, x),\; B(t, y),\; C(t, z)$,
```math
x \leq \min\{j_1+j_2+j_6+j_9, j_1+j_3+j_6+t, j_2+j_3+j_9+t\} \leq 5J_{max}
```
so we need to at least store to
```math
n_{min} \geq 5J_{max} + 1
```

### With maximum single particle $j_{max}$

Considering a quantum many body calculation, we can get a more optimistic estimation of the calculation capacity. In a quantum many body calculation, we often truncate single particle orbits, and in this condition we assume that we only need to consider two-body coupled angular momentum.

The maximum angular momentum of the single particle orbits defined as $j_{max}$. If for each function, there are at least one of the parameters is single particle angular momentum, then we can get the following estimation.

#### CG & 3j

In this condition, the $j_1, j_2, j_3$ contains two single particle angular momentum, and the rest one is a coupled two body angular momentum. So
```math
n_{min} \geq 4j_{max} + 1
```

#### 6j & Racha

Similarly
```math
x \leq \min\{j_1+j_2+j_4+j_5, j_1+j_3+j_4+j_6, j_2+j_3+j_5+j_6\}
```
These summations of four angular momentum can be split into two kinds, all single particle angular momentum, and two single particle with two two body angular momentum. Consider the worst condition
```math
n_{min} \geq 6j_{max} + 1
```

### 9j

We assume the 9j symbol contains at least one single particle angular momentum, then according to the coupling rules, the 9j symbol can be split into kinds
```math
\begin{Bmatrix}
1 & 1 & 2 \\
1 & 1 & 2 \\
2 & 2 & 2
\end{Bmatrix}
\quad
\begin{Bmatrix}
1 & 1 & 2 \\
1 & 2 & 1 \\
2 & 1 & 1
\end{Bmatrix}
```
where $1$ represents single particle and $2$ for two body angular momentum.
In both cases, we can deduce that
```math
n_{min} \geq 8j_{max} + 1
```

----
Reference

[^1]: A. N. Moskalev D. A. Varshalovich and V. K. Khersonskii, *Quantum theory of angular momentum*.

# Home

A package to calculate CG-coefficient, Racha coefficient, and Wigner 3j, 6j, 9j symbols. We offer two versions of API for all these coefficients.

1. The exact functions return `SqrtRational`, which are designed for demonstration. They use `BigInt` in the internal calculation, and do not cache the binomial table, so they are not efficient.
2. The floating-point functions return `Float64`, which are designed for numeric calculation. They use `Int, Float64` in the internal calculation, and you should pre-call [`wigner_init_float`](@ref) to calculate and cache the binomial table for later calculation. They may give inaccurate result for vary large angular momentum, due to floating-point arithmetic. You can find the max error at here: [wigner-benchmark](https://github.com/0382/wigner-benchmark).

## Install

Just install with Julia REPL and enjoy it.

```julia-repl
pkg> add CGcoefficient
```

## Usage

```@setup example
push!(LOAD_PATH, "../../src/") # hide
```
```@example example
using CGcoefficient
sixJ(1,2,3,4,5,6)
```
In a markdown enviroment, such as jupyter notebook, it will give you a latex output.
You can also do some arithmetics with the result, thus do arithmetics using the `SqrtRational` type.
```@example example
x = sixJ(1,2,3,4,5,6) * exact_sqrt(1//7) * exact_sqrt(1//13) * iphase(2+3+5+6)
```

The result is not simplified by default, you can use `simplify` function to simplify it.
```@example example
simplify(x)
```

In a console enviroment it will give out a text output.
```@repl example
nineJ(1,2,3,5,4,3,6,6,0)
```

You can convert a `SqrtRational` in to `BigFloat`,
```@example example
t = sixJ(17/2,9,19/2,15/2,10,15/2)
float(t)
```

Calling `wigner_init_float` first to pre-calculate and cache binomial table.
```@example example
wigner_init_float(10, "Jmax", 6)
```
Then call a float version function
```@example example
f6j(17,18,19,15,20,15)
```

## About

This package is inspired by Ref [^1]. See [CENS-MBPT](https://github.com/ManyBodyPhysics/CENS/blob/master/MBPT/VEffective/bhf-modules.f90) for details.

The idea is to simplify 3nj Symbols to sum combinations of binomial coefficients. We can calculate binomial coefficients by Pascal's Triangle, and store them first. Then we calculate 3nj Symbols using the stored binomial coefficients.

In this package, we just use the builtin `binomial` function for exact calculation. Only the float version uses stored `binomial`s.

[^1]: T. Engeland and M. Hjorth-Jensen, the Oslo-FCI code. [https://github.com/ManyBodyPhysics/CENS](https://github.com/ManyBodyPhysics/CENS).

# Prime Factorization representation of Rational

For any positive integer $N \in \mathbb{Z}^+$, it have a unique prime factorization representation
```math
N = \prod_{i}p_i^{e_i},
```
where $i = 1, 2, \dots, \infty$, $p_i$ are primes, and $e_i \ge 0$. Actually, if we modify this theorem a little, we have the prime factorization representation of rationals:

For any positive rational $q \in \mathbb{Q}^+$, it have a unique representation
```math
q = \prod_{i}p_i^{e_i},
```
where $i = 1, 2, \dots, \infty$ and $e_i \in \mathbb{N}$ can be positve, negative or zero.

Using this representation, we can quickly evaluate $q_1 \cdot q_2$ and $q_1 / q_2$:
```math
q_1 = \prod_{i}p_i^{e_i(1)}, \quad q_2 = \prod_{i}p_i^{e_i(2)}, \\
```
```math
q_1\cdot q_2 = \prod_{i}p_i^{e_i(1)+e_i(2)}, \quad q_1\cdot q_2 = \prod_{i}p_i^{e_i(1)-e_i(2)}.
```

We can also define
```math
\mathrm{gcd}(q_1, q_2) = \prod_{i}p_i^{\min\{e_i(1), e_i(2)\}}, \quad \mathrm{lcm}(q_1, q_2) = \prod_{i}p_i^{\max\{e_i(1),e_i(2)\}}
```

The prime factorization representation is very suitable for computing the factorial $n!$ and binomial $\tbinom{n}{m}$. If we known the maximum $n$ in all of the calculations, then the maximum $p_i$ needed in the calculation satisfy $p_i \le n \lt p_{i+1}$.

However, in our calculation of Wigner-3nj symbols, we need calculate some addition and subtraction of the numbers.
Considering to calculate $q_1 + q_2 - q_3$, we should first calculate
```math
q_g = gcd(q_1, q_2, q_3).
```
Then $q_1/q_g, q_2/q_g, q_3/q_g$ become integers. Next, we convert them into `BigInt` and do addition and subtraction.

## The maximum exponent

To convert the prime factorization representation of Rational into `Rational{BigInt}`, we need to store the pow table of primes to quickly obtain the result of $p_i^{e_i}$.

[Legendre's formula](https://en.wikipedia.org/wiki/Legendre%27s_formula): For any prime number $p$ and any positive integer $n$, let $\nu_{p}(n)$ be the exponent of the largest power of $p$ that divides $n$ (that is, the $p$-adic valuation of $n$). Then
```math
\nu _{p}(n!)=\sum _{i=1}^{\infty }\left\lfloor {\frac {n}{p^{i}}}\right\rfloor
```

[Kummer's Theorem](https://en.wikipedia.org/wiki/Kummer%27s_theorem): For given integers $n \ge m \ge 0$ and a prime number $p$, the p-adic valuation $\nu_{p}\!{\tbinom{n}{m}}$ of the binomial coefficient $\tbinom{n}{m}$ is equal to the number of carries when m is added to n − m in base p.

If we use factorial, then for $p^a \le n \lt p^{a-1}$, we have
```math
\nu_p(n!) = 1+p+p^2+\cdots +p^{a-1} = \frac{p^a-1}{p-1}
```
For $n = p^a, p = 2$, the maximum exponent needed is $n - 1$.

If we use the binomial, we have
```math
\sup_{0\le k\le n} \nu_p(C_n^k) \le \lfloor log_p n \rfloor,
```
because the number of carries is never larger than the number of digits of the number $n$ in base $p$.

For $n = p^a, p = 2$, the maximum exponent needed is $\lfloor log_2 n \rfloor$.

# Moshinsky

The Talmi-Moshinsky braket can be evaluated as following [^1]:
```math
\begin{aligned}
    &\langle n_3l_3,n_4l_4;\Lambda|n_1l_1,n_2l_2;\Lambda\rangle = \prod_{k=1}^4 i^{-l_k} \sqrt{\dfrac{n_k![2(n_k+l_k)+1]!!}{\sqrt{2^{l_k}}}} \\
    \times &\sum_{n_an_bn_cn_dl_a l_b l_c l_d} \Bigg[(-1)^{l_d} (\sin\beta)^{2n_a + l_a + 2n_d + l_d}(\cos\beta)^{2n_b+l_b + 2n_c + l_c} \begin{Bmatrix}l_a & l_b & l_1 \\ l_c & l_d & l_2 \\ l_3 & l_4 & \Lambda \end{Bmatrix} \\ 
    \times & C_{l_a0l_b0}^{l_10} C_{l_a0l_c0}^{l_30} C_{l_b0l_d0}^{l_40} C_{l_c0l_d0}^{l_20} \prod_{p = a}^{d} \dfrac{(-1)^{l_p}\sqrt{2^{l_p}}(2l_p+1)}{n_p![2(n_p+l_p) + 1]!!} \Bigg].
\end{aligned}
```
where
```math
\begin{aligned}
    2n_a + l_a + 2n_b + l_b = 2n_1 + l_1 \equiv e_1, \\
    2n_a + l_a + 2n_c + l_c = 2n_3 + l_3 \equiv e_3, \\
    2n_b + l_b + 2n_d + l_d = 2n_4 + l_4 \equiv e_4, \\
    2n_c + l_c + 2n_d + l_d = 2n_2 + l_2 \equiv e_2.
\end{aligned}
```

Here we define $\chi = e_1 + e_2 = e_3 + e_4$。

Similar as Wigner symbols, we try to rewrite it as binomials. First, we have:
```math
    (2k+1)!! = \dfrac{(2k+1)!}{(2k)!!} = \dfrac{(2k+1)!}{2^k k!}.
```
We can rewrite the following term:
```math
\begin{aligned}
    t_p &\equiv \dfrac{(-1)^{l_p}\sqrt{2^{l_p}}(2l_p+1)}{n_p![2(n_p+l_p) + 1]!!} \\
        &= \dfrac{(-1)^{l_p}\sqrt{2^{l_p}}(2l_p+1)2^{n_p+l_p}}{(2n_p+l_p+1)!}\begin{pmatrix}2n_p+l_p+1 \\ n_p\end{pmatrix} \begin{pmatrix}2(n_p+l_p)+1 \\ n_p + l_p\end{pmatrix}^{-1}.
\end{aligned}
```
Similiarly,
```math
\begin{aligned}
    r_k &\equiv \dfrac{n_k![2(n_k+l_k)+1]!!}{\sqrt{2^l_k}} \\
        &= \dfrac{(2n_k+l_k+2)!}{\sqrt{2^{l_k}}2^{n_k+l_k}(n_k+l_k+2)}\begin{pmatrix}2(n_k+l_k)+1 \\ n_k + l_k\end{pmatrix}\begin{pmatrix}2n_k+l_k+2 \\ n_k\end{pmatrix}^{-1}.
\end{aligned}
```
Next,
```math
\begin{aligned}
    t &\equiv \dfrac{\prod_{k=1}^4 \sqrt{(2n_k+l_k+2)!}}{\prod_{p=a}^d (2n_p+l_p + 1)!} \\
    &= \sqrt{\begin{pmatrix}2n_1+l_1+2 \\ 2n_a + l_a + 1\end{pmatrix}\begin{pmatrix}2n_2 + l_2 + 2 \\ 2n_c + l_c + 1\end{pmatrix} \begin{pmatrix}2n_3 + l_3 + 2 \\ 2n_a + l_a + 1\end{pmatrix}\begin{pmatrix}2n_4 + l_4 + 2 \\ 2n_b + l_b + 1\end{pmatrix}}
\end{aligned}
```

In the prod of $t_p$, there is
```math
    \prod_{p=a}^{d} \sqrt{2^{l_p}}2^{n_p+l_p} = \prod_{p=a}^d 2^{\frac{2n_p+l_p}{2}} 2^{l_p} = 2^{\chi/2} \prod_{p=a}^{d} 2^{l_p}.
```
In the pord of $r_k$, there is
```math
    \sqrt{\prod_{k=1}^4 \dfrac{1}{\sqrt{2^{l_k}}2^{n_k+l_k}}} = 2^{-\chi/2} \prod_{k=1}^4 2^{-l_k/2}
```

Finally, we have
```math
\begin{aligned}
    &\langle n_3l_3,n_4l_4;\Lambda|n_1l_1,n_2l_2;\Lambda\rangle\\
    = &\prod_{k=1}^4 i^{-l_k} \sqrt{\dfrac{1}{2^{l_k}(n_k+l_k+2)}\begin{pmatrix}2(n_k+l_k)+1 \\ n_k + l_k\end{pmatrix}\begin{pmatrix}2n_k+l_k+2 \\ n_k\end{pmatrix}^{-1}} \\
    \times & \sum_{n_an_bn_cn_dl_a l_b l_c l_d} \Bigg[(-1)^{l_d} (\sin\beta)^{2n_a + l_a + 2n_d + l_d}(\cos\beta)^{2n_b+l_b + 2n_c + l_c} \begin{Bmatrix}l_a & l_b & l_1 \\ l_c & l_d & l_2 \\ l_3 & l_4 & \Lambda \end{Bmatrix} \\
    \times & \sqrt{\begin{pmatrix}2n_1+l_1+2 \\ 2n_a + l_a + 1\end{pmatrix}\begin{pmatrix}2n_2 + l_2 + 2 \\ 2n_c + l_c + 1\end{pmatrix} \begin{pmatrix}2n_3 + l_3 + 2 \\ 2n_a + l_a + 1\end{pmatrix}\begin{pmatrix}2n_4 + l_4 + 2 \\ 2n_b + l_b + 1\end{pmatrix}} \\
    \times & C_{l_a0l_b0}^{l_10} C_{l_a0l_c0}^{l_30} C_{l_b0l_d0}^{l_40} C_{l_c0l_d0}^{l_20} \prod_{p=a}^d (-1)^{l_p}2^{l_p}(2l_p+1)\begin{pmatrix}2n_p+l_p+1 \\ n_p\end{pmatrix} \begin{pmatrix}2(n_p+l_p)+1 \\ n_p + l_p\end{pmatrix}^{-1} \Bigg]
\end{aligned}
```

Consider $m_1 = m_2,\;\omega_1 = \omega_2$, thus $\tan\beta = 1, \; \cos\beta = \sin\beta = 1/\sqrt{2}$, then
```math
\begin{aligned}
    (\sin\beta)^{2n_a + l_a + 2n_d + l_d}(\cos\beta)^{2n_b+l_b + 2n_c + l_c} &= 2^{-\frac{2n_a + l_a + 2n_b + l_b + 2n_c + l_c + 2n_d + l_d}{2}} \\
    &= 2^{-\frac{e_1+e_2}{2}} \\
    &= 2^{-\chi/2}
\end{aligned}
```

## Exact evaluation

Still start from the origin equation, define
```math
X_{abcd} = \left(\prod_{k=1}^4 i^{-l_k}\right)\left(\prod_{p = a}^d (-1)^{l_p}\right)\begin{Bmatrix}l_a & l_b & l_1 \\ l_c & l_d & l_2 \\ l_3 & l_4 & \Lambda \end{Bmatrix} C_{l_a0l_b0}^{l_10} C_{l_a0l_c0}^{l_30} C_{l_b0l_d0}^{l_40} C_{l_c0l_d0}^{l_20}.
```

According to Ref [^2], P251, Sec 8.5.2, Formula(32).
```math
C^{c0}_{a0b0} = \begin{cases}
0, & a + b + c = 2g + 1, \\
\dfrac{(-1)^{g-c}\hat{c}g!}{(g-a)!(g-b)!(g-c)!}\Delta(abc), & a +b +c = 2g.
\end{cases}
```
Define
```math
\Omega(abc) \equiv \dfrac{g!}{(g-a)!(g-b)!(g-c)!} = \frac{1}{(g+1)\Delta^2(\frac{a}{2}\frac{b}{2}\frac{c}{2})} = \binom{g}{c}\binom{c}{g-a}.
```
It is obvious a integer. Then
```math
X_{abcd} = (-1)^{f_x}\hat{l}_1\hat{l}_2\hat{l}_3\hat{l}_4\Omega(l_al_bl_1)\Delta(l_al_bl_1)\Omega(l_al_cl_3)\Delta(l_al_cl_3)\Omega(l_bl_dl_4)\Delta(l_bl_dl_4)\Omega(l_cl_dl_2)\Delta(l_cl_dl_2)\begin{Bmatrix}l_a & l_b & l_1 \\ l_c & l_d & l_2 \\ l_3 & l_4 & \Lambda \end{Bmatrix},
```
where
```math
\begin{aligned}
f_x &= -\frac{l_1+l_2+l_3+l_4}{2} + l_a+l_b+l_c+l_d + \dfrac{l_a+l_b-l_1}{2} + \dfrac{l_c+l_d-l_2}{2} + \dfrac{l_a+l_c-l_3}{2} + \dfrac{l_b+l_d-l_4}{2} \\
&= 2(l_a+l_b+l_c+l_d) - (l_1+l_2+l_3+l_4).
\end{aligned}
```
It is easy to prove that $l_1+l_2+l_3+l_4$ is even, so the phase factor $(-1)^{f_x}$ is $1$. In the Wigner symbols section, we have obtain
```math
\begin{Bmatrix}l_a & l_b & l_1 \\ l_c & l_d & l_2 \\ l_3 & l_4 & \Lambda \end{Bmatrix} = P_0\sum_t (-1)^{2t}(2t+1) \left(\sum_x A(t,x)\right) \left(\sum_y B(t,y)\right) \left(\sum_z C(t,z)\right).
```
Where, $A(t,x), B(t,y), C(t,z)$ are all integers, and
```math
P_0 = \Delta(l_al_bl_1)\Delta(l_cl_dl_2)\Delta(l_al_cl_3)\Delta(l_bl_dl_4)\Delta(l_1l_2\Lambda)\Delta(l_3l_4\Lambda).
```
So
```math
\begin{aligned}
X_{abcd} &= \hat{l}_1\hat{l}_2\hat{l}_3\hat{l}_4 \Omega(l_al_bl_1)\Omega(l_al_cl_3)\Omega(l_bl_dl_4)\Omega(l_cl_dl_2) \\
&\times \Delta^2(l_al_bl_1)\Delta^2(l_al_cl_3)\Delta^2(l_bl_dl_4)\Delta^2(l_cl_dl_2)\Delta(l_1l_2\Lambda)\Delta(l_3l_4\Lambda) \\
&\times\sum_t \hat{t}^2 \left(\sum_x A(t,x)\right) \left(\sum_y B(t,y)\right) \left(\sum_z C(t,z)\right).
\end{aligned}
```
In this formula, the only sqrt occurs in
```math
\hat{l}_1\hat{l}_2\hat{l}_3\hat{l}_4\Delta(l_1l_2\Lambda)\Delta(l_3l_4\Lambda),
```
which is only related to $l_1,l_2,l_3,l_4,\Lambda$, so can be taken out of the summation. If we only deal with $\tan\beta = 1$,
that's $(\sin\beta)^{2n_a + l_a + 2n_d + l_d}(\cos\beta)^{2n_b+l_b + 2n_c + l_c} = 2^{-\chi/2}$,
then the Moshinsky braket is a square root of a rational.

Define
```math
\begin{aligned}
M_{9j}(l_al_bl_cl_dl_1l_2l_3l_4\Lambda) &= \Omega(l_al_bl_1)\Omega(l_al_cl_3)\Omega(l_bl_dl_4)\Omega(l_cl_dl_2) \\
&\times \Delta^2(l_al_bl_1)\Delta^2(l_al_cl_3)\Delta^2(l_bl_dl_4)\Delta^2(l_cl_dl_2) \\
&\times \sum_t \hat{t}^2 \left(\sum_x A(t,x)\right) \left(\sum_y B(t,y)\right) \left(\sum_z C(t,z)\right).
\end{aligned}
```
With some simplification, we can write down the Moshinsky as follows:
```math
\begin{aligned}
&\langle n_3l_3,n_4l_4;\Lambda|n_1l_1,n_2l_2;\Lambda\rangle\\
= &\sqrt{\frac{\binom{\chi+2}{e_1+1}}{\binom{\chi+2}{e_3+1}\binom{l_1+l_2+\Lambda+1}{2\Lambda+1}\binom{2\Lambda}{\Lambda+l_1-l_2}\binom{l_3+l_4+\Lambda+1}{2\Lambda+1}\binom{2\Lambda}{\Lambda + l_3-l_4}}} \\
&\times\frac{1}{(e_1+2)(e_2+2)(2\Lambda+1)}\prod_{k=1}^4 \sqrt{\frac{(2l_k+1)\binom{e_k+l_k+1}{n_k+l_k}}{2^{l_k}\binom{e_k+1}{n_k}}} \\
&\times \sum_{n_an_bn_cn_dl_a l_b l_c l_d} \Bigg[(-1)^{l_d} (\sin\beta)^{e_a+e_d}(\cos\beta)^{e_b+e_c} M_{9j}(l_al_bl_cl_dl_1l_2l_3l_4\Lambda) \\
&\times \binom{e_1+2}{e_a+1}\binom{e_2+2}{e_c+1}  \prod_{p=a}^d 2^{l_p} (2l_p+1) \frac{\binom{e_p+1}{n_p}}{\binom{e_p+l_p+1}{n_p+l_p}}\Bigg]
\end{aligned}
```

Finally, if $\tan\beta = (m_1\omega_1/m_2\omega_2)^{1/2} = \sqrt{D}$ is a square root of rational, then
```math
\begin{aligned}
    (\sin\beta)^{e_a+e_d}(\cos\beta)^{e_b+e_c} &= (\sin\beta)^{e_4-e_1}(\cos\beta)^{e_1+e_3}(\tan\beta)^{2e_a} \\
    &= \frac{\sqrt{D}^{e_4-e_1}}{\sqrt{1+D}^{e_3+e_4}} D^{e_a},
\end{aligned}
```
where the $\frac{\sqrt{R}^{e_4-e_1}}{\sqrt{1+R}^{e_3+e_4}}$ can be taken aout from the summation. Espicially, when $D = 1$, we have
```math
    (\sin\beta)^{e_a+e_d}(\cos\beta)^{e_b+e_c} = 2^{-\frac{e_1+e_2}{2}}.
```

In summary, we prove that if $D = (m_1\omega_1)/(m_2\omega_2)$ is a rational, then the Moshinsky bracket can be expressed as a square root of a rational.

---

[^1]: Buck et al. Nuc. Phys. A 600 (1996) 387-402.
[^2]: A. N. Moskalev D. A. Varshalovich and V. K. Khersonskii, *Quantum theory of angular momentum*.
